package com.tyson.controller;

import com.tyson.util.CusutUtil;
import com.tyson.util.HttpUtil;
import com.tyson.util.dingUtil;
//import lombok.extern.slf4j.Slf4j;
import com.tyson.vo.DeductionVo;
import lombok.extern.slf4j.Slf4j;
import org.json.JSONArray;
import org.json.JSONObject;
//import org.slf4j.Logger;
//import org.slf4j.LoggerFactory;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.scheduling.annotation.Async;
import org.springframework.stereotype.Component;
import org.springframework.web.bind.annotation.GetMapping;

import java.math.BigDecimal;
import java.math.RoundingMode;
import java.text.DecimalFormat;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.time.Instant;
import java.time.LocalDate;
import java.time.LocalDateTime;
import java.time.ZoneId;
import java.util.*;
import java.util.stream.Collectors;

/**
 * Decription:
 *
 * @author hzk
 * @Date 2022/9/9 11:37
 */
@Component
@Slf4j
public class AsyncController {
    private static final Logger logger = LoggerFactory.getLogger(AsyncController.class);
    //    private static final Logger logger = LoggerFactory.getLogger(AsyncController.class);

    //    @Autowired
    //    private YiDaController yidaController;
    @Autowired
    private dingUtil dingUtil;

    @Autowired
    private com.tyson.consts.dingConst dingConst;
    //测试 //
    //String QA_sapUrl = "https://etl-nonprod-tasks.cloud.tyson.com:443/api/1/rest/feed/run/task/TysonNonProd/Ultra_PoC/20-PREPROD-team-fssc/tk_oa_to_sap_p2p?bearer_token=bBiGTA7PS0JJ6wKhQU8Vm0vLsIDNjLaN&interface_id=";
    String QA_sapUrl = "https://etl-nonprod-tasks.tysondt.com:443/api/1/rest/feed/run/task/TysonNonProd/Ultra_PoC/10-QA-team-fssc/tk_oa_to_sap_p2p?bearer_token=bBiGTA7PS0JJ6wKhQU8Vm0vLsIDNjLaN&interface_id=";

    //预生产  //String sapUrl = "https://etl-nonprod-tasks.cloud.tyson.com:bookeepflag443/api/1/rest/feed/run/task/TysonNonProd/Ultra_PoC/20-PREPROD-team-fssc/tk_sap_to_oa_p2p?bearer_token=C6h3CFJqgxT3KNTmX4JIcSdPx2Cfxz1J";
    //生产0403
    String sapUrl = "https://etl-prod-tasks.tysondt.com:443/api/1/rest/feed/run/task/TysonProd/Ultraprojects/team-fssc/tk_oa_to_sap_p2p?bearer_token=bBiGTA7PS0JJ6wKhQU8Vm0vLsIDNjLaN&interface_id=";
    //测试
    //String sapUrl = "https://elastic.snaplogic.com/api/1/rest/slsched/feed/TysonNonProd/Ultra_PoC/10-QA-team-fssc/tk_oa_to_sap_p2p?bearer_token=bBiGTA7PS0JJ6wKhQU8Vm0vLsIDNjLaN&interface_id=";
    //String sapUrl = "https://etl-nonprod-tasks.tysondt.com:443/api/1/rest/feed/run/task/TysonNonProd/Ultra_PoC/10-QA-team-fssc/tk_oa_to_sap_p2p?bearer_token=bBiGTA7PS0JJ6wKhQU8Vm0vLsIDNjLaN&interface_id=";
    boolean istest = false;


    /***
     * PO生成 凭证
     * @return
     */
    @Async
    public void POCreatePZ(String id, String name) {
        try {
            Thread.sleep(3000);
            JSONObject upJson = new JSONObject();
            String start_time = CusutUtil.getNowDate("yyyyMMdd");


            System.out.println(name);
            logger.info(name);
            JSONObject object = new JSONObject(dingUtil.getYidaById(id));

            if (object.has("dateField_lmocg0vi") && !object.get("dateField_lmocg0vi").toString().equals("")) {
                start_time = CusutUtil.getFormatDate(object.getLong("dateField_lmocg0vi"));
            }

            JSONObject sapJson = new JSONObject();
            if ("".equals(object.getString("textField_l7a342k7"))) {
                JSONObject obj = new JSONObject();
                obj.put("textField_l9qg8a8n", object.get("textField_l7a7xqg2"));
                JSONArray data = new JSONArray(dingUtil.yiDaSearch("FORM-WC9666911ZP308OTCINEF5VM2HKC2HI42GQ9LG7", obj));
                String str = (100000 + data.length()) + "";
                if (data.length() > 0) {
                    str = (100000 + data.getJSONObject(0).getJSONObject("formData").getInt("numberField_l9qnm4yt") + 1) + "";
                    obj.put("numberField_l9qnm4yt", data.getJSONObject(0).getJSONObject("formData").getInt("numberField_l9qnm4yt") + 1);
                    logger.info(" YiDa Update : " + data.getJSONObject(0).getString("formInstanceId") + " => " + obj.toString());
                    dingUtil.UpdateYiDa(data.getJSONObject(0).getString("formInstanceId"), obj);
                } else {
                    obj.put("numberField_l9qnm4yt", 1);

                    String res = dingUtil.saveYiDa("FORM-WC9666911ZP308OTCINEF5VM2HKC2HI42GQ9LG7", obj, dingConst.getUserId());
                    logger.info("YiDa Return Data :" + res);
                }
                object.remove("textField_l7a342k7");
                object.put("textField_l7a342k7", object.getString("textField_l7a7xqg2") + str.substring(1, str.length()));
                upJson.put("textField_l7a342k7", object.get("textField_l7a342k7"));
            }
            while (true) {
                JSONObject cobj = new JSONObject();
                cobj.put("textField_l7a342k7", object.get("textField_l7a342k7"));
                JSONArray cdata = new JSONArray(dingUtil.yiDaSearch("FORM-GC9664C1ALL2G3G5D6ZGNCYLX1FF2DG29TB6LQ", cobj));
                if (cdata.length() > 0) {
                    JSONObject obj = new JSONObject();
                    obj.put("textField_l9qg8a8n", object.get("textField_l7a7xqg2"));
                    JSONArray data = new JSONArray(dingUtil.yiDaSearch("FORM-WC9666911ZP308OTCINEF5VM2HKC2HI42GQ9LG7", obj));
                    String str = (100000 + data.length()) + "";
                    if (data.length() > 0) {
                        str = (100000 + data.getJSONObject(0).getJSONObject("formData").getInt("numberField_l9qnm4yt") + 1) + "";
                        obj.put("numberField_l9qnm4yt", data.getJSONObject(0).getJSONObject("formData").getInt("numberField_l9qnm4yt") + 1);
                        logger.info(" YiDa Update : " + data.getJSONObject(0).getString("formInstanceId") + " => " + obj.toString());
                        dingUtil.UpdateYiDa(data.getJSONObject(0).getString("formInstanceId"), obj);

                    } else {
                        obj.put("numberField_l9qnm4yt", 1);
                        String res = dingUtil.saveYiDa("FORM-WC9666911ZP308OTCINEF5VM2HKC2HI42GQ9LG7", obj, dingConst.getUserId());
                        logger.info("YiDa Return Data :" + res);
                    }
                    object.remove("textField_l7a342k7");
                    object.put("textField_l7a342k7", object.getString("textField_l7a7xqg2") + str.substring(1, str.length()));
                    upJson.put("textField_l7a342k7", object.get("textField_l7a342k7"));
                } else {
                    break;
                }
            }
            //
            sapJson.put("ZOA_NUMBER", object.get("textField_l7a342k7"));  //OA单据号
            if (object.get("selectField_l6btftfn").toString().equals("抵账后付款") || object.get("selectField_l6btftfn").toString().contains("预付") && !object.get("selectField_l6btftfn").toString().equals("清预付款(无需支付)") || object.get("selectField_l6btftfn").toString().contains("进度")) {
                sapJson.put("ZOA_TYPE", "AD");  //OA单据类型
                sapJson.put("UMSKZ", object.get("textField_l8jxzrmy")); //特别总帐标识
                if (object.get("selectField_l6btftfn").toString().contains("进度")) {
                    sapJson.put("ZINVOICE_AMT", object.get("numberField_l6czvx0g").toString());       //发票总额
                } else {
                    sapJson.put("ZINVOICE_AMT", "0");
                }
                sapJson.put("BLART", "Z4");      //凭证类型
            } else {
                sapJson.put("ZOA_TYPE", "PO");  //OA单据类型
                sapJson.put("ZINVOICE_AMT", object.get("numberField_l6czvx0w").toString());       //发票总额
                sapJson.put("BLART", "Z2");      //凭证类型
            }

            if (object.get("selectField_l6btftfn").toString().equals("无发票")) {
                sapJson.put("ZOA_TYPE", "AD");  //OA单据类型
                sapJson.put("UMSKZ", object.get("textField_l8jxzrmy")); //特别总帐标识
                sapJson.put("BLART", "Z4");      //凭证类型
            }

            sapJson.put("GJAHR", object.get("textField_l6x1rkjh"));          //会计年度
            sapJson.put("ZFUND", object.get("selectField_l6btftfn"));       //付款类型
            sapJson.put("BUKRS", object.get("textField_l6c19doa"));       //公司代码
            sapJson.put("BELNR", object.get("textField_l6czvx07"));       //系统发票号

            sapJson.put("WAERS", object.get("selectField_l6dcaibv"));       //币种
            sapJson.put("BLDAT", start_time);       //凭证日期

            if (object.has("dateField_lkuwhiwi") && !object.get("dateField_lkuwhiwi").equals("")) {
                try {
                    start_time = CusutUtil.getFormatDate(object.getLong("dateField_lkuwhiwi"));
                } catch (Exception exception) {

                }
            }

            sapJson.put("BUDAT", start_time);       //过账日期
            sapJson.put("BKTXT", "测试文本");       //抬头文本
            String uid = "TEST-CN001";
            JSONArray gzhangr = new JSONArray(name);
            if (gzhangr.length() > 0) {
                //textField_l6dddg5k
                JSONObject obj = new JSONObject();
                obj.put("textField_l6dddg5k", gzhangr.get(0));
                JSONArray data = new JSONArray(dingUtil.yiDaSearch("FORM-4J7669A10FO250UJ9C6Q7CM00PC62YPW8DD6LT", obj));
                JSONObject formData = data.getJSONObject(0).getJSONObject("formData");
                uid = formData.get("textField_l6djch1m").toString();
                uid = "CHN-0" + uid;
            }
            String ZLSPR = object.getString("selectField_l6btftfp");
            if (ZLSPR.contains("承兑")) {
                ZLSPR = "B";
            } else if (ZLSPR.contains("支票")) {
                ZLSPR = "C";
            } else if (ZLSPR.contains("信用证")) {
                ZLSPR = "L";
            } else if (ZLSPR.contains("银行托收")) {
                ZLSPR = "T";
            } else if (ZLSPR.contains("其他")) {
                ZLSPR = "O";
            } else {
                ZLSPR = "";
            }

            if (object.get("selectField_l6btftfn").toString().contains("进度")) {
                ZLSPR = "A";
            }


            if (!"".equals(ZLSPR)) {
                sapJson.put("ZLSPR", ZLSPR);//付款方式
            }
            if (istest) {
                uid = "CHN-01307786";
                sapUrl = "https://etl-nonprod-tasks.cloud.tyson.com:443/api/1/rest/feed/run/task/TysonNonProd/Ultra_PoC/00-STG-team-fssc/tk_oa_to_sap_p2p?bearer_token=bBiGTA7PS0JJ6wKhQU8Vm0vLsIDNjLaN&interface_id=";
            }
            sapJson.put("USNAM", uid);       //过账人
            sapJson.put("ZPAY_AMT", object.get("numberField_l6czvx0w").toString());       //支付金额
            sapJson.put("LIFNR", object.get("textField_l6btfthp"));       //供应商代码
            sapJson.put("KOINH", object.get("textField_l6c19doc"));       //收款方名称
            sapJson.put("BANKN", object.get("textField_l6btftfu"));       //银行账号
            sapJson.put("BANKA", object.get("textField_l6btftfv"));       //开户行
            if (object.has("dateField_l6btftfo") || object.get("dateField_l6btftfo").equals("")) {
                sapJson.put("ZDUEDATE", start_time);
            } else {
                sapJson.put("ZDUEDATE", CusutUtil.getFormatDate(object.getLong("dateField_l6btftfo")));       //到期日
            }

            JSONArray SapItem = new JSONArray();       //子表

            JSONArray tableField_l6btfti5 = object.getJSONArray("tableField_l6btfti5");

            JSONArray objects = new JSONArray();
            double numberField_l6x1rkjm = 0;
            double numberField_l7sowiqy = 0;
            for (int i = 0; i < tableField_l6btfti5.length(); i++) {
                JSONObject jsonObject = tableField_l6btfti5.getJSONObject(i);
                if (object.get("selectField_l6btftfn").toString().contains("预付") && !object.get("selectField_l6btftfn").toString().equals("清预付款(无需支付)")) {

                } else {
                    if (jsonObject.has("numberField_l6x1rkjm") && !"".equals(jsonObject.get("numberField_l6x1rkjm").toString()) && jsonObject.getDouble("numberField_l6x1rkjm") > 0) {
                        numberField_l6x1rkjm += jsonObject.getDouble("numberField_l6x1rkjm");
                        jsonObject.remove("numberField_l6x1rkjm");
                        jsonObject.put("numberField_l6x1rkjm", 0);
                    }
                    if (jsonObject.has("numberField_l7sowiqy") && !"".equals(jsonObject.get("numberField_l7sowiqy").toString()) && jsonObject.getDouble("numberField_l7sowiqy") > 0) {
                        if (jsonObject.getDouble("numberField_l7sowiqy") > numberField_l7sowiqy) {
                            numberField_l7sowiqy = jsonObject.getDouble("numberField_l7sowiqy");
                        }
                    }

                }
            }
            for (int i = 0; i < tableField_l6btfti5.length(); i++) {
                JSONObject jsonObject = tableField_l6btfti5.getJSONObject(i);
                if (object.get("selectField_l6btftfn").toString().contains("预付") && !object.get("selectField_l6btftfn").toString().equals("清预付款(无需支付)")) {
                    objects.put(jsonObject);
                } else {

                    if (jsonObject.has("numberField_l7sowiqy") && !"".equals(jsonObject.get("numberField_l7sowiqy").toString()) && jsonObject.getDouble("numberField_l7sowiqy") > 0) {
                        if (jsonObject.getDouble("numberField_l7sowiqy") == numberField_l7sowiqy) {
                            numberField_l7sowiqy = jsonObject.getDouble("numberField_l7sowiqy");
                            jsonObject.remove("numberField_l6x1rkjm");
                            jsonObject.put("numberField_l6x1rkjm", numberField_l6x1rkjm);
                        } else {
                            jsonObject.remove("numberField_l6x1rkjm");
                            jsonObject.put("numberField_l6x1rkjm", 0);
                        }
                    }
                    objects.put(jsonObject);
                }
            }
            int index = 0;
            numberField_l7sowiqy = 0;
            for (int i = 0; i < objects.length(); i++) {
                if (numberField_l6x1rkjm <= 0) {
                    break;
                }
                JSONObject jsonObject = objects.getJSONObject(i - index);
                if (jsonObject.has("numberField_l6x1rkjm") && !"".equals(jsonObject.get("numberField_l6x1rkjm").toString()) && jsonObject.getDouble("numberField_l6x1rkjm") > 0) {
                    numberField_l7sowiqy = jsonObject.getDouble("numberField_l7sowiqy");
                }
                if (numberField_l7sowiqy >= numberField_l6x1rkjm) {
                    numberField_l6x1rkjm = 0;
                    break;
                } else {
                    if (numberField_l7sowiqy > 0) {
                        jsonObject.remove("numberField_l6x1rkjm");
                        jsonObject.put("numberField_l6x1rkjm", numberField_l7sowiqy);
                        numberField_l6x1rkjm = numberField_l6x1rkjm - numberField_l7sowiqy;
                        numberField_l6x1rkjm = (double) (Math.round(numberField_l6x1rkjm * 100) / 100.0);

                        numberField_l7sowiqy = 0;
                        index++;
                        objects.remove(i);
                        objects.put(jsonObject);
                    }
                }
            }
            JSONArray objectss = new JSONArray();
            for (int i = 0; i < objects.length() - index; i++) {
                JSONObject jsonObject = objects.getJSONObject(i);
                if (numberField_l6x1rkjm <= 0) {
                    objectss.put(jsonObject);
                } else {
                    if (object.get("selectField_l6btftfn").toString().contains("预付") && !object.get("selectField_l6btftfn").toString().equals("清预付款(无需支付)")) {
                        objectss.put(jsonObject);
                    } else {
                        if (jsonObject.has("numberField_l7sowiqy") && !"".equals(jsonObject.get("numberField_l7sowiqy").toString()) && jsonObject.getDouble("numberField_l7sowiqy") > 0) {
                            numberField_l7sowiqy = jsonObject.getDouble("numberField_l7sowiqy");
                        }
                        if (numberField_l7sowiqy >= numberField_l6x1rkjm) {
                            jsonObject.remove("numberField_l6x1rkjm");
                            jsonObject.put("numberField_l6x1rkjm", numberField_l6x1rkjm);
                            numberField_l6x1rkjm = 0;
                            break;
                        } else {
                            double numberField_l7sowiqy1 = jsonObject.getDouble("numberField_l7sowiqy");
                            jsonObject.remove("numberField_l6x1rkjm");
                            jsonObject.put("numberField_l6x1rkjm", numberField_l7sowiqy1);
                            numberField_l6x1rkjm = numberField_l6x1rkjm - numberField_l7sowiqy1;
                            numberField_l6x1rkjm = (double) (Math.round(numberField_l6x1rkjm * 100) / 100.0);

                            numberField_l7sowiqy = 0;
                        }
                        objectss.put(jsonObject);
                    }
                }
            }
            tableField_l6btfti5 = objects;
            for (int i = 0; i < tableField_l6btfti5.length(); i++) {
                JSONObject jsonObject = tableField_l6btfti5.getJSONObject(i);
                JSONObject itemObject = new JSONObject();
                itemObject.put("ZOA_ITEMNO", (i + 1) + "");       //OA单据行号
                // itemObject.put("EBELN", "5100000128");
                if (object.get("selectField_l6btftfn").toString().equals("无发票")) {
                    itemObject.put("XREF1", object.get("textField_l8iin96w"));//长文本未开发
                    itemObject.put("EBELN", object.get("textField_l8iin96v"));       //PO号
                    itemObject.put("EBELP", "00010");       //PO行项目
                    BigDecimal bigBhsje = new BigDecimal(object.get("numberField_l6czvx0w").toString());//改大数
                    bigBhsje = bigBhsje.setScale(2, RoundingMode.HALF_UP);
                    itemObject.put("DMBTR", bigBhsje);       //不含税金额
                    itemObject.put("MWSKZ", "J0");       //税码
                    itemObject.put("ZTAX_AMT", 0);       //税额
                    itemObject.put("SGTXT", "");       //行项目文本
                    break;
                }

                if (object.get("selectField_l6btftfn").toString().contains("预付") && !object.get("selectField_l6btftfn").toString().equals("清预付款(无需支付)")) {
                    itemObject.put("XREF1", object.get("textField_l8iin96w"));//长文本未开发
                    itemObject.put("EBELN", jsonObject.get("textField_l6x1rkjk"));       //PO号
                    itemObject.put("EBELP", jsonObject.get("textField_l6czvx0h"));       //PO行项目

                    BigDecimal bigBhsje = new BigDecimal(jsonObject.get("numberField_l7sowiqy").toString());//改大数
                    bigBhsje = bigBhsje.setScale(2, RoundingMode.HALF_UP);
                    itemObject.put("DMBTR", bigBhsje);       //不含税金额

//                    itemObject.put("DMBTR", jsonObject.get("numberField_l7sowiqy").toString());       //不含税金额
//                    itemObject.put("DMBTR", "1100.92");       //不含税金额
                    itemObject.put("MWSKZ", "J0");       //税码
                    itemObject.put("ZTAX_AMT", 0);       //税额
                    itemObject.put("SGTXT", "");       //行项目文本
                } else {
                    itemObject.put("EBELN", jsonObject.get("textField_l6x1rkjk"));       //PO号
                    itemObject.put("EBELP", jsonObject.get("textField_l6czvx0h").toString().equals("") ? "00010" : jsonObject.get("textField_l6czvx0h").toString());       //PO行项目

                    BigDecimal bigBhsje = new BigDecimal(jsonObject.get("numberField_l7sowiqy").toString());//改大数
                    bigBhsje = bigBhsje.setScale(2, RoundingMode.HALF_UP);
                    itemObject.put("DMBTR", bigBhsje);       //不含税金额

//                    itemObject.put("DMBTR", jsonObject.get("numberField_l7sowiqy").toString());       //不含税金额
                    itemObject.put("MWSKZ", jsonObject.get("textField_l6x1rkjl").toString().equals("") ? "J0" : jsonObject.get("textField_l6x1rkjl"));       //税码
                    itemObject.put("ZTAX_AMT", jsonObject.get("numberField_l6x1rkjm").toString());       //税额
                    itemObject.put("SGTXT", jsonObject.get("textField_l815hv7t"));       //行项目文本

                    if (object.has("tableField_l6otidfq") && object.getJSONArray("tableField_l6otidfq").length() > 0) {
                        JSONArray tableField_l6otidfq = object.getJSONArray("tableField_l6otidfq");
                        for (int j = 0; j < tableField_l6otidfq.length(); j++) {
                            JSONObject c_jsonObject = tableField_l6otidfq.getJSONObject(j);
                            if (!c_jsonObject.has("associationFormField_l6ygli4c_id") || c_jsonObject.get("associationFormField_l6ygli4c_id").toString().equals("")) {
                                continue;
                            }
                            String substring = c_jsonObject.getString("associationFormField_l6ygli4c_id").replaceAll("\\\\", "").substring(1);
                            if (new JSONArray(substring.substring(0, substring.length() - 1)).length() == 0) {
                                continue;
                            }
                            String instanceId = new JSONArray(substring.substring(0, substring.length() - 1)).getJSONObject(0).getString("instanceId");
                            String s = PjgetByid(instanceId, "1");
                            if ("JH".equals(s)) {
                                itemObject.remove("MWSKZ");
                                itemObject.put("MWSKZ", "JH");       //税码
                            }
                        }
                    }

                }
                SapItem.put(itemObject);
            }
            sapJson.put("ITEM", SapItem);


            JSONArray tableField_l8iin972 = object.getJSONArray("tableField_l8iin972");
            SapItem = new JSONArray();
            ///需要删除
//            JSONObject itemObject = new JSONObject();
//            itemObject.put("ZGL_ITEMNO", "1");       //OA单据行号
//            itemObject.put("HKONT","155164");       //PO行项目
//            itemObject.put("SHKZG", "H");       //不含税金额
//            itemObject.put("WRBTR","0.01");       //税额
//            SapItem.put(itemObject);

            for (int i = 0; i < tableField_l8iin972.length(); i++) {
                JSONObject jsonObject = tableField_l8iin972.getJSONObject(i);
                JSONObject itemObject = new JSONObject();
                itemObject.put("ZGL_ITEMNO", (i + 1) + "");       //OA单据行号
                itemObject.put("HKONT", jsonObject.get("textField_l8iin973"));       //PO行项目
                if (jsonObject.has("selectField_l8ijz7vc") && !"".equals(jsonObject.get("selectField_l8ijz7vc"))) {
                    if (jsonObject.getString("selectField_l8ijz7vc").contains("借")) {
                        itemObject.put("SHKZG", "S");       //不含税金额
                    } else {
                        itemObject.put("SHKZG", "H");       //不含税金额
                    }

                    itemObject.put("WRBTR", jsonObject.get("textField_l8iin975"));       //税码
                    itemObject.put("KOSTL", jsonObject.get("textField_l8iin976"));       //税额
                    SapItem.put(itemObject);
                }
            }
            sapJson.put("GL_ITEM", SapItem);
            System.out.println(sapJson);
            logger.info(sapJson.toString());
            System.out.println(QA_sapUrl + "SAP007");
            logger.info(QA_sapUrl + "SAP007");
            String post = HttpUtil.post(QA_sapUrl + "SAP007", null, sapJson.toString(), null);
            if (!post.equals("")) {
                System.out.println(post);
                logger.info("post:" + post);
                JSONArray jsonArray = new JSONArray(post);
                if (jsonArray.length() > 0) {
                    JSONObject postJsonObject = jsonArray.getJSONObject(0);
                    System.out.println(postJsonObject.get("E_MESSAGE"));
                    Object e_message = postJsonObject.get("E_MESSAGE");
                    logger.info(e_message.toString());
                    if (postJsonObject.has("E_BELNR") && !postJsonObject.getString("E_BELNR").equals("")) {
                        upJson.put("textField_l6yt5969", postJsonObject.getString("E_BELNR"));
                    }
                    if (postJsonObject.has("E_BELNR_FI") && !postJsonObject.getString("E_BELNR_FI").equals("")) {
                        upJson.put("textField_l7imtdo3", postJsonObject.getString("E_BELNR_FI"));
                    }


                    upJson.put("dateField_l701pr3a", CusutUtil.dateTOtimeshapYYMMDD(start_time));
                    upJson.put("dateField_l701pr3b", CusutUtil.dateTOtimeshapYYMMDD(start_time));
                    upJson.put("textField_l701pr3d", name);
                    upJson.put("textField_l7a5euts", postJsonObject.get("E_MESSAGE"));
                    logger.info("YIDA UPDATE:" + id + "=>" + upJson.toString());
                    dingUtil.UpdateYiDa(id, upJson);
//                    if (upJson.has("textField_l6yt5969") || upJson.has("textField_l7imtdo3")) {
//                        try {
//                            if (upJson.has("textField_l6yt5969") && !"".equals(upJson.get("textField_l6yt5969")) && !";".equals(upJson.get("textField_l6yt5969"))) {
//                                Thread.sleep(3000);
//                                bookkeeping(id, "PO");
//                            } else if (upJson.has("textField_l7imtdo3") && !"".equals(upJson.get("textField_l7imtdo3")) && !";".equals(upJson.get("textField_l7imtdo3"))) {
//                                Thread.sleep(3000);
//                                bookkeeping(id, "PO");
//                            }
//                        } catch (Exception ex) {
//                            ex.printStackTrace();
//                        }
//                    }
                }
            }
//            dingUtil.UpdateYiDa(id, upJson);

            //    return CusutUtil.SuccessReturnJsonString(200, "成功", "str");
        } catch (Exception ex) {
            ex.printStackTrace();
        }
    }

    /***
     * TE生成 凭证
     * @return
     */
    @Async
    public void TECreatePZ(String id, String name) {
        try {

            Thread.sleep(3000);
            JSONObject upJson = new JSONObject();
            String start_time = CusutUtil.getNowDate("yyyyMMdd");
//            System.out.println(name);

            JSONObject object = new JSONObject(dingUtil.getYidaById(id));
            logger.info("AsyncController (TECreatePZ)465: Result => " + object.toString());
            logger.info("AsyncController (TECreatePZ)465: Param => " + id);
            if (!object.has("textField_l7a7bf8a") || "".equals(object.getString("textField_l7a7bf8a"))) {
                object.put("textField_l7a7bf8a", object.has("textField_l6bynqpu") ? object.get("textField_l6bynqpu") : "");
            }

            //获取公司编号
            String str_corp_id = object.getString("textField_l7a7bf8a");

            if (object.get("textField_l7a7bf8d").toString().equals("") || !object.has("textField_l7a7bf8d")) {
                String YY = object.getString("textField_l7a7bf8f").substring(2, 4);
                String value = object.getString("textField_l7a7bf8a") + YY;

                upJson.put("textField_l7a916pt", value);
                JSONObject obj = new JSONObject();
                obj.put("textField_l9qg8a8n", object.get("textField_l7a916pt"));
                JSONArray data = new JSONArray(dingUtil.yiDaSearch("FORM-WC9666911ZP308OTCINEF5VM2HKC2HI42GQ9LG7", obj));
                String str = (100000 + data.length() + 1) + "";

                if (data.length() > 0) {
                    logger.info("AsyncController (TECreatePZ)482: Result => " + data.getJSONObject(0).toString());
                    logger.info("AsyncController (TECreatePZ)482: Param => " + obj.toString());
                    str = (100000 + data.getJSONObject(0).getJSONObject("formData").getInt("numberField_l9qnm4yt") + 1) + "";
                    obj.put("numberField_l9qnm4yt", data.getJSONObject(0).getJSONObject("formData").getInt("numberField_l9qnm4yt") + 1);
//                    logger.info(" YiDa Update : " + data.getJSONObject(0).getString("formInstanceId") + " => " + obj.toString());
                    String res = dingUtil.UpdateYiDa(data.getJSONObject(0).getString("formInstanceId"), obj);
                    logger.info("AsyncController (TECreatePZ)491: Result => " + res);
                    logger.info("AsyncController (TECreatePZ)491: Param => " + obj.toString());
                } else {
                    obj.put("numberField_l9qnm4yt", 1);
                    String res = dingUtil.saveYiDa("FORM-WC9666911ZP308OTCINEF5VM2HKC2HI42GQ9LG7", obj, dingConst.getUserId());
                    logger.info("AsyncController (TECreatePZ)496: Result => " + res);
                    logger.info("AsyncController (TECreatePZ)496: Param => " + obj.toString());
                }
                upJson.put("textField_l7a7bf8d", object.getString("textField_l7a916pt") + str.substring(1, str.length()));
                object.remove("textField_l7a7bf8d");
                object.put("textField_l7a7bf8d", upJson.getString("textField_l7a7bf8d"));
                System.out.println(upJson);
                logger.info(upJson.toString());
            }
//            else
//            {
//                object.remove("textField_l7a7bf8d");
//                object.put("textField_l7a7bf8d","TE2023089999");
//            }
            while (true) {
                // if (!object.has("textField_l6bynqpu") || "否".equals(object.getString("textField_l6bynqpu"))) {
                JSONObject cobj = new JSONObject();
                cobj.put("textField_l7a7bf8d", object.get("textField_l7a7bf8d"));
                JSONArray cdata = new JSONArray(dingUtil.yiDaSearch("FORM-UX866Q61LRK2LACIB8A6M6T1ZOLM2VY5NYB6LZ", cobj));
                if (cdata.length() > 1) {
                    String YY = object.getString("textField_l7a7bf8f").substring(2, 4);
                    String value = object.getString("textField_l7a7bf8a") + YY;

                    upJson.put("textField_l7a916pt", value);
                    JSONObject obj = new JSONObject();
                    obj.put("textField_l9qg8a8n", object.get("textField_l7a916pt"));
                    JSONArray data = new JSONArray(dingUtil.yiDaSearch("FORM-WC9666911ZP308OTCINEF5VM2HKC2HI42GQ9LG7", obj));
                    String str = (100000 + data.length() + 1) + "";

                    if (data.length() > 0) {
                        logger.info("AsyncController (TECreatePZ)523: Result => " + data.getJSONObject(0).toString());
                        logger.info("AsyncController (TECreatePZ)523: Param => " + obj.toString());
                        str = (100000 + data.getJSONObject(0).getJSONObject("formData").getInt("numberField_l9qnm4yt") + 1) + "";
                        obj.put("numberField_l9qnm4yt", data.getJSONObject(0).getJSONObject("formData").getInt("numberField_l9qnm4yt") + 1);


                        String res = dingUtil.UpdateYiDa(data.getJSONObject(0).getString("formInstanceId"), obj);
                        logger.info("AsyncController (TECreatePZ)533: Result => " + res);
                        logger.info("AsyncController (TECreatePZ)533: Param => " + obj.toString());
                    } else {
                        obj.put("numberField_l9qnm4yt", 1);
                        String res = dingUtil.saveYiDa("FORM-WC9666911ZP308OTCINEF5VM2HKC2HI42GQ9LG7", obj, dingConst.getUserId());
                        logger.info("AsyncController (TECreatePZ)538: Result => " + res);
                        logger.info("AsyncController (TECreatePZ)538: Param => " + obj.toString());
                    }
                    upJson.put("textField_l7a7bf8d", object.getString("textField_l7a916pt") + str.substring(1, str.length()));
                    object.remove("textField_l7a7bf8d");
                    object.put("textField_l7a7bf8d", upJson.getString("textField_l7a7bf8d"));
                    upJson.put("textField_l6bynqpu", "是");
                } else {
                    break;
                }
                // }
            }

            JSONObject sapJson = new JSONObject();
            sapJson.put("ZOA_NUMBER", object.get("textField_l7a7bf8d"));  //OA单据号
            sapJson.put("ZOA_TYPE", "TE");  //OA单据类型
            sapJson.put("BUKRS", object.get("textField_l7a7bf8a"));       //公司代码
            sapJson.put("BLART", "Z2");      //凭证类型
            sapJson.put("WAERS", "CNY");       //币种
//            try {
//                if (object.has("dateField_l8i7z6z6")) {
//                    start_time = CusutUtil.getFormatDate(object.getLong("dateField_l8i7z6z6"));
//                }
//            } catch (Exception ex) {
//
//            }
            sapJson.put("BLDAT", start_time);       //凭证日期
            sapJson.put("BUDAT", start_time);       //过账日期
            sapJson.put("BKTXT", object.get("textField_l6lmxo6c"));       //抬头文本

            String uid = "TEST-CN001";
            JSONArray gzhangr = new JSONArray(name);
            if (gzhangr.length() > 0) {
                JSONObject obj = new JSONObject();
                obj.put("textField_l6dddg5k", gzhangr.get(0));
                JSONArray data = new JSONArray(dingUtil.yiDaSearch("FORM-4J7669A10FO250UJ9C6Q7CM00PC62YPW8DD6LT", obj));
                logger.info("AsyncController (TECreatePZ)574: Result => " + data.getJSONObject(0).toString());
                logger.info("AsyncController (TECreatePZ)574: Param => " + obj.toString());
                JSONObject formData = data.getJSONObject(0).getJSONObject("formData");
                uid = formData.get("textField_l6djch1m").toString();
                uid = "CHN-0" + uid;
            }
            sapJson.put("USNAM", uid);       //过账人
            sapJson.put("ZINVOICE_AMT", object.get("numberField_l6lmxo6h"));       //发票总额
            sapJson.put("ZPAY_AMT", object.get("numberField_l6lmxo6h"));       //支付金额
            sapJson.put("LIFNR", object.get("textField_l6bynqpk"));       //供应商代码
//            if(sapJson.getString("LIFNR").equals("1111111")){
//                sapJson.remove("LIFNR");
//                sapJson.put("LIFNR", "1201509");
//            }
            String context = object.getJSONArray("employeeField_l843wfsm").getString(0);
            try {
                String bracket = context.substring(context.indexOf("("), context.indexOf(")") + 1);

                context = context.replace(bracket, "");
            } catch (Exception ex) {

            }

            sapJson.put("KOINH", context);       //收款方名称
            sapJson.put("BANKN", object.get("textField_l6bynqpr"));       //银行账号
            sapJson.put("BANKA", object.get("textField_l6bynqpq"));       //开户行


            JSONArray SapItem = new JSONArray();       //子表

            JSONArray tableField_l6btfti5 = object.getJSONArray("tableField_l6lmxo5r");
            if (tableField_l6btfti5.length() == 50) {
                tableField_l6btfti5 = dingUtil.innerTables(id, "FORM-UX866Q61LRK2LACIB8A6M6T1ZOLM2VY5NYB6LZ", "tableField_l6lmxo5r");
            }
            HashMap<String, Double> fphmMap = new HashMap<>();
            for (int i = 0; i < tableField_l6btfti5.length(); i++) {
                JSONObject jsonObject = tableField_l6btfti5.getJSONObject(i);
                if (!jsonObject.has("numberField_l6lmxo62") || "".equals(jsonObject.get("numberField_l6lmxo62").toString())) {
                    jsonObject.put("numberField_l6lmxo62", 0);
                }
//                if ("0".equals(jsonObject.get("numberField_l6lmxo62").toString()) && jsonObject.has("numberField_l6lmxo61") && !"".equals(jsonObject.get("numberField_l6lmxo61").toString()) && !"0".equals(jsonObject.get("numberField_l6lmxo61").toString())) {
//                    try {
//                        double sl = jsonObject.getDouble("numberField_l6lmxo61") / 100;
//                        double s = jsonObject.getDouble("numberField_l6napwwi") / (1 + sl) * sl;
//                        String format = new DecimalFormat("#.00").format(s);
//                        jsonObject.remove("numberField_l6lmxo62");
//                        jsonObject.put("numberField_l6lmxo62", format);
//                    } catch (Exception ex) {
//                        if (!jsonObject.has("numberField_l6lmxo62") || "".equals(jsonObject.get("numberField_l6lmxo62").toString())) {
//                            jsonObject.put("numberField_l6lmxo62", 0);
//                        } else {
//                            jsonObject.remove("numberField_l6lmxo62");
//                            jsonObject.put("numberField_l6lmxo62", 0);
//                        }
//                    }
//                }


                if (jsonObject.has("textField_l6q8uw0g") && !jsonObject.get("textField_l6q8uw0g").toString().equals("")) {
                    double se = jsonObject.getDouble("numberField_l6lmxo62");
                    if (fphmMap.containsKey(jsonObject.getString("textField_l6q8uw0g"))) {
                        se += fphmMap.get(jsonObject.getString("textField_l6q8uw0g"));
                        fphmMap.remove(jsonObject.getString("textField_l6q8uw0g"));
                    }
                    String format = new DecimalFormat("#.0000").format(se);
                    fphmMap.put(jsonObject.getString("textField_l6q8uw0g"), new Double(format));

                }
            }
//            System.out.println(tableField_l6btfti5.length());
            for (int i = 0; i < tableField_l6btfti5.length(); i++) {
                JSONObject jsonObject = tableField_l6btfti5.getJSONObject(i);
                JSONObject itemObject = new JSONObject();
                itemObject.put("ZOA_ITEMNO", i + 1);       //OA单据行号
                if (jsonObject.getString("selectField_l6lmxo5z").contains("私车公用")) {
                    jsonObject.put("textField_l6lmxo66", "822604");
                }
                if (jsonObject.getString("selectField_l6lmxo5z").contains("手机费")) {
                    jsonObject.put("textField_l6lmxo66", "822410");
                }
                if (jsonObject.getString("selectField_l6lmxo5z").contains("早/午/晚餐")) {
                    jsonObject.put("textField_l6lmxo66", "822700");
                }
                if (jsonObject.getString("selectField_l6lmxo5z").contains("住宿")) {
                    jsonObject.put("textField_l6lmxo66", "822615");
                }
                if (jsonObject.getString("selectField_l6lmxo5z").contains("火车")) {
                    jsonObject.put("textField_l6lmxo66", "822609");
                }


                if (jsonObject.getString("selectField_l6lmxo5z").contains("机票")) {
                    jsonObject.put("textField_l6lmxo66", "822605");
                }
                if (jsonObject.getString("selectField_l6lmxo5z").contains("出租车费")) {
                    jsonObject.put("textField_l6lmxo66", "822610");
                }


                if (!jsonObject.has("textField_l6lmxo66")) {
                    JSONObject queryobj = new JSONObject();
                    queryobj.put("textField_l6emcrsj", jsonObject.getString("selectField_l6lmxo5z"));
                    JSONArray data = new JSONArray(dingUtil.yiDaSearch("FORM-J7966ZA1YSX24JW6BS5KX48HZ36E25W2BAN6L0", queryobj));
                    logger.info("AsyncController (TECreatePZ)677: Result => " + data.getJSONObject(0).toString());
                    logger.info("AsyncController (TECreatePZ)677: Param => " + queryobj.toString());
                    JSONObject formData = data.getJSONObject(0).getJSONObject("formData");
                    jsonObject.put("textField_l6lmxo66", formData.getString("textField_l6emcrsc"));
                }
                itemObject.put("HKONT", jsonObject.get("textField_l6lmxo66"));       //会计科目
                itemObject.put("KOSTL", object.get("textField_l88jamy9"));       //成本中心
                if (!jsonObject.has("numberField_l6lmxo62")) {
                    jsonObject.put("numberField_l6lmxo62", 0);
                }

                if (!jsonObject.has("numberField_l81a6gqq")) {
                    jsonObject.put("numberField_l81a6gqq", 0);
                }
                if (!jsonObject.has("textField_l7a7bf8i")) {
                    if (!jsonObject.has("numberField_l6lmxo61") || jsonObject.get("numberField_l6lmxo61").toString().equals("0")) {
                        jsonObject.put("textField_l7a7bf8i", "J0");
                    } else {
                        JSONObject queryobj = new JSONObject();
                        queryobj.put("numberField_l79x0uw8", new JSONArray().put(jsonObject.get("numberField_l6lmxo61")).put(jsonObject.get("numberField_l6lmxo61")));
//                        System.out.println(queryobj);
                        JSONArray data = new JSONArray(dingUtil.yiDaSearch("FORM-XN966G71C1A3T2LJ62UOZAZTRGS72GNG0X97L41", queryobj));
                        logger.info("AsyncController (TECreatePZ)699: Result => " + data.getJSONObject(0).toString());
                        logger.info("AsyncController (TECreatePZ)699: Param => " + queryobj.toString());
                        JSONObject formData = data.getJSONObject(0).getJSONObject("formData");
                        jsonObject.put("textField_l7a7bf8i", formData.getString("textField_l79x0uw6"));
                    }
                }
                double se = jsonObject.get("textField_l7a7bf8i").toString().equals("") ? 0 : jsonObject.getDouble("numberField_l6lmxo62");
//                if (jsonObject.has("textField_l6q8uw0g") && !jsonObject.get("textField_l6q8uw0g").toString().equals("")) {
//                    se = fphmMap.get(jsonObject.getString("textField_l6q8uw0g"));
//                    fphmMap.remove(jsonObject.getString("textField_l6q8uw0g"));
//                    fphmMap.put(jsonObject.getString("textField_l6q8uw0g"), 0.0);
//                }
                if (!jsonObject.has("numberField_l88jamy7") || jsonObject.get("numberField_l88jamy7").equals("")) {
                    jsonObject.put("numberField_l88jamy7", jsonObject.get("numberField_l6napwwi"));
                }

                if (jsonObject.has("textField_l6q8uw0g") && !jsonObject.get("textField_l6q8uw0g").toString().equals("")) {
                    se = fphmMap.get(jsonObject.getString("textField_l6q8uw0g"));
                    fphmMap.remove(jsonObject.getString("textField_l6q8uw0g"));
                    fphmMap.put(jsonObject.getString("textField_l6q8uw0g"), 0.0);
                }

                itemObject.put("ZTAX_AMT", se);       //税额

                BigDecimal bd1 = new BigDecimal(jsonObject.getDouble("numberField_l88jamy7"));
                BigDecimal bd2 = new BigDecimal(se);
                BigDecimal subtractResult = bd1.subtract(bd2);
                BigDecimal roundedResult = subtractResult.setScale(2, RoundingMode.HALF_UP);
                System.out.println(roundedResult);
                itemObject.put("DMBTR", roundedResult);//不含税金额

                itemObject.put("ZTAXOUT_AMT", jsonObject.get("numberField_l81a6gqq"));       //进项税转出金额
                itemObject.put("SGTXT", jsonObject.get("textField_l6lmxo5x"));       //行项目文本
                if (!jsonObject.has("textField_l6lmxo67")) {
                    jsonObject.put("textField_l6lmxo67", "");
                }
                itemObject.put("XREF1", jsonObject.get("textField_l6lmxo67"));//参考码1
                if (i == tableField_l6btfti5.length() - 1) {
                    try {
                        sapJson.put("ZDUEDATE", CusutUtil.getFormatDate(jsonObject.getLong("dateField_l6lmxo5w")));       //到期日
                    } catch (Exception ex) {
                        sapJson.put("ZDUEDATE", start_time);
                    }
                }
                String s = "";
                try {
                    String substring = jsonObject.getString("associationFormField_l6vk2yxg_id").replaceAll("\\\\", "").substring(1);
                    String instanceId = new JSONArray(substring.substring(0, substring.length() - 1)).getJSONObject(0).getString("instanceId");
                    s = PjgetByid(instanceId, "1");
                    logger.info("AsyncController (TECreatePZ)745: Result => " + s);
                    logger.info("AsyncController (TECreatePZ)745: Param => " + instanceId);
                } catch (Exception ex) {

                }
                if ("JH".equals(s)) {
                    itemObject.put("MWSKZ", "JH");       //税码
                } else {
                    itemObject.put("MWSKZ", jsonObject.get("textField_l7a7bf8i").equals("") ? "J0" : jsonObject.get("textField_l7a7bf8i"));       //税码
                }
                if (i == 0) {
                    itemObject.put("ZZ01", object.get("textField_lgq1a9a8"));
                }
                //测试大批量数据
                SapItem.put(itemObject);
            }
            sapJson.put("ITEM", SapItem);

//            System.out.println(sapJson);
//            String post = "";
//            if (post.equals("")) {
//                return;
//            }
            //凭证编号
            String BELNR_CODE = "";

            //todo 写在数据库里

            // 记录外推POST请求
            logger.info("AsyncController (TECreatePZ)776:发起POST请求：URL={}, 参数={}", sapUrl + "SAP005", sapJson);
            // 发送POST请求
            String post = HttpUtil.post(sapUrl + "SAP005", null, sapJson.toString(), null);
//            String post = HttpUtil.post(sapUrl + "SAP005", null, "", null);

            // ppExt: 本地配置忽略证书发起请求 [sap 会验证证书, 本地请求不通, 可将参数复制到 postman 执行]
//            String post = HttpUtil.okRequest(sapUrl + "SAP005", sapJson.toString());

            // 记录请求结束时的信息
            logger.info("AsyncController (TECreatePZ)776:POST请求完成：响应={}", post);

            if (!post.equals("")) {
                System.out.println(post);
                if (new JSONArray(post).length() > 0) {
                    JSONObject postJsonObject = new JSONArray(post).getJSONObject(0);
                    if (!postJsonObject.getString("E_BELNR").equals("")) {
                        BELNR_CODE = postJsonObject.getString("E_BELNR");
                        upJson.put("textField_l7a7bf81", BELNR_CODE);
                        //   upJson.put("dateField_l7a7bf88", CusutUtil.dateTOtimeshapYYMMDD(start_time));
                        upJson.put("dateField_l7a7bf89", CusutUtil.dateTOtimeshapYYMMDD(start_time));
                        upJson.put("textField_l7a7bf8h", name);
                    }
                    upJson.put("textField_l7a7bf8g", postJsonObject.get("E_MESSAGE"));
                } else {
                    upJson.put("textField_l7a7bf8g", "[]");
                }
            } else {
                return;
            }
            String s = dingUtil.UpdateYiDa(id, upJson);
            logger.info("AsyncController (TECreatePZ)800: Result => " + s);
            logger.info("AsyncController (TECreatePZ)800: Param => " + id + " => " + upJson.toString());
//            if (upJson.has("textField_l7a7bf81")) {
//                if (!"".equals(upJson.get("textField_l7a7bf81")) && !";".equals(upJson.get("textField_l7a7bf81"))) {
//                    Thread.sleep(2000);
//                    bookkeeping(id, "TE");
//                }
//            }
            if (!"".equals(BELNR_CODE) && !"".equals(str_corp_id)) {
//                yidaController.bookkeepingSync(str_corp_id,BELNR_CODE);
//todo 重推后打开
//                this.bookkeepingSync(str_corp_id, BELNR_CODE);
            }
            CusutUtil.SuccessReturnJsonString(200, "成功", "str");
        } catch (Exception ex) {
            logger.error("AsyncController (TECreatePZ)816: " + ex.getMessage());
            ex.printStackTrace();
            CusutUtil.SuccessReturnJsonString(500, "接口异常500,请联系管理员或开发者处理", "str");
        }
    }

    public String bookkeepingSync(String gs, String pz_id) {
        String s = null;
        try {
            JSONObject obj = new JSONObject();
            obj.put("textField_l7a7bf8a", gs);
            obj.put("textField_l7a7bf81", pz_id);
            s = dingUtil.yiDaSearch("FORM-UX866Q61LRK2LACIB8A6M6T1ZOLM2VY5NYB6LZ", obj, 0);
            logger.info("AsyncController (bookkeepingSync)829: Result => " + s);
            logger.info("AsyncController (bookkeepingSync)829: Param => " + obj.toString());
        } catch (Exception e) {
            logger.error("AsyncController (TECreatePZ)832: " + e.getMessage());
            e.printStackTrace();
        }
        JSONArray jsonArray = new JSONArray(s);
        System.out.println(jsonArray.length());
        int num = 0;
        for (int i = 0; i < jsonArray.length(); i++) {
            try {
                JSONObject jobject = jsonArray.getJSONObject(i);
//                    if (!"".equals(jobject.getJSONObject("formData").getString("textField_l7a7bf81")) && CusutUtil.getFormatDateMM(jobject.getJSONObject("formData").getLong("dateField_l7a7bf89")).equals("07")) {
//                        bookkeepingBack(jobject.getString("formInstanceId"), "TE");
                logger.info("AsyncController (bookkeepingSync)844: Param => " + jobject.toString());
                String res = this.bookkeeping(jobject.getString("formInstanceId"), "TE");
                logger.info("AsyncController (bookkeepingSync)844: Result => " + res);
//                    }
            } catch (Exception e) {
                logger.error("AsyncController (TECreatePZ)848: " + e.getMessage());
            }
        }
//      }
        log.info("完成");
        return "200";
    }

    @Async
    public void TECreateSeqNo(String id) {
        try {
            Thread.sleep(3000);
            JSONObject upJson = new JSONObject();

            JSONObject object = new JSONObject(dingUtil.getYidaById(id));
            while (true) {
                JSONObject cobj = new JSONObject();
                cobj.put("textField_l7a7bf8d", object.get("textField_l7a7bf8d"));
                JSONArray cdata = new JSONArray(dingUtil.yiDaSearch("FORM-UX866Q61LRK2LACIB8A6M6T1ZOLM2VY5NYB6LZ", cobj));
                if (cdata.length() > 1) {
                    String YY = object.getString("textField_l7a7bf8f").substring(2, 4);
                    String value = object.getString("textField_l7a7bf8a") + YY;

                    upJson.put("textField_l7a916pt", value);
                    JSONObject obj = new JSONObject();
                    obj.put("textField_l9qg8a8n", object.get("textField_l7a916pt"));
                    JSONArray data = new JSONArray(dingUtil.yiDaSearch("FORM-WC9666911ZP308OTCINEF5VM2HKC2HI42GQ9LG7", obj));
                    String str = (100000 + data.length() + 1) + "";

                    if (data.length() > 0) {
                        str = (100000 + data.getJSONObject(0).getJSONObject("formData").getInt("numberField_l9qnm4yt") + 1) + "";
                        obj.put("numberField_l9qnm4yt", data.getJSONObject(0).getJSONObject("formData").getInt("numberField_l9qnm4yt") + 1);
                        logger.info(" YiDa Update : " + data.getJSONObject(0).getString("formInstanceId") + " => " + obj.toString());
                        dingUtil.UpdateYiDa(data.getJSONObject(0).getString("formInstanceId"), obj);
                    } else {
                        obj.put("numberField_l9qnm4yt", 1);
                        String res = dingUtil.saveYiDa("FORM-WC9666911ZP308OTCINEF5VM2HKC2HI42GQ9LG7", obj, dingConst.getUserId());
                        logger.info("YiDa Return Data :" + res);
                    }
                    upJson.put("textField_l7a7bf8d", object.getString("textField_l7a916pt") + str.substring(1, str.length()));
                    object.remove("textField_l7a7bf8d");
                    object.put("textField_l7a7bf8d", upJson.getString("textField_l7a7bf8d"));
                } else {
                    break;
                }
            }
            JSONArray jsonArray = new JSONArray();
            JSONArray tableField_l6lmxo5r = object.getJSONArray("tableField_l6lmxo5r");
            for (int i = 0; i < tableField_l6lmxo5r.length(); i++) {
                JSONObject jsonObject = tableField_l6lmxo5r.getJSONObject(i);
                String selectField_l6lmxo5z = jsonObject.getString("selectField_l6lmxo5z");

                JSONObject cobj = new JSONObject();
                cobj.put("textField_l6emcrsj", selectField_l6lmxo5z);
                JSONArray cdata = new JSONArray(dingUtil.yiDaSearch("FORM-J7966ZA1YSX24JW6BS5KX48HZ36E25W2BAN6L0", cobj));
                if (cdata.length() > 0) {
                    jsonObject.remove("textField_l6lmxo66");
                    jsonObject.put("textField_l6lmxo66", cdata.getJSONObject(0).getJSONObject("formData").getString("textField_l6emcrsc"));
                }
                jsonArray.put(jsonObject);
            }
            if (upJson.has("textField_l7a7bf8d")) {
                logger.info(" YiDa Update : " + id + " => " + upJson.toString());
                dingUtil.UpdateYiDa(id, upJson);
            }
            System.out.println(1);
        } catch (Exception ex) {
            ex.printStackTrace();
            CusutUtil.SuccessReturnJsonString(500, "接口异常500,请联系管理员或开发者处理", "str");
        }
    }

    /***
     * NP生成 凭证
     * @return
     */
    @Async
    public void NPCreatePZ(String id, String name) {
        try {
            Thread.sleep(3000);
            JSONObject upJson = new JSONObject();
            String start_time = CusutUtil.getNowDate("yyyyMMdd");
            System.out.println("NP");
            JSONObject object = new JSONObject(dingUtil.getYidaById(id));
            System.out.println(object);
            JSONObject sapJson = new JSONObject();
            String type = "NP";
            if (object.has("selectField_l6bvwdie") && object.getString("selectField_l6bvwdie").contains("预付") && !object.get("selectField_l6bvwdie").toString().equals("100%清预付款")) {
                type = "AD";
                if (!object.has("textField_l9s5b8f1")) {
                    object.put("textField_l9s5b8f1", "A");
                }
                sapJson.put("UMSKZ", object.get("textField_l9s5b8f1")); //特别总帐标识
                // sapJson.put("BLART", "Z4");      //凭证类型
            } else {
                //sapJson.put("BLART", "Z2");      //凭证类型
            }
            sapJson.put("BLART", "Z2");      //凭证类型
            if (object.get("textField_l7a6bzps").toString().equals("") || !object.has("textField_l7a6bzps") || object.get("textField_l7a6bzps").toString().contains("00001")) {
                String YY = object.getString("textField_l701yhtw").substring(0, 4);//截取会计年度前四位
                String value = object.getString("textField_l7a6bzpu") + YY;

                upJson.put("textField_l7a988ju", value);//单据号前置
                JSONObject obj = new JSONObject();

                obj.put("textField_l9qg8a8n", object.get("textField_l7a988ju"));
                JSONArray data = new JSONArray(dingUtil.yiDaSearch("FORM-WC9666911ZP308OTCINEF5VM2HKC2HI42GQ9LG7", obj));
                String str = (100000 + data.length() + 1) + "";
                if (data.length() > 0) {
                    str = (100000 + data.getJSONObject(0).getJSONObject("formData").getInt("numberField_l9qnm4yt") + 1) + "";
                    obj.put("numberField_l9qnm4yt", data.getJSONObject(0).getJSONObject("formData").getInt("numberField_l9qnm4yt") + 1);

                    logger.info(" YiDa Update : " + data.getJSONObject(0).getString("formInstanceId") + " => " + obj.toString());
                    dingUtil.UpdateYiDa(data.getJSONObject(0).getString("formInstanceId"), obj);
                } else {
                    obj.put("numberField_l9qnm4yt", 1);
                    String res = dingUtil.saveYiDa("FORM-WC9666911ZP308OTCINEF5VM2HKC2HI42GQ9LG7", obj, dingConst.getUserId());
                    logger.info("YiDa Return Data :" + res);
                }
                upJson.put("textField_l7a6bzps", "NP" + object.getString("textField_l7a988ju") + str.substring(1, str.length()));
                object.remove("textField_l7a6bzps");
                object.put("textField_l7a6bzps", "NP" + object.getString("textField_l7a988ju") + str.substring(1, str.length()));
            }

            sapJson.put("ZOA_NUMBER", object.get("textField_l7a6bzps"));  //OA单据号
            sapJson.put("ZOA_TYPE", type);  //OA单据类型

            String ZLSPR = object.getString("selectField_l6bwb4ha");
            if (ZLSPR.contains("承兑")) {
                ZLSPR = "B";
            } else if (ZLSPR.contains("支票")) {
                ZLSPR = "C";
            } else if (ZLSPR.contains("信用证")) {
                ZLSPR = "L";
            } else if (ZLSPR.contains("其他")) {
                ZLSPR = "O";
            } else if (ZLSPR.contains("银行托收")) {
                ZLSPR = "T";
            } else {
                ZLSPR = "";
            }

            if (!"".equals(ZLSPR)) {
                sapJson.put("ZLSPR", ZLSPR);//付款方式
            }

            if (object.has("selectField_l6bvwdie") && (object.getString("selectField_l6bvwdie").equals("100%清预付款") || object.getString("selectField_l6bvwdie").equals("Progress/进度款"))) {
                if (sapJson.has("ZLSPR")) {
                    sapJson.remove("ZLSPR");
                }
                sapJson.put("ZLSPR", "A");//付款方式
            }
            sapJson.put("BUKRS", object.get("textField_l7a6bzpu"));       //公司代码
            sapJson.put("WAERS", object.get("selectField_l6bvh7ki"));       //币种
            sapJson.put("BLDAT", start_time);       //凭证日期ƒ
            sapJson.put("BUDAT", start_time);       //过账日期
            sapJson.put("BKTXT", "测试文本");       //抬头文本
            //JSONArray gzhangr = new JSONArray(name);
            JSONArray gzhangr = (JSONArray) object.get("employeeField_l7k7sus9");
            String uid = "TEST-CN001";
            if (gzhangr.length() > 0) {
                //textField_l6dddg5k
                JSONObject obj = new JSONObject();
                obj.put("textField_l6dddg5k", gzhangr.get(0));
                String source = dingUtil.yiDaSearch("FORM-4J7669A10FO250UJ9C6Q7CM00PC62YPW8DD6LT", obj);
                if ("[]".equals(source) || source == null) {
                    // TODO 无工号的情况
                    uid = "CHN-01000332";
                } else {
                    JSONArray data = new JSONArray(source);
                    JSONObject formData = data.getJSONObject(0).getJSONObject("formData");
                    uid = formData.get("textField_l6djch1m").toString();
                    uid = "CHN-0" + uid;
                }
            }
            //uid = "CHN-01000332";
            if (istest) {
                uid = "CHN-01307786";
                sapUrl = "https://etl-nonprod-tasks.cloud.tyson.com:443/api/1/rest/feed/run/task/TysonNonProd/Ultra_PoC/00-STG-team-fssc/tk_oa_to_sap_p2p?bearer_token=bBiGTA7PS0JJ6wKhQU8Vm0vLsIDNjLaN&interface_id=";
            }
            //uid = "CHN-01307786";//开发环境
            sapJson.put("USNAM", uid);       //过账人
            if (type.equals("NP")) {
                if (object.has("numberField_l6bxm988")) {
                    sapJson.put("ZINVOICE_AMT", object.get("numberField_l6bxm988").toString());       //发票总额
                } else {
                    sapJson.put("ZINVOICE_AMT", object.get("numberField_l6bwb4hg").toString());
                }
            } else {
                sapJson.put("ZINVOICE_AMT", "0");
            }
            if (object.get("selectField_l6bvwdie").toString().equals("100%清预付款")) {
                sapJson.put("ZINVOICE_AMT", object.get("numberField_l6bxm988").toString());//发票总额
            }
            sapJson.put("ZPAY_AMT", object.has("numberField_l6bwb4hg") ? object.get("numberField_l6bwb4hg").toString() : 0);       //支付金额
            sapJson.put("LIFNR", object.get("textField_l6bvh7kf"));       //供应商代码
            sapJson.put("KOINH", object.get("textField_l7zrpiwv"));       //收款方名称
            sapJson.put("BANKN", object.get("textField_l6bwb4hb"));       //银行账号
            sapJson.put("BANKA", object.has("selectField_l75v5c4i") ? object.get("selectField_l75v5c4i") : "");       //开户行
            sapJson.put("ZDUEDATE", CusutUtil.getFormatDate(object.getLong("dateField_l6bwb4h7")));       //到期日
            if (type.equals("NP")) {
                JSONArray SapItem = new JSONArray();       //子表
                JSONArray tableField_l6btfti5 = object.getJSONArray("tableField_l6bwb4hj");
                //50行
                if (object.getJSONArray("tableField_l6bwb4hj").length() >= 50) {
                    tableField_l6btfti5 = dingUtil.innerTables(id, "FORM-YU966T913NK2V4E4BUVZY5X8UWYR3842GVB6LA1", "tableField_l6bwb4hj");
                }
                double fpse = 0;
                String fpsm = "";
                HashMap<String, Double> fphmMap = new HashMap<>();
                for (int i = 0; i < tableField_l6btfti5.length(); i++) {
                    JSONObject jsonObject = tableField_l6btfti5.getJSONObject(i);
                    //如果税额为空，设为0
                    if (!jsonObject.has("numberField_l6bx7hqh") || "".equals(jsonObject.get("numberField_l6bx7hqh"))) {
                        jsonObject.put("numberField_l6bx7hqh", 0);
                    }
                    //如果税码为空，设为j0
                    if (!jsonObject.has("textField_l7a6bzpv") || "".equals(jsonObject.get("textField_l7a6bzpv"))) {
                        jsonObject.put("textField_l7a6bzpv", "J0");
                    }
                    //如果是分摊，第一行分配税额为税额，分配税码为税码
                    if (jsonObject.has("textField_l89lxz5r") && jsonObject.get("textField_l89lxz5r").toString().equals("分摊成本中心") && i == 0) {
                        fpse = jsonObject.getDouble("numberField_l6bx7hqh");
                        fpsm = jsonObject.getString("textField_l7a6bzpv");
                    }

                    //有发票号并且发票号不为空
                    if (jsonObject.has("textField_l6d82b5a") && !jsonObject.get("textField_l6d82b5a").toString().equals("")) {
                        //定义se=税额
                        double se = jsonObject.getDouble("numberField_l6bx7hqh");
                        //map中有对应的发票号，就在税额中加上去
                        if (fphmMap.containsKey(jsonObject.getString("textField_l6d82b5a"))) {
                            se += fphmMap.get(jsonObject.getString("textField_l6d82b5a"));
                            //移走发票号
                            fphmMap.remove(jsonObject.getString("textField_l6d82b5a"));
                        }
                        String format = new DecimalFormat("#.0000").format(se);
                        //把发票号和对应的新税额重新放入map里
                        fphmMap.put(jsonObject.getString("textField_l6d82b5a"), new Double(format));
                    }
                }
                int y = 0;
                for (int i = 0; i < tableField_l6btfti5.length(); i++) {
                    JSONObject jsonObject = tableField_l6btfti5.getJSONObject(i);
                    int n = tableField_l6btfti5.length() - 1;
                    //分摊导入非导入的数据不参与循环
//                    if (jsonObject.has("textField_l89lxz5r") && jsonObject.get("textField_l89lxz5r").toString().equals("分摊成本中心") && jsonObject.has("textField_lr0g1anf") && jsonObject.get("textField_lr0g1anf").toString().equals("")) {
//                        continue;
//                    }
                    JSONObject itemObject = new JSONObject();
                    if (i == 1) {
                        // jsonObject.remove("numberField_l6oga4zx");
                        // jsonObject.put("numberField_l6oga4zx",82.08);
                    }
                    int itemno = (y + 1);
                    String Itemno = "";
                    if (itemno < 10) {
                        Itemno += "00" + itemno;
                    } else if (itemno < 100) {
                        Itemno += "0" + itemno;
                    } else {
                        Itemno += itemno;
                    }
                    y++;
                    itemObject.put("ZOA_ITEMNO", Itemno);       //OA单据行号
                    //会计科目
                    if (!jsonObject.has("textField_l6lvt6lj") || jsonObject.getString("textField_l6lvt6lj").equals("")) {
                        JSONObject queryobj = new JSONObject();
                        if (!jsonObject.get("textField_l6q4o7od").toString().equals("")) {
                            queryobj.put("textField_l6bwtaj7", jsonObject.getString("textField_l6q4o7od"));

                            JSONArray jsonArray = new JSONArray(dingUtil.yiDaSearch("FORM-0IA66C71FCM25GLQ9NHWIATVS3WL3NR3TWB6LC", queryobj));
                            if (jsonArray.length() > 0) {
                                String string = jsonArray.getJSONObject(0).getJSONObject("formData").getString("textField_l6q1sagw");
                                if (jsonObject.has("textField_l6lvt6lj")) {
                                    jsonObject.remove("textField_l6lvt6lj");
                                }
                                jsonObject.put("textField_l6lvt6lj", string);
                            }
                        }
                    }
                    itemObject.put("HKONT", jsonObject.get("textField_l6lvt6lj"));       //会计科目
                    itemObject.put("KOSTL", jsonObject.get("textField_l6czvrgp"));       //成本中心
                    if (!jsonObject.has("numberField_l6bx7hqh") || "".equals(jsonObject.get("numberField_l6bx7hqh"))) {
                        jsonObject.put("numberField_l6bx7hqh", 0);
                    }
                    if (!jsonObject.has("textField_l7a6bzpv") || "".equals(jsonObject.get("textField_l7a6bzpv"))) {
                        jsonObject.put("textField_l7a6bzpv", "J0");
                    }
                    //会计科目等于341415，税额--0，税码--“”
                    if (itemObject.getString("HKONT").equals("341415")) {
                        jsonObject.remove("numberField_l6bx7hqh");
                        jsonObject.remove("textField_l7a6bzpv");
                        jsonObject.put("numberField_l6bx7hqh", 0);
                        jsonObject.put("textField_l7a6bzpv", "");
                    }
                    double se = Double.parseDouble(jsonObject.get("numberField_l6bx7hqh").toString().equals("") ? "0" : jsonObject.get("numberField_l6bx7hqh").toString());
                    if (fphmMap.containsKey(jsonObject.get("textField_l6d82b5a").toString())) {
                        se = fphmMap.get(jsonObject.getString("textField_l6d82b5a"));       //税额
                        fphmMap.remove(jsonObject.getString("textField_l6d82b5a"));
                        //第一行之后的税额设置为零
                        fphmMap.put(jsonObject.getString("textField_l6d82b5a"), 0.0);
                    }

                    double je;
                    if (object.get("radioField_l8cscf8n").equals("否")) {
                        je = jsonObject.getDouble("numberField_l6bwb4he");
                    } else {
                        je = jsonObject.getDouble("numberField_l6oga4zx");
                    }

                    // TODO
                    if (se == 0 && fpse > 0) {
                        se = fpse;
                        fpse = 0;
                        jsonObject.put("MWSKZ", fpsm);
                        je += se;
                    }

                    //1.4 lizzy添加if条件
                    if (jsonObject.has("textField_l89lxz5r") && jsonObject.get("textField_l89lxz5r").toString().equals("分摊成本中心")) {
                        itemObject.put("ZTAX_AMT", 0);
                        itemObject.put("ZTAXOUT_AMT", 0);       //进项税转出金额
                    } else {
                        itemObject.put("ZTAX_AMT", se);//税额
                        itemObject.put("ZTAXOUT_AMT", jsonObject.has("numberField_l6bx7hqk") ? jsonObject.get("numberField_l6bx7hqk").toString() : 0);       //进项税转出金额
                    }

                    //if(jsonObject.get("numberField_l6bx7hqk").toString().equals("")){
//10.1改大数--lizzy
                    BigDecimal jeBig = new BigDecimal(je);
                    BigDecimal roundedResult = jeBig.setScale(2, RoundingMode.HALF_UP);
                    System.out.println(roundedResult);
                    itemObject.put("DMBTR", roundedResult);//不含税金额不存在，设为金额

                    //  itemObject.put("DMBTR", je);       //不含税金额不存在，设为金额

                    itemObject.put("SGTXT", jsonObject.get("textareaField_l6bx7hqm"));       //行项目文本
                    itemObject.put("XREF1", object.get("textField_l8k0o6gi"));
                    String s = "";
                    try {
                        String substring = jsonObject.getString("associationFormField_l6yglav7_id").replaceAll("\\\\", "").substring(1);
                        String instanceId = new JSONArray(substring.substring(0, substring.length() - 1)).getJSONObject(0).getString("instanceId");
                        s = PjgetByid(instanceId, "1");
                    } catch (Exception ex) {

                    }

                    if ("JH".equals(s)) {
                        itemObject.put("MWSKZ", "JH");
                    } else {
                        itemObject.put("MWSKZ", jsonObject.get("textField_l7a6bzpv"));       //税码
                    }
                    ///测试！TODO
//                    for (int cs=0; cs < 40; cs++){
//                            itemObject.put("DMBTR", 20+cs+10);
//                            SapItem.put(itemObject);
//
//                    }
                    SapItem.put(itemObject);
                }

                /*
                 * 1.4 lizzy添加，分摊时价税分离item
                 * */
                if (object.get("radioField_l8cscf8n").toString().equals("是")) {
                    JSONObject itemObject = new JSONObject();

                    int x = tableField_l6btfti5.length() + 1;
                    String sjItemNo = "";
                    if (x < 10) {
                        sjItemNo += "00" + x;
                    } else if (x < 100) {
                        sjItemNo += "0" + x;
                    } else {
                        sjItemNo += x;
                    }
                    itemObject.put("ZOA_ITEMNO", sjItemNo);       //OA单据行号
                    itemObject.put("HKONT", "359000");       //会计科目
                    itemObject.put("KOSTL", "");       //成本中心


                    BigDecimal bigBhsje = new BigDecimal(object.get("numberField_lqp1edlt").toString());//改大数
                    bigBhsje = bigBhsje.setScale(2, RoundingMode.HALF_UP);
                    itemObject.put("DMBTR", bigBhsje);       //不含税金额

//                    itemObject.put("DMBTR", object.get("numberField_lqp1edlt").toString());       //不含税金额--支付金额
                    itemObject.put("MWSKZ", "");       //税码
                    itemObject.put("ZTAX_AMT", "0");       //税额
                    itemObject.put("ZTAXOUT_AMT", "0");       //进项税转出金额
                    itemObject.put("SGTXT", "");       //行项目文本
                    itemObject.put("XREF1", object.get("textField_l8k0o6gi")); //cir项目号
                    SapItem.put(itemObject);

                }
                sapJson.put("ITEM", SapItem);
            } else {
                JSONArray SapItem = new JSONArray();       //子表
                JSONObject itemObject = new JSONObject();
                itemObject.put("ZOA_ITEMNO", "001");       //OA单据行号
                itemObject.put("HKONT", "");       //会计科目
                itemObject.put("KOSTL", "");       //成本中心

                BigDecimal bigBhsje = new BigDecimal(object.get("numberField_l6bwb4hg").toString());//改大数
                bigBhsje = bigBhsje.setScale(2, RoundingMode.HALF_UP);
                itemObject.put("DMBTR", bigBhsje);       //不含税金额

//                itemObject.put("DMBTR", object.get("numberField_l6bwb4hg").toString());       //不含税金额--支付金额
                itemObject.put("MWSKZ", "");       //税码
                itemObject.put("ZTAX_AMT", "0");       //税额
                itemObject.put("ZTAXOUT_AMT", "0");       //进项税转出金额
                itemObject.put("SGTXT", "");       //行项目文本
                itemObject.put("XREF1", object.get("textField_l8k0o6gi")); //cir项目号
                SapItem.put(itemObject);
                sapJson.put("ITEM", SapItem);
            }
            if (object.getString("selectField_l6bvwdie").contains("进度款")) {
                type = "AD";
                sapJson.put("ZINVOICE_AMT", object.get("numberField_l6bxm988").toString());

                sapJson.remove("ZOA_TYPE");  //OA单据类型
                sapJson.put("ZOA_TYPE", type);  //OA单据类型
            }

            System.out.println(sapJson);
            log.info("sapJson-------->>>{}", sapJson);
            logger.info("发起POST请求：URL={},参数={}", QA_sapUrl + "SAP005", sapJson);
//            String post = "";
            // TODO url
            String post = HttpUtil.post(QA_sapUrl + "SAP005", null, sapJson.toString(), null);
//            JSONArray post = new JSONArray();
//            JSONObject jsonObject = new JSONObject();
//            jsonObject.put("E_BELNR","1930000034;");
//            jsonObject.put("E_MESSAGE","SUCCESS");
//            post.put(jsonObject);

            logger.info("POST请求完成：响应={}", post);
            if (!post.equals("")) {
                System.out.println(post);
                JSONArray jsonArray = new JSONArray(post);
                if (jsonArray.length() > 0) {
                    JSONObject postJsonObject = jsonArray.getJSONObject(0);
                    System.out.println(postJsonObject.get("E_MESSAGE"));
                    if (!postJsonObject.getString("E_BELNR").equals("")) {
                        upJson.put("textField_l701yhu3", postJsonObject.getString("E_BELNR"));
                        upJson.put("dateField_l701yhu7", CusutUtil.dateTOtimeshapYYMMDD(start_time));
                        upJson.put("dateField_l701yhua", CusutUtil.dateTOtimeshapYYMMDD(start_time));
                        upJson.put("textField_l701yhu6", name);
                    }
                    upJson.put("textField_l7a6bzpw", postJsonObject.get("E_MESSAGE"));
                }
            }

            dingUtil.UpdateYiDa(id, upJson);
            logger.info(" YiDa Update : " + id + " => " + upJson.toString());
            if (upJson.has("textField_l701yhu3")) {
                if (!"".equals(upJson.get("textField_l701yhu3")) && !";".equals(upJson.get("textField_l701yhu3"))) {
                    System.out.println(upJson.get("textField_l701yhu3"));
                    logger.info(upJson.get("textField_l701yhu3").toString());
                    Thread.sleep(3000);
                    bookkeeping(id, "NP");
                }
            }
            CusutUtil.SuccessReturnJsonString(200, "成功", "str");
        } catch (Exception ex) {
            ex.printStackTrace();
            CusutUtil.SuccessReturnJsonString(500, "接口异常500,请联系管理员或开发者处理", "str");
        }
    }

    Object has(JSONObject jo, String key) {
        if (jo.has(key) && !jo.get(key).toString().toLowerCase().equals("null")) {
            return jo.get(key);
        }
        return "";
    }


    /***
     *抵扣预付
     */
    public void DKYF(String id) {
        try {
            JSONObject object = new JSONObject(dingUtil.getYidaById(id));
            System.out.println(object);
            String jsonStr = object.getString("associationFormField_lr4n015p_id").replaceAll("\\\\", "").substring(1);

            //JSONObject jsonObject = object.getJSONObject("associationFormField_lr4n015p_id");
            //String jsonStr = jsonObject.getString("associationFormField_lr4n015p_id");
            BigDecimal reduceMoney = object.getBigDecimal("numberField_l6bxm988");

            reduceAdvance(jsonStr, reduceMoney);

            CusutUtil.SuccessReturnJsonString(200, "成功", "str");
        } catch (Exception ex) {
            ex.printStackTrace();
            CusutUtil.SuccessReturnJsonString(500, "接口异常500,请联系管理员或开发者处理", "str");
        }

    }

    public void reduceAdvance(String t, BigDecimal reduceMoney) {
        try {
            //JSON
            log.info("要处理的json是：{}", t);
            JSONArray jsonArray = new JSONArray(t);
            //DateTimeFormatter formatter = DateTimeFormatter.ofPattern("yyyy年MM月dd日");
            //DateTimeFormatter formatter = DateTimeFormatter.ofPattern("yyyy-MM-dd-");
            List<DeductionVo> list = new ArrayList<>();

            for (Object obj : jsonArray) {
                JSONObject jsonObject = new JSONObject(obj.toString());
                String instanceIdStr = (String) jsonObject.get("instanceId");
                log.info("instanceId : {}", instanceIdStr);
                String yidaByIdStr = dingUtil.getYidaById(instanceIdStr);
                log.info(yidaByIdStr);
                JSONObject jsonObj = new JSONObject(yidaByIdStr);
                Long timestamp = jsonObj.getLong("dateField_l9nsavm3");

                // 将毫秒时间戳转换为Instant对象
                Instant instant = Instant.ofEpochMilli(timestamp);
                // 根据系统默认时区将Instant对象转换为LocalDateTime
                LocalDateTime localDateTime = instant.atZone(ZoneId.systemDefault()).toLocalDateTime();
                // 从LocalDateTime获取LocalDate
                LocalDate date = localDateTime.toLocalDate();

                BigDecimal pay = jsonObj.getBigDecimal("numberField_l9nwaike");

                DeductionVo deductionVo = new DeductionVo();
                deductionVo.setId(instanceIdStr);
                deductionVo.setDate(date);
                deductionVo.setMoney(pay);
                list.add(deductionVo);
            }
            // 排序
            List<DeductionVo> sortList = list.stream().sorted(Comparator.comparing(DeductionVo::getDate)).collect(Collectors.toList());
            // 按照顺序扣减
            for (DeductionVo deductionVo : sortList) {

                BigDecimal money = deductionVo.getMoney();
                int code = reduceMoney.compareTo(money);
                if (code >= 0) {
                    // reduceMoney 大
                    reduceMoney = reduceMoney.subtract(money);
                    deductionVo.setMoney(BigDecimal.ZERO);
                } else {
                    deductionVo.setMoney(money.subtract(reduceMoney));
                    reduceMoney = BigDecimal.ZERO;
                    break;
                }
            }

            for (DeductionVo deductionVo : sortList) {
                String id = deductionVo.getId();
                String yidaByIdStr = dingUtil.getYidaById(id);
                JSONObject jsonObj = new JSONObject(yidaByIdStr);
                jsonObj.put("numberField_l9nwaike", deductionVo.getMoney());

                log.info("jsonObj:{}", jsonObj);
                dingUtil.UpdateYiDa(id, jsonObj);
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
    }


    String RTR_url = "https://etl-nonprod-tasks.cloud.tyson.com:443/api/1/rest/feed/run/task/TysonNonProd/Ultra_PoC/20-PREPROD-team-fssc/tk_oa_to_sap_p2p?bearer_token=bBiGTA7PS0JJ6wKhQU8Vm0vLsIDNjLaN&interface_id=";
//    String OTC_URL = "https://etl-nonprod-tasks.cloud.tyson.com/api/1/rest/feed/run/task/TysonNonProd/Ultra_PoC/00-STG-team-fssc/tk_oa_to_sap_o2c?bearer_token=Fo1SLHus9rk9gFQlYHvLJpx9eenPG3QE&interface_id=SAP009";


    /***
     * 总账通用工单
     * @return
     */
    @Async
    public void SACreatePZ(String id, String name) {
        try {
            Thread.sleep(3000);
            JSONObject upJson = new JSONObject();
            String start_time = CusutUtil.getNowDate("yyyyMMdd");
            System.out.println("SA");
            JSONObject object = new JSONObject(dingUtil.getYidaById(id));
            JSONObject sapJson = new JSONObject();
            String type = "SA";

            while (true) {
                JSONObject cobj = new JSONObject();
                cobj.put("textField_l8jygtyf", object.get("textField_l8jygtyf"));
                long cdata = dingUtil.yiDaSearch2("FORM-3J866L819YI3M8ND7DFPSBLD6OP93J9M1AH7L3", cobj);
                if (cdata > 1) {
                    cobj = new JSONObject();
                    cobj.put("textField_l7ha72uf", object.get("textField_l7ha72uf"));
                    cdata = dingUtil.yiDaSearch2("FORM-3J866L819YI3M8ND7DFPSBLD6OP93J9M1AH7L3", cobj);
                    String str = (100000 + cdata + 1) + "";

                    object.remove("textField_l8jygtyf");
                    object.put("textField_l8jygtyf", object.getString("textField_l7ha72uf") + str.substring(1, str.length()));
                    upJson.put("textField_l8jygtyf", object.getString("textField_l7ha72uf") + str.substring(1, str.length()));
                } else {
                    break;
                }
            }

            if (object.has("dateField_l7ha72v1") && !object.get("dateField_l7ha72v1").toString().equals("")) {
                start_time = CusutUtil.getFormatDate(object.getLong("dateField_l7ha72v1"));
            }

            sapJson.put("ZOA_NUMBER", object.get("textField_l8jygtyf"));  //OA单据号
            sapJson.put("ZOA_TYPE", "GL");  //OA单据类型
            sapJson.put("ZLSPR", "");//付款方式
            sapJson.put("BUKRS", object.get("selectField_l8jygtyn"));       //公司代码
            sapJson.put("BLART", "Z5");      //凭证类型
            sapJson.put("WAERS", object.get("selectField_l7ha72vc"));       //币种

            if (object.has("dateField_l7ha72ut") && !"".equals(object.get("dateField_l7ha72ut").toString())) {
                sapJson.put("BLDAT", CusutUtil.getFormatDate(object.getLong("dateField_l7ha72ut")));       //凭证日期
            } else {
                sapJson.put("BLDAT", start_time);       //凭证日期
            }
            if (object.has("dateField_l7ha72v1") && !"".equals(object.get("dateField_l7ha72v1").toString())) {
                sapJson.put("BUDAT", CusutUtil.getFormatDate(object.getLong("dateField_l7ha72v1")));       //凭证日期
            } else {
                sapJson.put("BUDAT", start_time);       //过账日期
            }

            sapJson.put("BKTXT", has(object, "textField_liifjjsd"));       //抬头文本
            JSONArray gzhangr = new JSONArray(name);
            String uid = "TEST-CN001";
            String uname = "";
            if (gzhangr.length() > 0) {
                JSONObject obj = new JSONObject();
                obj.put("textField_l6dddg5k", gzhangr.get(0));
                JSONArray data = new JSONArray(dingUtil.yiDaSearch("FORM-4J7669A10FO250UJ9C6Q7CM00PC62YPW8DD6LT", obj));
                JSONObject formData = data.getJSONObject(0).getJSONObject("formData");
                uid = formData.get("textField_l6djch1m").toString();
                uid = "CHN-0" + uid;
                uname = formData.get("textField_l6dddg5j").toString();
            }

            //             uid = "CHN-01307786";//开发环境
            sapJson.put("USNAM", uid);       //过账人

            sapJson.put("ZINVOICE_AMT", 0);    //发票总额
            sapJson.put("ZPAY_AMT", 0);       //支付金额
            sapJson.put("LIFNR", "");       //供应商代码
            sapJson.put("KOINH", "");       //收款方名称
            sapJson.put("BANKN", "");       //银行账号
            sapJson.put("BANKA", "");       //开户行
            sapJson.put("ZDUEDATE", start_time);       //到期日
            sapJson.put("UMSKZ", ""); // 特别总账标识


            JSONArray SapItem = new JSONArray();       //子表
            JSONArray tableField_l7ha72vf = object.getJSONArray("tableField_l7ha72vf");
            if (tableField_l7ha72vf.length() == 50) {
                tableField_l7ha72vf = dingUtil.innerTables(id, "FORM-3J866L819YI3M8ND7DFPSBLD6OP93J9M1AH7L3", "tableField_l7ha72vf");
            }
            int index = 0;

            JSONObject queryJs = new JSONObject();
            JSONObject obj = new JSONObject();
            obj.put("textField_l6emcrsc", object.getString("textField_l8k1lu0t"));
            String s = dingUtil.yiDaSearch("FORM-AC666081PXI3B3KMD80PM87WGVVF3XP0UAH7L4", obj);
            JSONArray jsonArrayq = new JSONArray(s);
            if (jsonArrayq.length() > 0) {
                queryJs = jsonArrayq.getJSONObject(0).getJSONObject("formData");
            }

            for (int i = 0; i < tableField_l7ha72vf.length(); i++) {
                JSONObject jsonObject = tableField_l7ha72vf.getJSONObject(i);
                JSONObject itemObject = new JSONObject();
                int itemno = (index + 1);
                String Itemno = "";
                if (itemno < 10) {
                    Itemno += "00" + itemno;
                } else if (itemno < 100) {
                    Itemno += "0" + itemno;
                } else {
                    Itemno += itemno;
                }
                index++;
                itemObject.put("ZOA_ITEMNO", Itemno);       //OA单据行号
                //queryJs
                //科目
                if (!jsonObject.has("textField_l7ha72vp")) {
                    jsonObject.put("textField_l7ha72vp", queryJs.get("textField_l701lsek"));
                }
                if (jsonObject.get("textField_l7ha72vp").toString().equals("")) {
                    jsonObject.remove("textField_l7ha72vp");
                    jsonObject.put("textField_l7ha72vp", queryJs.get("textField_l701lsek"));
                }
                //项目文本
                if (!jsonObject.has("textareaField_l7ha72vm")) {
                    jsonObject.put("textareaField_l7ha72vm", object.get("textField_liifjjsd"));
                }
                if (jsonObject.get("textareaField_l7ha72vm").toString().equals("")) {
                    jsonObject.remove("textareaField_l7ha72vm");
                    jsonObject.put("textareaField_l7ha72vm", object.get("textField_liifjjsd"));
                }
                //借/贷
                if (!jsonObject.has("selectField_l7ha72vr")) {
                    jsonObject.put("selectField_l7ha72vr", "借方");
                }
                if (jsonObject.get("selectField_l7ha72vr").toString().equals("")) {
                    jsonObject.remove("selectField_l7ha72vr");
                    jsonObject.put("selectField_l7ha72vr", "借方");
                }

                itemObject.put("HKONT", jsonObject.get("textField_l7ha72vp"));       //会计科目
                itemObject.put("KOSTL", jsonObject.get("textField_l7ha72vz"));       //成本中心
                itemObject.put("ZTAX_AMT", "0");//税额

                BigDecimal bigBhsje = BigDecimal.valueOf(jsonObject.getDouble("numberField_l7ha72vu"));//改大数
                bigBhsje = bigBhsje.setScale(2, RoundingMode.HALF_UP);
                itemObject.put("DMBTR", bigBhsje);       //不含税金额

//                itemObject.put("DMBTR", jsonObject.getDouble("numberField_l7ha72vu"));       //不含税金额
                itemObject.put("ZTAXOUT_AMT", "0");       //进项税转出金额
                itemObject.put("SGTXT", jsonObject.get("textareaField_l7ha72vm"));       //行项目文本
                itemObject.put("XREF1", jsonObject.get("textField_l7ha72w9"));//参考码1
                itemObject.put("MWSKZ", has(jsonObject, "selectField_l7ha72w5"));       //税码
                itemObject.put("SHKZG", jsonObject.getString("selectField_l7ha72vr").equals("借方") ? "S" : "H");       //借/贷
                itemObject.put("AUFNR", jsonObject.get("textField_l7ha72w1"));       //订单
                itemObject.put("PS_POSID", jsonObject.get("textField_l7ha72w3"));       //WPS
                itemObject.put("ZUONR", jsonObject.get("textField_l7ha72w8"));       //分配

                SapItem.put(itemObject);
            }
            if (object.has("tableField_lkuuoaku")) {
                JSONArray tableField_lkuuoaku = object.getJSONArray("tableField_lkuuoaku");


                for (int i = 0; i < tableField_lkuuoaku.length(); i++) {
                    JSONObject jsonObject = tableField_lkuuoaku.getJSONObject(i);
                    System.out.println(jsonObject);
                    JSONObject itemObject = new JSONObject();
                    int itemno = (index + 1);
                    String Itemno = "";
                    if (itemno < 10) {
                        Itemno += "00" + itemno;
                    } else if (itemno < 100) {
                        Itemno += "0" + itemno;
                    } else {
                        Itemno += itemno;
                    }
                    index++;
                    if (jsonObject.get("textareaField_lkuuoakh").toString().equals("")) {
                        break;
                    }
                    itemObject.put("ZOA_ITEMNO", Itemno);       //OA单据行号
                    //科目
                    if (!jsonObject.has("textField_lkuuoaki")) {
                        jsonObject.put("textField_lkuuoaki", queryJs.get("textField_l7havtaq"));
                    }
                    if (jsonObject.get("textField_lkuuoaki").toString().equals("")) {
                        jsonObject.remove("textField_lkuuoaki");
                        jsonObject.put("textField_lkuuoaki", queryJs.get("textField_l7havtaq"));
                    }
                    //项目文本
                    if (!jsonObject.has("textareaField_lkuuoakh")) {
                        jsonObject.put("textareaField_lkuuoakh", object.get("textField_liifjjsd"));
                    }
                    if (jsonObject.get("textareaField_lkuuoakh").toString().equals("")) {
                        jsonObject.remove("textareaField_lkuuoakh");
                        jsonObject.put("textareaField_lkuuoakh", object.get("textField_liifjjsd"));
                    }
                    //借/贷
                    if (!jsonObject.has("selectField_lkuuoakl")) {
                        jsonObject.put("selectField_lkuuoakl", "贷方");
                    }
                    if (jsonObject.get("selectField_lkuuoakl").toString().equals("")) {
                        jsonObject.remove("selectField_l7ha72vr");
                        jsonObject.put("selectField_lkuuoakl", "贷方");
                    }
                    itemObject.put("HKONT", jsonObject.get("textField_lkuuoaki"));       //会计科目
                    itemObject.put("KOSTL", jsonObject.get("textField_lkuuoakn"));       //成本中心
                    itemObject.put("ZTAX_AMT", "0");//税额

                    BigDecimal bigBhsje = BigDecimal.valueOf(jsonObject.getDouble("numberField_lkuuoakm"));//改大数
                    bigBhsje = bigBhsje.setScale(2, RoundingMode.HALF_UP);
                    itemObject.put("DMBTR", bigBhsje);       //不含税金额

//                    itemObject.put("DMBTR", jsonObject.getDouble("numberField_lkuuoakm"));       //不含税金额
                    itemObject.put("ZTAXOUT_AMT", "0");       //进项税转出金额
                    itemObject.put("SGTXT", jsonObject.get("textareaField_lkuuoakh"));       //行项目文本
                    itemObject.put("XREF1", jsonObject.get("textField_lkuuoakt"));//参考码1
                    itemObject.put("MWSKZ", has(jsonObject, "selectField_lkuuoakr"));       //税码
                    itemObject.put("SHKZG", jsonObject.getString("selectField_lkuuoakl").equals("借方") ? "S" : "H");       //借/贷
                    itemObject.put("AUFNR", jsonObject.get("textField_lkuuoakp"));       //订单
                    itemObject.put("PS_POSID", jsonObject.get("textField_lkuuoakq"));       //WPS
                    itemObject.put("ZUONR", jsonObject.get("textField_lkuuoaks"));       //分配

                    SapItem.put(itemObject);
                }
            }
            sapJson.put("ITEM", SapItem);

            logger.info("发起POST请求：url={},参数={}", RTR_url + "SAP005", sapJson);
            System.out.println(sapJson);
//            String post = "";
            System.out.println(RTR_url + "SAP005");

            String post = HttpUtil.post(RTR_url + "SAP005", null, sapJson.toString(), null);

            logger.info("POST请求：响应={}", post);

            if (!post.equals("")) {
                System.out.println(post);
                JSONArray jsonArray = new JSONArray(post);
                if (jsonArray.length() > 0) {
                    JSONObject postJsonObject = jsonArray.getJSONObject(0);
                    System.out.println(postJsonObject.get("E_MESSAGE"));
                    if (!postJsonObject.getString("E_BELNR").equals("")) {
                        String e_belnr = postJsonObject.getString("E_BELNR");
                        if (e_belnr.contains(";")) {
                            String[] split = e_belnr.split(";");
                            try {
                                e_belnr = split[0] + ";";
                            } catch (Exception ex) {
                                e_belnr = ";";
                            }

                        }
                        upJson.put("textField_l7ha72vi", e_belnr);
                        upJson.put("textField_lmsu6l5r", uname);
                        upJson.put("textField_l7a7bf8h", name);
                    }
                    upJson.put("textareaField_lhoeg8oq", postJsonObject.get("E_MESSAGE"));
                }
            }

            logger.info(" YiDa Update : " + id + " => " + upJson.toString());
            dingUtil.UpdateYiDa(id, upJson);

            CusutUtil.SuccessReturnJsonString(200, "成功", "str");
        } catch (Exception ex) {
            ex.printStackTrace();
            CusutUtil.SuccessReturnJsonString(500, "接口异常500,请联系管理员或开发者处理", "str");
        }
    }

    @Async
    public void SAXY(String id) {
        try {
            Thread.sleep(3000);
            JSONObject upJson = new JSONObject();
            JSONObject object = new JSONObject(dingUtil.getYidaById(id));

            if (object.getString("radioField_l8jt1ad8").equals("冲销")) {
                return;
            }
            while (true) {
                JSONObject cobj = new JSONObject();
                cobj.put("textField_l8jygtyf", object.get("textField_l8jygtyf"));
                long cdata = dingUtil.yiDaSearch2("FORM-3J866L819YI3M8ND7DFPSBLD6OP93J9M1AH7L3", cobj);
                if (cdata > 1) {
                    cobj = new JSONObject();
                    cobj.put("textField_l7ha72uf", object.get("textField_l7ha72uf"));
                    cdata = dingUtil.yiDaSearch2("FORM-3J866L819YI3M8ND7DFPSBLD6OP93J9M1AH7L3", cobj);
                    String str = (100000 + cdata + 1) + "";

                    object.remove("textField_l8jygtyf");
                    object.put("textField_l8jygtyf", object.getString("textField_l7ha72uf") + str.substring(1, str.length()));
                    upJson.put("textField_l8jygtyf", object.getString("textField_l7ha72uf") + str.substring(1, str.length()));
                } else {
                    break;
                }
            }

            JSONObject queryJs = new JSONObject();
            JSONObject obj = new JSONObject();
            obj.put("textField_l6emcrsc", object.getString("textField_l8k1lu0t"));
            String s = dingUtil.yiDaSearch("FORM-AC666081PXI3B3KMD80PM87WGVVF3XP0UAH7L4", obj);
            JSONArray jsonArrayq = new JSONArray(s);
            if (jsonArrayq.length() > 0) {
                queryJs = jsonArrayq.getJSONObject(0).getJSONObject("formData");
            }
            JSONArray tableField_l7ha72vf = object.getJSONArray("tableField_l7ha72vf");
            if (tableField_l7ha72vf.length() == 50) {
                tableField_l7ha72vf = dingUtil.innerTables(id, "FORM-3J866L819YI3M8ND7DFPSBLD6OP93J9M1AH7L3", "tableField_l7ha72vf");
            }
            JSONArray objects = new JSONArray();
            for (int i = 0; i < tableField_l7ha72vf.length(); i++) {
                JSONObject jsonObject = tableField_l7ha72vf.getJSONObject(i);

                //项目文本
                if (!jsonObject.has("textareaField_l7ha72vm")) {
                    jsonObject.put("textareaField_l7ha72vm", object.get("textField_liifjjsd"));
                }
                if (jsonObject.get("textareaField_l7ha72vm").toString().equals("")) {
                    jsonObject.remove("textareaField_l7ha72vm");
                    jsonObject.put("textareaField_l7ha72vm", object.get("textField_liifjjsd"));
                }
                //借/贷
                if (!jsonObject.has("selectField_l7ha72vr")) {
                    jsonObject.put("selectField_l7ha72vr", "借方");
                }
                if (jsonObject.get("selectField_l7ha72vr").toString().equals("")) {
                    jsonObject.remove("selectField_l7ha72vr");
                    jsonObject.put("selectField_l7ha72vr", "借方");
                }

                if (object.getString("radioField_l8jt1ad8").equals("计提") && object.getString("selectField_llevrew6").equals("业务部门")) {
                    jsonObject.remove("selectField_l7ha72vr");
                    jsonObject.put("selectField_l7ha72vr", "借方");
                }
                //科目
                if (!jsonObject.has("textField_l7ha72vp")) {
                    if (jsonObject.get("selectField_l7ha72vr").toString().equals("借方")) {
                        jsonObject.put("textField_l7ha72vp", queryJs.get("textField_l701lsek"));
                    } else {
                        jsonObject.put("textField_l7ha72vp", queryJs.get("textField_l7havtaq"));
                    }
                }
                if (!jsonObject.has("textField_l7ha72vq")) {
                    jsonObject.put("textField_l7ha72vq", "");
                }
                //科目名称
                if (jsonObject.get("textField_l7ha72vq").toString().equals("")) {

                    if (jsonObject.get("selectField_l7ha72vr").toString().equals("借方")) {
                        jsonObject.put("textField_l7ha72vq", queryJs.get("textField_l6emcrsi"));
                    } else {
                        jsonObject.put("textField_l7ha72vq", queryJs.get("textField_l6emcrsk"));
                    }
                }

                if (jsonObject.get("textField_l7ha72vp").toString().equals("")) {
                    jsonObject.remove("textField_l7ha72vp");
                    if (jsonObject.get("selectField_l7ha72vr").toString().equals("借方")) {
                        jsonObject.put("textField_l7ha72vp", queryJs.get("textField_l701lsek"));
                    } else {
                        jsonObject.put("textField_l7ha72vp", queryJs.get("textField_l7havtaq"));
                    }
                }


                objects.put(jsonObject);
            }
            upJson.put("tableField_l7ha72vf", objects);
//            System.out.println(upJson);
            logger.info(" YiDa Update : " + id + " => " + upJson.toString());
            dingUtil.UpdateYiDa(id, upJson);
        } catch (Exception ex) {
            ex.printStackTrace();
        }
    }

    /***
     * SA冲销
     * @return
     */
    @Async
    public String SARemove(String id, String name) {
        try {
            JSONObject upJson = new JSONObject();
            String start_time = CusutUtil.getNowDate("yyyyMMdd");
            JSONArray gzhangr = new JSONArray(name);
            String uid = "TEST-CN001";
            String uname = "";
            if (gzhangr.length() > 0) {
                JSONObject obj = new JSONObject();
                obj.put("textField_l6dddg5k", gzhangr.get(0));
                JSONArray data = new JSONArray(dingUtil.yiDaSearch("FORM-4J7669A10FO250UJ9C6Q7CM00PC62YPW8DD6LT", obj));
                JSONObject formData = data.getJSONObject(0).getJSONObject("formData");
                uid = formData.get("textField_l6djch1m").toString();
                uid = "CHN-0" + uid;
                uname = formData.get("textField_l6dddg5j").toString();
            }
            JSONObject object = new JSONObject(dingUtil.getYidaById(id));
            JSONObject sapJson = new JSONObject();
            sapJson.put("ZOA_NUMBER", object.get("textField_lnlf141a"));  //OA单据号改成textField_lnlf141a
//            sapJson.put("ZOA_NUMBER","6600-GL230900015");
            sapJson.put("ZOA_TYPE", "SA");  //OA单据类型
            sapJson.put("BUKRS", object.get("selectField_l8jygtyn"));       //公司代码
            sapJson.put("BELNR", object.get("textField_l7ha72v8"));      //凭证编号
            sapJson.put("GJAHR", CusutUtil.getFormatDateYY(object.getLong("dateField_lkvyrr4p")));       //会计年度
            sapJson.put("STGRD", object.get("textField_l7jvjyog"));       //冲销原因
            //过账日期
            if (object.has("dateField_l7ha72v1") && !"".equals(object.get("dateField_l7ha72v1").toString())) {
                sapJson.put("BUDAT", CusutUtil.getFormatDate(object.getLong("dateField_l7ha72v1")));       //凭证日期
            } else {
                sapJson.put("BUDAT", start_time);       //过账日期
            }

            sapJson.put("USNAM", uid);  //过账人
            logger.info("发起POST请求：url={},参数={}", RTR_url + "SAP006", sapJson);
            System.out.println(sapJson);
            String post = HttpUtil.post(RTR_url + "SAP006", null, sapJson.toString(), null);
            System.out.println(post);
            logger.info("POST请求：响应={}", post);

            if (!post.equals("")) {
                JSONObject postJsonObject = new JSONArray(post).getJSONObject(0);
                System.out.println(postJsonObject.get("E_MESSAGE"));
                if (!postJsonObject.getString("E_BELNR").equals("")) {
                    upJson.put("textField_l7ha72vi", postJsonObject.getString("E_BELNR"));
                    //   upJson.put("dateField_l7a7bf88", CusutUtil.dateTOtimeshapYYMMDD(start_time));
//                    upJson.put("textField_l701yhu4", remake);
                    upJson.put("textField_lmsu6l5r", uname);
                }
            }
            logger.info(" YiDa Update : " + id + " => " + upJson.toString());
            dingUtil.UpdateYiDa(id, upJson);
            return CusutUtil.SuccessReturnJsonString(200, "成功", "str");
        } catch (Exception ex) {
            ex.printStackTrace();
            return CusutUtil.SuccessReturnJsonString(500, "接口异常500,请联系管理员或开发者处理", "str");
        }
    }

    /***
     * 查询票夹数据 -byId -通用//
     * @param id
     * @return
     */
    public String PjgetByid(String id, String oper) {
        try {
            JSONObject object = new JSONObject(dingUtil.getYidaById(id));
            if (!object.has("textField_l6u55vd8")) {
                return "";
            }
            if (!object.getString("textField_l6u55vd8").contains("发票") && !object.getString("textField_l6u55vd8").contains("全电")) {
                return "";
            }
            if (object.getString("textField_l6u55vd3").equals("") && object.getString("textField_l6u55vd9").equals("")) {
                return "";
            }

            String sh = object.getString("textField_l6u55vdn");
            String s = "";
            if (sh != "") {
                try {
                    s = HttpUtil.get("http://106.15.251.153:8091/stms/openapi/ts/income/getDeadLine/" + sh);
                    if ("".equals(s)) {
                        return "";
                    }
                } catch (Exception ex) {
                    s = "error";
                }
            }
//            if(true){
            if (true) {
                if (!s.equals("error")) {
                    if ("".equals(s)) {
                        return "";
                    }
                    JSONObject ssqJson = new JSONObject(s);
                    if (ssqJson.has("code") && ssqJson.getInt("code") == 200) {
                        String kgxrgz = ssqJson.getJSONObject("data").getString("kgxrqz");
                        String kprq = CusutUtil.getFormatDate(object.getLong("dateField_l6u55vdg"));
                        SimpleDateFormat sdf = new SimpleDateFormat("yyyyMMdd");
                        try {
                            Date kgxrgz_date = sdf.parse(kgxrgz);
                            Date kprq_date = sdf.parse(kprq);

                            if (kgxrgz_date.compareTo(kprq_date) < 0) {
                                JSONObject jsonObject = new JSONObject();
                                jsonObject.put("textField_l7efm5az", "系统异常:发票日期超过结账日,不予勾选");
                                logger.info(" YiDa Update : " + id + " => " + jsonObject.toString());
                                dingUtil.UpdateYiDa(id, jsonObject);
                                return "JH";
                            }
                        } catch (ParseException e) {
                            e.printStackTrace();
                        } catch (Exception e) {
                            e.printStackTrace();
                        }
                    }
                }
                if (object.getString("textField_l6vk7131").equals("泰森(江苏)畜禽业发展有限公司")) {
                    return "";
                }

                JSONObject jsonObject = new JSONObject();
                jsonObject.put("taxno", object.getString("textField_l6u55vdn"));
                if (object.getString("textField_l6u55vd8").contains("全电")) {
                    jsonObject.put("invoicecode", "全电发票");
                } else {
                    jsonObject.put("invoicecode", object.getString("textField_l6u55vd9"));
                }
                jsonObject.put("invoicenumber", object.getString("textField_l6u55vd3"));
                jsonObject.put("usetax", object.get("textField_l6vu65fs").toString());
                try {
                    if (!object.has("textField_l6vvuq3f") || object.getString("textField_l6vvuq3f").equals("")) {
                        object.remove("textField_l6vvuq3f");
                        object.put("textField_l6vvuq3f", "0");
                    }
                    jsonObject.put("taxrate", Double.parseDouble(object.getString("textField_l6vvuq3f").substring(0, object.getString("textField_l6vvuq3f").lastIndexOf("%"))) / 100);
                } catch (Exception ex) {
                    try {
                        jsonObject.put("taxrate", Double.parseDouble(object.getString("textField_l6vvuq3f")) / 100);
                    } catch (Exception ex2) {
                        jsonObject.put("taxrate", 0);
                    }
                }
                jsonObject.put("autodeduct", "1");
                jsonObject.put("oper", oper);

                return jsonObject.toString();
            }
        } catch (Exception exception) {
            exception.printStackTrace();
        }
        return "";
    }


    /***
     * PO数据校验
     */
    @Async
    public String POXY(String id, String user, String dept) {
        try {
            System.out.println("PO数据校验");
            System.out.println(id);
            JSONObject jsonObject = new JSONObject(dingUtil.getYidaById(id));

            JSONObject upjson = new JSONObject();
            upjson.put("employeeField_l6btftib", user);
            String MM = CusutUtil.getFormatDateMM(jsonObject.getLong("dateField_l6btfthk"));

            String tt = "PO";
            if (jsonObject.getString("selectField_l6btftfn").contains("预付") || jsonObject.getString("selectField_l6btftfn").contains("进度")) {
                tt = "AD";
            }
            String YY = jsonObject.getString("textField_l6x1rkjh").substring(2, 4);
            String value = jsonObject.getString("textField_l6c19doa") + YY;

            if (jsonObject.has("textField_l6btftfv")) {
                upjson.put("selectField_l7o5kch0", jsonObject.getString("textField_l6btftfv"));
            }

            upjson.put("textField_l7a5euts", "无");
            if (jsonObject.has("numberField_l6czvx0g")) {
                upjson.put("numberField_l6czvx0w", jsonObject.get("numberField_l6czvx0g"));
            }
//            if(jsonObject.get("textField_l6czvx07"))

            JSONObject object = new JSONObject();
            if (!jsonObject.get("textField_l6czvx07").toString().equals("")) {
                object.put("textField_l6czvx07", jsonObject.get("textField_l6czvx07"));
                object.put("textField_l6x1rkjh", jsonObject.get("textField_l6x1rkjh"));
                JSONArray query_qchong = new JSONArray(dingUtil.yiDaSearch("FORM-GC9664C1ALL2G3G5D6ZGNCYLX1FF2DG29TB6LQ", object));
                if (query_qchong.length() > 1) {
                    dingUtil.delete(id);
                    logger.info("DELETE:" + id);
                    return CusutUtil.SuccessReturnJsonString(200, "成功", "str");
                }
            }
            upjson.put("textField_l7a7xqg2", value);
            JSONObject obj = new JSONObject();
            obj.put("textField_l9qg8a8n", upjson.get("textField_l7a7xqg2"));
            JSONArray data = new JSONArray(dingUtil.yiDaSearch("FORM-WC9666911ZP308OTCINEF5VM2HKC2HI42GQ9LG7", obj));
            String str = (100000 + data.length() + 1) + "";
            if (data.length() > 0) {
                str = (100000 + data.getJSONObject(0).getJSONObject("formData").getInt("numberField_l9qnm4yt") + 1) + "";
                obj.put("numberField_l9qnm4yt", data.getJSONObject(0).getJSONObject("formData").getInt("numberField_l9qnm4yt") + 1);

                logger.info(" YiDa Update : " + data.getJSONObject(0).getString("formInstanceId") + " => " + obj.toString());
                dingUtil.UpdateYiDa(data.getJSONObject(0).getString("formInstanceId"), obj);
            } else {
                obj.put("numberField_l9qnm4yt", 1);
                String res = dingUtil.saveYiDa("FORM-WC9666911ZP308OTCINEF5VM2HKC2HI42GQ9LG7", obj, dingConst.getUserId());
                logger.info("YiDa Return Data :" + res);
            }

            upjson.put("textField_l7a342k7", upjson.getString("textField_l7a7xqg2") + str.substring(1, str.length()));
            upjson.put("numberField_l6btftia", jsonObject.get("numberField_l6czvx0g"));
            upjson.put("textField_l7a342kc", MM);
            upjson.put("textField_l6c19doc", jsonObject.get("textField_l6c19dof"));
            double numberField_l6czvx0b = 0;
            String textField_l9setoyg = "";
            JSONArray jsonArray = new JSONArray();
            if (jsonObject.has("tableField_l6btfti5")) {
                HashMap<String, Double> map = new HashMap<String, Double>();
                HashMap<String, Double> map2 = new HashMap<String, Double>();
                HashMap<String, String> map3 = new HashMap<String, String>();
                for (int i = 0; i < jsonObject.getJSONArray("tableField_l6btfti5").length(); i++) {


                    JSONObject itemJson = jsonObject.getJSONArray("tableField_l6btfti5").getJSONObject(i);
                    if (itemJson.has("textField_l6x1rkjl")) {
                        String textField_l6x1rkjl = itemJson.get("textField_l6x1rkjl").toString();
                        if ("".equals(textField_l6x1rkjl)) {
                            if (itemJson.has("textField_l6x1rkjl")) {
                                itemJson.remove("textField_l6x1rkjl");
                            }
                            itemJson.put("textField_l6x1rkjl", "J0");
                        }
                    }

//                    if (itemJson.has("textField_l815hv7t")  && i == 0) {
//                        itemJson.remove("textField_l815hv7t");
//                        itemJson.put("textField_l815hv7t", "Jimmy Dean猪柳欧姆蛋可颂三明治 1.56kg×12");
//                    }

                    //金额
                    Double numberField_l7sowiqy = itemJson.getDouble("numberField_l7sowiqy");
                    if (map.containsKey(itemJson.get("textField_l815hv7t").toString())) {
                        Double textField_l815hv7t = map.get(itemJson.get("textField_l815hv7t").toString());
                        map.remove(itemJson.get("textField_l815hv7t").toString());
                        numberField_l7sowiqy = textField_l815hv7t + numberField_l7sowiqy;
                    }

                    map.put(itemJson.get("textField_l815hv7t").toString(), numberField_l7sowiqy);
                    //数量
                    Double numberField_l815hv7r = itemJson.getDouble("numberField_l815hv7r");
                    if (map2.containsKey(itemJson.get("textField_l815hv7t").toString())) {
                        Double textField_l815hv7t = map2.get(itemJson.get("textField_l815hv7t").toString());
                        map2.remove(itemJson.get("textField_l815hv7t").toString());
                        numberField_l815hv7r = textField_l815hv7t + numberField_l815hv7r;
                    }
                    map2.put(itemJson.get("textField_l815hv7t").toString(), numberField_l815hv7r);
                    //单位
                    if (!itemJson.has("textField_l815hv7s")) {
                        itemJson.put("textField_l815hv7s", "");
                    }
                    String textField_l815hv7s = itemJson.get("textField_l815hv7s").toString();
                    map3.put(itemJson.get("textField_l815hv7t").toString(), textField_l815hv7s);

                    if (itemJson.has("numberField_l6oq3qea")) {
                        itemJson.put("numberField_l7sowiqy", itemJson.get("numberField_l6oq3qea"));
                    }
                    if (itemJson.has("numberField_l6x1rkjm") && i == 0) {
                        numberField_l6czvx0b = itemJson.getDouble("numberField_l6x1rkjm");
                    } else {
                        itemJson.remove("numberField_l6x1rkjm");
                        itemJson.put("numberField_l6x1rkjm", 0);
//                        itemJson.put("textField_l6x1rkjl", "J0");
                    }

                    obj = new JSONObject();
                    obj.put("textField_l79x0uw6", itemJson.get("textField_l6x1rkjl"));
                    data = new JSONArray(dingUtil.yiDaSearch("FORM-XN966G71C1A3T2LJ62UOZAZTRGS72GNG0X97L41", obj));
                    if (data.length() > 0) {
                        double numberField_l79x0uw8 = data.getJSONObject(0).getJSONObject("formData").getDouble("numberField_l79x0uw8");
                        if (itemJson.has("numberField_l7sofvnv")) {
                            itemJson.remove("numberField_l7sofvnv");
                        }
                        itemJson.put("numberField_l7sofvnv", numberField_l79x0uw8);
                    }
                    obj = new JSONObject();
                    obj.put("textField_l7smls2z", itemJson.get("textField_l6x1rkjk"));
                    obj.put("textField_l7smls30", itemJson.get("textField_l6czvx0h"));
                    data = new JSONArray(dingUtil.yiDaSearch("FORM-Z2666J81L1Q3B6MUE5B5VCFYM11S3OXALMS7LR", obj));
                    double sum = 0;
                    if (data.length() > 0) {
                        sum += data.getJSONObject(0).getJSONObject("formData").getDouble("numberField_l7smls31");
                        if (itemJson.has("numberField_l7igunas")) {
                            itemJson.remove("numberField_l7igunas");
                        }
                        itemJson.put("numberField_l7igunas", sum);
                    }
                    if (itemJson.has("textField_l9f7o00d")) {
                        if (!textField_l9setoyg.contains(itemJson.getString("textField_l9f7o00d"))) {
                            textField_l9setoyg += itemJson.getString("textField_l9f7o00d") + ";";
                        }
                    }
                    jsonArray.put(itemJson);
                }
                JSONArray jsonArray1 = new JSONArray();
                for (String textField_lam6lry0 : map.keySet()) {
                    Double numberField_lam6lry1 = map.get(textField_lam6lry0);
                    JSONObject tableField_lam6lry2 = new JSONObject();
                    tableField_lam6lry2.put("textField_lam6lry0", textField_lam6lry0);
                    tableField_lam6lry2.put("numberField_lam6lry1", numberField_lam6lry1);
                    tableField_lam6lry2.put("numberField_lam8grp7", map2.get(textField_lam6lry0));
                    tableField_lam6lry2.put("textField_lam8grp5", map3.get(textField_lam6lry0));
                    jsonArray1.put(tableField_lam6lry2);
                }
                upjson.put("tableField_lam6lry2", jsonArray1);
            }

            upjson.put("textField_l9setoyg", textField_l9setoyg);
            upjson.put("numberField_l6czvx0b", numberField_l6czvx0b);
            upjson.put("tableField_l6btfti5", jsonArray);

            JSONObject queryJon = new JSONObject();
            queryJon.put("textField_l6bwnaf8", jsonObject.get("textField_l6btfthp"));
            queryJon.put("textField_l6dhvu1r", jsonObject.get("textField_l6c19doa"));
            jsonArray = new JSONArray(dingUtil.yiDaSearch("FORM-FV966U91BPP2KC648VLLT5J26WOO2DX2NWB6L0", queryJon));
            try {
                if (jsonArray.length() > 0) {
                    String textField_l6dhvu1p = jsonArray.getJSONObject(0).getJSONObject("formData").getString("textField_l6dhvu1p");
                    String textField_l6bwnafd = jsonArray.getJSONObject(0).getJSONObject("formData").getString("textField_l6bwnafd");

                    upjson.put("selectField_l7o5kch0", textField_l6dhvu1p);
                    upjson.put("textField_l6btftfu", textField_l6bwnafd);
                }
            } catch (Exception ex) {
                ex.printStackTrace();
            }

            queryJon = new JSONObject();
            queryJon.put("textField_l75terja", upjson.get("selectField_l7o5kch0"));
            jsonArray = new JSONArray(dingUtil.yiDaSearch("FORM-EX866CB143A3WF6PAR7O94M7SE7I2FMKET57L5", queryJon));
            try {
                if (jsonArray.length() > 0) {
                    String selectField_l7o5kch0 = jsonArray.getJSONObject(0).getJSONObject("formData").getString("textField_l75terjb");

                    upjson.put("textField_l75v2ckq", selectField_l7o5kch0);
                }
            } catch (Exception ex) {
                ex.printStackTrace();
            }
            upjson.put("radioField_l8dun9dl", "否");
            upjson.put("radioField_lalwchdh", "否");
            logger.info(" YiDa Update : " + id + " => " + upjson.toString());
            dingUtil.UpdateYiDa(id, upjson);
            return CusutUtil.SuccessReturnJsonString(200, "成功", "str");
        } catch (
                Exception ex) {
            ex.printStackTrace();
            return CusutUtil.SuccessReturnJsonString(500, "接口异常500,请联系管理员或开发者处理", "str");
        }

    }

    public int index = 0;

    public String bookkeeping(String id, String type) {
        //
        try {
            JSONObject object = new JSONObject(dingUtil.getYidaById(id));
            String nowDate = CusutUtil.getNowDate();
            JSONArray bookkeepingJArray = new JSONArray();
            JSONObject bookkeepingJObj = new JSONObject();
            bookkeepingJObj.put("voucherstatus", "0");
            bookkeepingJObj.put("voucherdate", nowDate);
            bookkeepingJObj.put("applytime", nowDate);
            bookkeepingJObj.put("syssource", "第三方系统规定");
            bookkeepingJObj.put("bookeepflag", "1");
            JSONArray invoices = new JSONArray();
            JSONObject upJson = new JSONObject();
            ArrayList<String> ids = new ArrayList<>();
            if ("PO".equals(type)) {
                if (object.has("textField_l7imtdo3") && !object.get("textField_l7imtdo3").equals("")) {
                    bookkeepingJObj.put("voucherNumber", object.getString("textField_l7imtdo3"));
                } else if (object.has("textField_l6yt5969") && !object.get("textField_l6yt5969").equals("")) {
                    bookkeepingJObj.put("voucherNumber", object.getString("textField_l6yt5969"));
                }
                if (object.has("tableField_l6otidfq") && object.getJSONArray("tableField_l6otidfq").length() > 0) {
                    JSONArray tableField_l6otidfq = object.getJSONArray("tableField_l6otidfq");
                    for (int i = 0; i < tableField_l6otidfq.length(); i++) {
                        JSONObject jsonObject = tableField_l6otidfq.getJSONObject(i);
                        String substring = jsonObject.getString("associationFormField_l6ygli4c_id").replaceAll("\\\\", "").substring(1);
                        String instanceId = new JSONArray(substring.substring(0, substring.length() - 1)).getJSONObject(0).getString("instanceId");
                        String s = PjgetByid(instanceId, "1");
                        if (!"".equals(s)) {
                            invoices.put(new JSONObject(s));
                            ids.add(instanceId);
                        }
                    }
                    upJson.put("tableField_l6otidfq", tableField_l6otidfq);
                }
            } else if ("NP".equals(type)) {
                bookkeepingJObj.put("voucherNumber", object.getString("textField_l701yhu3"));
                if (object.has("tableField_l6bwb4hj") && object.getJSONArray("tableField_l6bwb4hj").length() > 0) {
                    JSONArray tableField_l6bwb4hj = object.getJSONArray("tableField_l6bwb4hj");
                    for (int i = 0; i < tableField_l6bwb4hj.length(); i++) {
                        JSONObject jsonObject = tableField_l6bwb4hj.getJSONObject(i);
                        String substring = jsonObject.getString("associationFormField_l6yglav7_id").replaceAll("\\\\", "").substring(1);
                        String instanceId = new JSONArray(substring.substring(0, substring.length() - 1)).getJSONObject(0).getString("instanceId");
                        String s = PjgetByid(instanceId, "1");
                        if (!"".equals(s)) {
                            invoices.put(new JSONObject(s));
                            ids.add(instanceId);
                        }
                    }
                    upJson.put("tableField_l6bwb4hj", tableField_l6bwb4hj);
                }
            } else if ("TE".equals(type)) {
                bookkeepingJObj.put("voucherNumber", object.getString("textField_l7a7bf81"));
                if (object.has("tableField_l6lmxo5r") && object.getJSONArray("tableField_l6lmxo5r").length() > 0) {
                    JSONArray tableField_l6lmxo5r = object.getJSONArray("tableField_l6lmxo5r");
                    if (object.getJSONArray("tableField_l6lmxo5r").length() >= 50) {
                        tableField_l6lmxo5r = dingUtil.innerTables(id, "FORM-UX866Q61LRK2LACIB8A6M6T1ZOLM2VY5NYB6LZ", "tableField_l6lmxo5r");
                    }
                    //true=采用选择发票控件模式
                    if (true) {
                        String substring = object.getString("associationFormField_l83trmls_id").replaceAll("\\\\", "").substring(1);
                        tableField_l6lmxo5r = new JSONArray(substring.substring(0, substring.length() - 1));
                    }
                    for (int i = 0; i < tableField_l6lmxo5r.length(); i++) {
                        bookkeepingJObj.put("voucherdate", CusutUtil.getFormatDate(object.getLong("dateField_l7a7bf89")));
                        bookkeepingJObj.put("applytime", CusutUtil.getFormatDate(object.getLong("dateField_l7a7bf89")));
                        JSONObject jsonObject = tableField_l6lmxo5r.getJSONObject(i);
                        try {
                            String instanceId = "";
                            if (true) {//true=采用选择发票控件模式
                                instanceId = tableField_l6lmxo5r.getJSONObject(i).getString("instanceId");
                            } else { //采用选择子表（选择发票控件模式）
                                String substring = jsonObject.getString("associationFormField_l6vk2yxg_id").replaceAll("\\\\", "").substring(1);
                                instanceId = new JSONArray(substring.substring(0, substring.length() - 1)).getJSONObject(0).getString("instanceId");
                            }
                            String s = PjgetByid(instanceId, "1");
                            if (!"".equals(s)) {
                                invoices.put(new JSONObject(s));
                                ids.add(instanceId);
                                index++;
                            }
                        } catch (Exception exception) {
                        }
                    }
                    upJson.put("tableField_l6lmxo5r", tableField_l6lmxo5r);
                }
            }
            bookkeepingJObj.put("invoices", invoices);
            bookkeepingJArray.put(bookkeepingJObj);
            System.out.println(bookkeepingJArray);
            logger.info("发起POST请求：URL=http://106.15.251.153:8091/stms/openapi/ts/income/bookkeeping,参数={}", bookkeepingJArray);
            String post = HttpUtil.post("http://106.15.251.153:8091/stms/openapi/ts/income/bookkeeping", null, bookkeepingJArray.toString(), null);
            logger.info("POST请求完成：响应={}", post);
            if (!"".equals(post)) {
                System.out.println(CusutUtil.unicodeDecode(post));
                JSONObject jsonObject = new JSONObject(CusutUtil.unicodeDecode(post));
                if (jsonObject.getString("code").equals("0000")) {
                    JSONArray data = jsonObject.getJSONArray("data");
                    log.info("date数据真实值：" + data);
                    Iterator<String> keys = upJson.keys();
                    JSONArray jsonArray = new JSONArray();
                    String key = "";
                    while (keys.hasNext()) {
                        key = keys.next();
                        jsonArray = upJson.getJSONArray(key);
                    }
                    log.info("jsonArray数据真实值：" + jsonArray);
                    for (int i = 0; i < data.length(); i++) {
                        JSONObject dataJSONObject = data.getJSONObject(i);
                        JSONObject jsonArrayJSONObject = jsonArray.getJSONObject(i);
                        jsonArray.remove(i);
                        String returnmsg = dataJSONObject.getString("returnmsg");
                        if (type.equals("PO")) {
                            jsonArrayJSONObject.remove("textField_l6q3aelu");
                            jsonArrayJSONObject.put("textField_l6q3aelu", returnmsg);
                            jsonArray.put(jsonArrayJSONObject);
                        } else if (type.equals("NP")) {
                            jsonArrayJSONObject.remove("textField_l6q3cn36");
                            jsonArrayJSONObject.put("textField_l6q3cn36", returnmsg);
                            jsonArray.put(jsonArrayJSONObject);
                        } else if (type.equals("TE")) {
                            jsonArrayJSONObject.remove("textField_l6q8uw0g");
                            jsonArrayJSONObject.put("textField_l6q8uw0g", returnmsg);
                            jsonArray.put(jsonArrayJSONObject);
                        } else {
                            jsonArray.put(jsonArrayJSONObject);
                        }
                        String s = dingUtil.UpdateYiDa(ids.get(i), new JSONObject().put("textField_l7efm5az", returnmsg));
                        logger.info(" AsyncController 2139 : " + returnmsg + " => " + s);
                    }
                    try {
                        upJson.remove(key);
                        upJson.put(key, jsonArray);
                        JSONObject upResJson = new JSONObject();

                        if (type.equals("TE")) {
                            log.info("TE进入");
                            upResJson.put("textField_lz9aycs1", jsonObject.get("msg"));
                            log.info("TE赋值");
                        }
                        if (type.equals("NP")) {
                            log.info("NP进入");
                            upResJson.put("textField_m03oeoau", jsonObject.get("msg"));
                            log.info("NP赋值");
                        }
                        String updatedRes = dingUtil.UpdateYiDa(id, upResJson);
                        log.info(" AsyncController 2159 upResJson: " + upResJson + " updatedRes ==> " + updatedRes);
                    } catch (Exception ex) {
                        ex.printStackTrace();
                        log.error(" AsyncController 2161 更新标签失败" + ex.getMessage());
                    }
                } else {
                    return CusutUtil.SuccessReturnJsonString(500, "接口返回值异常" + jsonObject, "str");
                }
            }
            return CusutUtil.SuccessReturnJsonString(200, "成功", "str");
        } catch (Exception ex) {
            ex.printStackTrace();
            return CusutUtil.SuccessReturnJsonString(500, "接口异常500,请联系管理员或开发者处理" + id + " " + type + "exMessage:" + ex.getMessage(), "str");
        }
    }

    //String OTC_URL = "https://etl-nonprod-tasks.cloud.tyson.com:443/api/1/rest/feed/run/task/TysonNonProd/Ultra_PoC/20-PREPROD-team-fssc/tk_oa_to_sap_o2c?bearer_token=Fo1SLHus9rk9gFQlYHvLJpx9eenPG3QE&interface_id=SAP009";
    //SAP009测试0204
    //String OTC_URL = "https://elastic.snaplogic.com/api/1/rest/slsched/feed/TysonNonProd/Ultra_PoC/10-QA-team-fssc/tk_oa_to_sap_o2c?bearer_token=Fo1SLHus9rk9gFQlYHvLJpx9eenPG3QE&interface_id=SAP009";
    //SAP009测试0221
    //String OTC_URL = "https://etl-nonprod-tasks.tysondt.com:443/api/1/rest/feed/run/task/TysonNonProd/Ultra_PoC/10-QA-team-fssc/tk_oa_to_sap_o2c?bearer_token=Fo1SLHus9rk9gFQlYHvLJpx9eenPG3QE&interface_id=SAP009";
    //正式URL0403
    String OTC_URL = "https://etl-prod-tasks.tysondt.com:443/api/1/rest/feed/run/task/TysonProd/Ultraprojects/team-fssc/tk_oa_to_sap_o2c?bearer_token=Fo1SLHus9rk9gFQlYHvLJpx9eenPG3QE&interface_id=SAP009";

    //*测试*
    //https://etl-nonprod-tasks.cn.tyson.com:443/api/1/rest/feed/run/task/TysonNonProd/Ultra_PoC/10-QA-team-fssc/tk_oa_to_sap_o2c?bearer_token=Fo1SLHus9rk9gFQlYHvLJpx9eenPG3QE&interface_id=SAP009
    @Async
    public void SDCreatePz(String id, String name) {
        try {
            Thread.sleep(3000);
            JSONObject upJson = new JSONObject();
            JSONObject object = new JSONObject(dingUtil.getYidaById(id));


            while (true) {
                JSONObject cobj = new JSONObject();
                if (!object.has("textField_lkjakeuc")) {
                    object.put("textField_lkjakeuc", "");
                }
                cobj.put("textField_lkjakeuc", object.get("textField_lkjakeuc"));
                JSONArray cdata = new JSONArray(dingUtil.yiDaSearch("FORM-YZ9664D18X23H2708NGYZ8W56VBJ2W765HU6L0", cobj));
                if (cdata.length() > 1 || object.get("textField_lkjakeuc").toString().equals("")) {

                    JSONObject obj = new JSONObject();
                    obj.put("textField_lkjakeum", object.get("textField_lkjakeum"));
                    JSONArray data = new JSONArray(dingUtil.yiDaSearch("FORM-YZ9664D18X23H2708NGYZ8W56VBJ2W765HU6L0", obj));
                    String str = (1000 + data.length() + 1) + "";

                    //upJson.put("textField_lkjakeuc", object.getString("textField_lkjakeum") + str.substring(1, str.length()));
                    if (object.has("textField_lkjakeuc")) {
                        object.remove("textField_lkjakeuc");
                    }
                    object.put("textField_lkjakeuc", object.getString("textField_lkjakeum") + str.substring(1, str.length()));

                } else {
                    break;
                }
            }
            upJson.put("textField_lkjakeuc", object.getString("serialNumberField_lq1zzrp0"));

            JSONObject sapJson = new JSONObject();
            JSONArray tableField_l6uh6h5u = object.getJSONArray("tableField_lkut6ezx");
            if (tableField_l6uh6h5u.length() == 50) {
                tableField_l6uh6h5u = dingUtil.innerTables(id, "FORM-YZ9664D18X23H2708NGYZ8W56VBJ2W765HU6L0", "tableField_lkut6ezx");
            }


            sapJson.put("ZOA_NUMBER", object.get("serialNumberField_lq1zzrp0"));
            sapJson.put("ZOA_TYPE", "SD");
            sapJson.put("VKORG", object.get("selectField_l9wko1by"));
            sapJson.put("ERNAM", "CHN-0" + object.get("textField_lkjakeub"));
            JSONArray sapItem = new JSONArray();
            System.out.println(tableField_l6uh6h5u);
            for (int i = 0; i < tableField_l6uh6h5u.length(); i++) {
                JSONObject jsonObject = tableField_l6uh6h5u.getJSONObject(i);
                JSONObject item = new JSONObject();
                item.put("ZOA_ITEMNO", "" + (i + 1));
                item.put("AUART", jsonObject.get("selectField_lkut6eza"));
                item.put("VTWEG", jsonObject.get("textField_lkut6ezc"));
                item.put("SPART", jsonObject.get("textField_lkut6ezd"));
                item.put("KUNNR", jsonObject.get("textField_lkut6ezf"));
                item.put("BSTKD", jsonObject.get("textField_lkut6ezi"));
                item.put("AUGRU", jsonObject.get("textField_lkut6ezk"));
                item.put("WAERK", "CNY");
                item.put("POSNR", jsonObject.get("textField_lkut6ezq"));
                item.put("MATNR", jsonObject.get("textField_lkut6ezr"));
                item.put("WMENG", jsonObject.get("numberField_lkut6ezs"));
                item.put("VRKME", jsonObject.get("textField_lkut6ezt"));
                item.put("WERKS", jsonObject.get("textField_lkut6ezu"));
                //
                if (jsonObject.has("numberField_lkut6ezv_value")) {
                    item.put("KBETR", jsonObject.get("numberField_lkut6ezv_value"));
                } else {
                    item.put("KBETR", jsonObject.get("numberField_lkut6ezv"));
                }
                item.put("BNAME", "");
                if (jsonObject.has("textareaField_ls2wxgoi")) {
                    item.put("ZUONR", jsonObject.get("textareaField_ls2wxgoi"));//多行文本
                } else {
                    item.put("ZUONR", jsonObject.get("textField_lki1mp42"));//老数据单行文本
                }

                sapItem.put(item);
            }
            sapJson.put("ITEM", sapItem);
            System.out.println(sapJson);
            System.out.println(OTC_URL);
            logger.info("发起POST请求：URL={},参数={}", OTC_URL, sapJson);
            String post = HttpUtil.post(OTC_URL, null, sapJson.toString(), null);
            logger.info("POST请求完成：响应={}", post);
            if (!post.equals("")) {
                System.out.println(post);
                if (new JSONArray(post).length() > 0) {
                    JSONObject postJsonObject = new JSONArray(post).getJSONObject(0);
                    if (!postJsonObject.getString("E_VBELN").equals("")) {
                        upJson.put("textField_lkjakeu8", postJsonObject.getString("E_VBELN"));

                    }
                    upJson.put("textField_l7a7bf8g", postJsonObject.get("E_MESSAGE"));
                } else {
                    upJson.put("textField_l7a7bf8g", "[]");
                }
            } else {
                return;
            }
            dingUtil.UpdateYiDa(id, upJson);
            logger.info(" YiDa Update : " + id + " => " + upJson.toString());


            CusutUtil.SuccessReturnJsonString(200, "成功", "str");
        } catch (Exception ex) {
            ex.printStackTrace();
            CusutUtil.SuccessReturnJsonString(500, "接口异常500,请联系管理员或开发者处理", "str");
        }
    }

    //OTC 销售订单凭证生成 -流程结束自动生成
    @Async
    public void XSddCreatePz(String id) {
        try {
            Thread.sleep(3000);
            JSONObject object = new JSONObject(dingUtil.getYidaById(id));
            logger.info("XSddCreatePz----getYIDAData：" + object);
            String uuid = CusutUtil.getRandomString(6);
            int index = 1;
            JSONObject seJson = new JSONObject();
            double je = 0;
            JSONArray tableField_l7pku3he = object.getJSONArray("tableField_l7pku3he");
            for (int i = 0; i < tableField_l7pku3he.length(); i++) {
                JSONObject itemJson = tableField_l7pku3he.getJSONObject(i);
                JSONObject CrJson = new JSONObject();
                //索引
                CrJson.put("textField_6dol1j6", uuid);
                //行项目号
                CrJson.put("textField_3zo0wnl", index++);
                //公司代码
                CrJson.put("textField_cgdbdti", object.get("selectField_l9wko1by"));
                //凭证类型
                CrJson.put("textField_50d9atv", "ZU");
                //凭证抬头文本
                CrJson.put("textField_rl9chzb", itemJson.getString("textField_l7pku3hh") + "核销" + object.getString("selectField_l7pku3h5") + "" + itemJson.getString("selectField_l7pku3hj"));
                //记帐代码
                CrJson.put("textField_a0ecw67", "81");
                //物料
                JSONObject wljo = new JSONObject();
                JSONObject obj = new JSONObject();
                obj.put("textField_65olxoa", itemJson.getString("selectField_l7pku3hn"));
                String s = dingUtil.yiDaSearch("FORM-4IA66891UL9EF7ZJ73IXF8E8QL6K2SHPOAOML6", obj);
                JSONArray jsonArray = new JSONArray(s);
                if (jsonArray.length() > 0) {
                    wljo = jsonArray.getJSONObject(0).getJSONObject("formData");
                    //总分类帐帐目
                    CrJson.put("textField_z0y9np3", wljo.getString("textField_jeepjzc"));
                }
                //凭证货币金额
                CrJson.put("textField_765t48n", itemJson.get("numberField_l7pku3hv"));

                //加总
                je += itemJson.getDouble("numberField_l7pku3hr");
                double se = itemJson.getDouble("numberField_l7pku3hx");

                //税码
                obj = new JSONObject();
                obj.put("numberField_lmoadm5o", new JSONArray().put(itemJson.getDouble("numberField_l7pku3ht")).put(itemJson.getDouble("numberField_l7pku3ht")));
                s = dingUtil.yiDaSearch("FORM-MFA66S91VKCEW162DE5QG67J77Y72C39DAOML0", obj);
                jsonArray = new JSONArray(s);
                if (jsonArray.length() > 0) {
                    JSONObject smJs = jsonArray.getJSONObject(0).getJSONObject("formData");
                    String sm = smJs.getString("textField_lmo9wts2");
                    if (seJson.has(sm)) {
                        se = seJson.getDouble(sm) + se;
                        seJson.remove(sm);
                    }
                    seJson.put(sm, se);
                }

                //成本中心
                if (CrJson.getString("textField_z0y9np3").equals("600330") || CrJson.getString("textField_z0y9np3").equals("595100")) {
                    CrJson.put("textField_xhyz73p", "66002584");
                } else {
                    CrJson.put("textField_xhyz73p", "66002234");
                }
                //项目文本
                CrJson.put("textField_6e843p4", CrJson.getString("textField_rl9chzb"));
                //利润中心
                CrJson.put("textField_ikvxizv", "171116600");
                //分配
                CrJson.put("textField_ybsyab5", itemJson.getString("textField_l7pku3hh"));

                //客户简称
                obj = new JSONObject();
                obj.put("textField_lmo9wts1", object.getString("selectField_l7pku3h5"));
                s = dingUtil.yiDaSearch("FORM-WV866IC1PH9EISA0ASY088EFYYD33D7AHAOML5", obj);

                jsonArray = new JSONArray(s);
                logger.info("客户简称" + jsonArray);
                if (jsonArray.length() > 0) {
                    JSONObject khjc = jsonArray.getJSONObject(0).getJSONObject("formData");
                    //客户简称编号
                    CrJson.put("textField_9bifp2f", khjc.getString("textField_lmo9wts2"));
                }
                //产品号
                CrJson.put("textField_w3ffz93", wljo.getString("textField_bwjgjcp"));
                //销售组织
                CrJson.put("textField_r9h0adl", "6600");
                //分销渠道
                CrJson.put("textField_j1gukg1", "C1");

                //产品组
                obj = new JSONObject();
                obj.put("textField_lmo9wts1", itemJson.getString("selectField_l7pku3hl"));
                s = dingUtil.yiDaSearch("FORM-3C866TC1OKCEV8LXE4L8Y9FNX4K42KLO3AOML0", obj);
                jsonArray = new JSONArray(s);
                if (jsonArray.length() > 0) {
                    JSONObject cpz = jsonArray.getJSONObject(0).getJSONObject("formData");
                    //产品组编号
                    CrJson.put("textField_fe3epv9", cpz.getString("textField_lmo9wts2"));
                }

                //客户定义
                obj = new JSONObject();
                obj.put("textField_lmo9wts1", object.getString("selectField_l7pku3h3"));
                s = dingUtil.yiDaSearch("FORM-WY766581BX8ELNA77JWHPB2FCUCR2ZASBAOML8", obj);
                jsonArray = new JSONArray(s);
                if (jsonArray.length() > 0) {
                    JSONObject cpz = jsonArray.getJSONObject(0).getJSONObject("formData");
                    //客户定义
                    CrJson.put("textField_vqndemn", cpz.getString("textField_lmo9wts2"));
                }

                //物料组包装物料
                obj = new JSONObject();
                obj.put("textField_lmo9wts1", itemJson.getString("selectField_l7pku3hj"));
                s = dingUtil.yiDaSearch("FORM-0IA66C71KJCESLLI7F024DDRCKCU36ZNW9OML1", obj);
                jsonArray = new JSONArray(s);
                if (jsonArray.length() > 0) {
                    JSONObject cpz = jsonArray.getJSONObject(0).getJSONObject("formData");
                    //物料组包装物料
                    CrJson.put("textField_nfl7fne", cpz.getString("textField_lmo9wts2"));
                }

                //客户简称
                CrJson.put("textField_ibr3gfx", CrJson.getString("textField_9bifp2f"));
                String res = dingUtil.saveYiDa("FORM-566665710LCEQZU773Y01AINSF8S3RPESAOML1", CrJson, dingConst.getUserId());
                logger.info("YiDa Return Data :" + res);
            }
            Iterator<String> keys = seJson.keys();

            //税金 行
            while (keys.hasNext()) {
                String key = keys.next();

                JSONObject CrJson = new JSONObject();
                //索引
                CrJson.put("textField_6dol1j6", uuid);
                //行项目号
                CrJson.put("textField_3zo0wnl", index++);
                //公司代码
                CrJson.put("textField_cgdbdti", object.get("selectField_l9wko1by"));
                //凭证类型
                CrJson.put("textField_50d9atv", "ZU");
                //凭证抬头文本
                CrJson.put("textField_rl9chzb", "核销" + object.getString("selectField_l7pku3h5") + "帐扣费用");
                //记帐代码
                CrJson.put("textField_a0ecw67", "81");
                //总分类帐帐目
                CrJson.put("textField_z0y9np3", "359000");
                //凭证货币金额
                String format = new DecimalFormat("#.00").format(seJson.get(key));
                CrJson.put("textField_765t48n", format);
                //项目文本
                CrJson.put("textField_6e843p4", CrJson.getString("textField_rl9chzb"));
                //利润中心
                CrJson.put("textField_ikvxizv", "171116600");
                //分配
                CrJson.put("textField_ybsyab5", CrJson.getString("textField_6e843p4"));
                //税码
                CrJson.put("textField_6khhryb", key);
                logger.info("CrJson-----》:" + CrJson);
                String res = dingUtil.saveYiDa("FORM-566665710LCEQZU773Y01AINSF8S3RPESAOML1", CrJson, dingConst.getUserId());
                logger.info("YiDa Return Data :" + res);
            }

            //总金额 行
            if (je > 0) {
//                String key = seJson.keys().next();

                JSONObject CrJson = new JSONObject();
                //索引
                CrJson.put("textField_6dol1j6", uuid);
                //行项目号
                CrJson.put("textField_3zo0wnl", index++);
                //公司代码
                CrJson.put("textField_cgdbdti", object.get("selectField_l9wko1by"));
                //凭证类型
                CrJson.put("textField_50d9atv", "ZU");
                //凭证抬头文本
                CrJson.put("textField_rl9chzb", "核销" + object.getString("selectField_l7pku3h5") + "帐扣费用");
                //记帐代码
                CrJson.put("textField_a0ecw67", "31");
                //总分类帐帐目
                CrJson.put("textField_z0y9np3", "310000");
                //凭证货币金额
                String format = new DecimalFormat("#.00").format(je);
                CrJson.put("textField_765t48n", format);
                //项目文本
                CrJson.put("textField_6e843p4", CrJson.getString("textField_rl9chzb"));
                //利润中心
                CrJson.put("textField_ikvxizv", "171116600");
                //分配
                CrJson.put("textField_ybsyab5", CrJson.getString("textField_6e843p4"));
                //供应商账号
                CrJson.put("textField_z0pwl9l", object.getString("selectField_l926f4kx"));
                String res = dingUtil.saveYiDa("FORM-566665710LCEQZU773Y01AINSF8S3RPESAOML1", CrJson, dingConst.getUserId());
                logger.info("YiDa Return Data :" + res);
            }
            JSONObject upJson = new JSONObject();
            upJson.put("textField_lz89sxle", uuid);
            String s = dingUtil.UpdateYiDa(id, upJson);
            logger.info("YiDa Return Data (xsddUpdate):" + s);
            System.out.println("生成成功");
        } catch (Exception ex) {
            ex.printStackTrace();
        }

    }
}