package com.tyson.controller;

import com.tyson.consts.dingConst;
import com.tyson.util.CusutUtil;
import com.tyson.util.FileUtil;
import com.tyson.util.HttpUtil;
import com.tyson.util.dingUtil;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import lombok.extern.slf4j.Slf4j;
import net.bytebuddy.asm.Advice;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.json.JSONArray;
import org.json.JSONObject;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.MediaType;
import org.springframework.scheduling.annotation.Async;
import org.springframework.util.LinkedMultiValueMap;
import org.springframework.util.MultiValueMap;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.print.DocFlavor;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.net.URLDecoder;
import java.util.*;

/**
 * Decription:
 *
 * @author hzk
 * @ClassName YiDaController
 * @Date 2022/8/3 11:41
 */
@RestController
@RequestMapping("/api")
@Api(tags = "api")
@Slf4j
public class YiDaController {
    private static final Logger logger = LoggerFactory.getLogger(YiDaController.class);
    //    private static final Logger logger = LoggerFactory.getLogger(YiDaController.class);
    @Autowired
    private dingUtil dingUtil;

    @Autowired
    private dingConst dingConst;

    @ApiOperation("测试")
    @GetMapping("testdemo")
    public String demo(String id) {
        JSONObject obj = new JSONObject();
        obj.put("numberField_lkhw10r8", 102116.45);
        try {
            logger.info("YiDa Update : " + id + " => " + obj.toString());
            dingUtil.UpdateYiDa(id, obj);
        } catch (Exception e) {
            e.printStackTrace();
        }
        return "";
    }

    @ApiOperation("更新TEJS数据")
    @GetMapping("up_TEJs")
    public String up_TEJs(int page) {
        for (int i = 26; i <= page; i++) {
            String instanceIds = dingUtil.getInstanceIds(i);
            String ids = instanceIds.substring(1, instanceIds.length() - 1);
            String withoutSpaces = ids.replaceAll("\\s+", ""); // 删除所有空白字符
            // 使用逗号分隔字符串
            String[] parts = withoutSpaces.split(",");
            // 创建 ArrayList 并添加分割后的字符串
            ArrayList<String> idList = new ArrayList<>(Arrays.asList(parts));
            // 输出结果
            logger.info("YiDaController (up_TEJs): idList => " + idList);
            if (!idList.isEmpty()) {
                for (String id : idList) {
                    try {
                        dingUtil.UpdateYiDa_String(id, "{}");
                    } catch (Exception e) {
                        logger.error("UPjs => " + e.getMessage());
                    }
                }
            } else {
                break;
            }
        }
        return "200";
    }

    @ApiOperation("定时重推航信接口")
    @GetMapping("bookkeepingTimer")
    public String bookkeepingTimer(String type) {

        //获取当前时间的时间戳
        long now_Time = System.currentTimeMillis();
        String modifiedToTimeGMT = CusutUtil.getDate(now_Time);
        //向前倒推24小时的时间戳
        long day_Time = now_Time - 3 * 24 * 60 * 60 * 1000;
        String modifiedFromTimeGMT = CusutUtil.getDate(day_Time);
        //搜索24小时内的所有数据
        logger.info("YiDaController (bookkeepingSync): modifiedFromTimeGMT=>" + modifiedFromTimeGMT + "modifiedToTimeGMT=>" + modifiedToTimeGMT);
        String s = null;
        if (type == "TE") {
            try {
                s = dingUtil.yiDaSearch("FORM-UX866Q61LRK2LACIB8A6M6T1ZOLM2VY5NYB6LZ", modifiedFromTimeGMT, modifiedToTimeGMT, 0);
                logger.info("YiDaController (bookkeepingSync): TEYiDaSearchResult => " + s);
            } catch (Exception e) {
                e.printStackTrace();
                logger.error("YiDaController (bookkeepingSync): TEYiDaSearchError => " + e.getMessage());
            }
            JSONArray jsonArray = new JSONArray(s);
            System.out.println(jsonArray.length());
            for (int i = 0; i < jsonArray.length(); i++) {
                try {
                    JSONObject jobject = jsonArray.getJSONObject(i);
                    String formInstanceId = jobject.getString("formInstanceId");
                    String textField_lz9aycs1 = jobject.getJSONObject("formData").has("textField_lz9aycs1") ? jobject.getJSONObject("formData").getString("textField_lz9aycs1") : "";
//                String textField_l7a7bf8a = jobject.getJSONObject("formData").getString("textField_l7a7bf8a");
//                String textField_l7a7bf81 = jobject.getJSONObject("formData").getString("textField_l7a7bf81");
                    if (jobject.getJSONObject("formData").has("textField_lz9aycs1") && jobject.getJSONObject("formData").getString("textField_lz9aycs1").equals("") && !jobject.getJSONObject("formData").getString("textField_l7a7bf8a").equals("") && !jobject.getJSONObject("formData").getString("textField_l7a7bf81").equals("")) {
                        String res = asyncController.bookkeeping(jobject.getString("formInstanceId"), "TE");
                        logger.info("YiDaController (bookkeepingSync): TEbookkeepingResult => 第" + i + "条" + res);
                    }
                } catch (Exception e) {
                    logger.error("YiDaController (bookkeepingSync): TEbookkeepingError => " + e.getMessage());
                }
            }
            logger.info("定时推送TE任务结束");
            return "200";
        }
        if (type == "NP") {
            try {
                s = dingUtil.yiDaSearch("FORM-YU966T913NK2V4E4BUVZY5X8UWYR3842GVB6LA1", modifiedFromTimeGMT, modifiedToTimeGMT, 0);
                logger.info("YiDaController (bookkeepingSync): NPYiDaSearchResult => " + s);
            } catch (Exception e) {
                e.printStackTrace();
                logger.error("YiDaController (bookkeepingSync): NPYiDaSearchError => " + e.getMessage());
            }
            JSONArray jsonArray = new JSONArray(s);
            System.out.println(jsonArray.length());
            for (int i = 0; i < jsonArray.length(); i++) {
                try {
                    JSONObject jobject = jsonArray.getJSONObject(i);
                    String formInstanceId = jobject.getString("formInstanceId");
                    String textField_m03oeoau = jobject.getJSONObject("formData").has("textField_m03oeoau") ? jobject.getJSONObject("formData").getString("textField_m03oeoau") : "";
                    if (jobject.getJSONObject("formData").has("textField_m03oeoau") && jobject.getJSONObject("formData").getString("textField_m03oeoau").equals("") && !jobject.getJSONObject("formData").getString("textField_l7a6bzpu").equals("") && !jobject.getJSONObject("formData").getString("textField_l701yhu3").equals("")) {
                        String res = asyncController.bookkeeping(jobject.getString("formInstanceId"), "NP");
                        logger.info("YiDaController (bookkeepingSync): NPbookkeepingResult => 第" + i + "条" + res);
                    }
                } catch (Exception e) {
                    logger.error("YiDaController (bookkeepingSync): NPbookkeepingError => " + e.getMessage());
                }
            }
            logger.info("定时推送NP任务结束");
            return "200";
        }
        return "200";
    }

    @GetMapping("bookkeepingTestBack")
    public String bookkeepingTestBack(String gs) {


//        JSONArray bookkeepingJArray = new JSONArray("    [{\n" +
//                "        \"voucherstatus\": \"0\",\n" +
//                "        \"syssource\": \"第三方系统规定\",\n" +
//                "        \"bookeepflag\": \"1\",\n" +
//                "        \"invoices\": [\n" +
//                "            {\n" +
//                "                \"taxrate\": 0.01,\n" +
//                "                \"oper\": \"1\",\n" +
//                "                \"autodeduct\": \"1\",\n" +
//                "                \"taxno\": \"91440300618806911D\",\n" +
//                "                \"invoicecode\": \"3200224130\",\n" +
//                "                \"invoicenumber\": \"49195656\",\n" +
//                "                \"usetax\": \"2.28\"\n" +
//                "            }\n" +
//
//                "        ],\n" +
//                "        \"voucherdate\": \"2023-06-02 00:00:00\",\n" +
//                "        \"vouchernumber\": \"1930000003;\",\n" +
//                "        \"applytime\": \"2023-06-02 00:00:00\"\n" +
//                "    }]");
//
//        String post = HttpUtil.post("http://106.15.251.153:8091/stms/openapi/ts/income/bookkeeping", null, bookkeepingJArray.toString(), null);
//        System.out.println(CusutUtil.unicodeDecode(post));

        String[] str = new String[]{
//                "1930000005;",
                "1930000061;"
//                "1930000007;",
//                "1930000009;",
//                "1930000011;",
//                "1930000012;",
//                "1930000014;",
//                "1930000017;",
//                "1930000061;",
//                "1930000030;"
        };

        for (String s1 : str) {


//        for (int page = 0; page <= 2; page++) {
            String s = null;
            try {
                JSONObject obj = new JSONObject();
                obj.put("textField_l7a7bf8a", gs);
                obj.put("textField_l7a7bf81", s1);
//                obj.put("textField_l7a7bf8f","2024");
                s = dingUtil.yiDaSearch("FORM-UX866Q61LRK2LACIB8A6M6T1ZOLM2VY5NYB6LZ", obj, 0);
            } catch (Exception e) {
                e.printStackTrace();
            }
            JSONArray jsonArray = new JSONArray(s);
            System.out.println(jsonArray.length());
            for (int i = 0; i < jsonArray.length(); i++) {
                try {
                    JSONObject jobject = jsonArray.getJSONObject(i);
//                    if (!"".equals(jobject.getJSONObject("formData").getString("textField_l7a7bf81")) && CusutUtil.getFormatDateMM(jobject.getJSONObject("formData").getLong("dateField_l7a7bf89")).equals("07")) {
//                        bookkeepingBack(jobject.getString("formInstanceId"), "TE");

                    String res = asyncController.bookkeeping(jobject.getString("formInstanceId"), "TE");
                    logger.info(res);
//                    }
                } catch (Exception e) {
                    logger.error(e.getMessage());
                }
            }
//            }
//        }
        }
        return "200";
    }


    //    @GetMapping("bookkeepingSync")
    public String bookkeepingSync(String gs, String pz_id) {
        logger.info("YiDaController (bookkeepingSync): gs=>" + gs + ",pz_id=>" + pz_id);
        String s = null;
        try {
            JSONObject obj = new JSONObject();
            obj.put("textField_l7a7bf8a", gs);
            obj.put("textField_l7a7bf81", pz_id);
            s = dingUtil.yiDaSearch("FORM-UX866Q61LRK2LACIB8A6M6T1ZOLM2VY5NYB6LZ", obj, 0);
            logger.info("YiDaController (bookkeepingSync): YiDaSearchParams => " + obj.toString());
            logger.info("YiDaController (bookkeepingSync): YiDaSearchResult => " + s);
        } catch (Exception e) {
            e.printStackTrace();
            logger.error("YiDaController (bookkeepingSync): YiDaSearchError => " + e.getMessage());
        }
        JSONArray jsonArray = new JSONArray(s);
        System.out.println(jsonArray.length());
        for (int i = 0; i < jsonArray.length(); i++) {
            try {
                JSONObject jobject = jsonArray.getJSONObject(i);
//                    if (!"".equals(jobject.getJSONObject("formData").getString("textField_l7a7bf81")) && CusutUtil.getFormatDateMM(jobject.getJSONObject("formData").getLong("dateField_l7a7bf89")).equals("07")) {
//                        bookkeepingBack(jobject.getString("formInstanceId"), "TE");

                String res = asyncController.bookkeeping(jobject.getString("formInstanceId"), "TE");
//                    }
            } catch (Exception e) {

            }
        }
//      }
        return "200";
    }

    @GetMapping("bookkeepingByTest")
    @ApiOperation("推送测试")
    public String bookkeepingByTest(String gs, String pz_id) {
        try {
            asyncController.bookkeepingSync("6600", "1930001966;");
        } catch (Exception e) {
        }
        return "200";
    }

    @GetMapping("bookkeepingTest")
    public String bookkeepingTest(String gs) {

        for (int page = 0; page <= 2; page++) {
            String s = null;
            try {
                JSONObject obj = new JSONObject();
                obj.put("textField_l7a7bf8a", gs);
                obj.put("textField_l7a7bf81", ";");
                s = dingUtil.yiDaSearch("FORM-UX866Q61LRK2LACIB8A6M6T1ZOLM2VY5NYB6LZ", obj, page);
            } catch (Exception e) {
                e.printStackTrace();
            }
            JSONArray jsonArray = new JSONArray(s);
            System.out.println(jsonArray.length());
            for (int i = 0; i < jsonArray.length(); i++) {
                try {
                    JSONObject jobject = jsonArray.getJSONObject(i);

                    //         asyncController.bookkeeping(jobject.getString("formInstanceId"), "TE");

                    asyncController.bookkeeping("941ab087-b47d-4a03-b45c-c26472a78d14", "TE");
//                    if("".equals(jobject.getJSONObject("formData").getString("textField_l7a7bf81"))) {
//                        bookkeepingBack(jobject.getString("formInstanceId"), "TE");
//                    }
//                    else
//                    {
//                        System.out.println(1);
//                    }
                } catch (Exception e) {

                }

            }
        }
        return "200";
    }

    @GetMapping("demo")
    public String demo() {

        String s = null;
        try {
            JSONObject obj = new JSONObject();
            s = dingUtil.yiDaSearch("FORM-UX866Q61LRK2LACIB8A6M6T1ZOLM2VY5NYB6LZ", obj);

        } catch (Exception e) {
            e.printStackTrace();
        }
        JSONArray jsonArray = new JSONArray(s);
        System.out.println(jsonArray.length());
        for (int i = 0; i < jsonArray.length(); i++) {
            try {
                JSONObject jobject = jsonArray.getJSONObject(i);

                asyncController.TECreateSeqNo(jobject.getString("formInstanceId"));
            } catch (Exception e) {

            }
        }
        return "";
    }

    @GetMapping("Test")
    public String test(String dat) {
        try {
            JSONObject object = new JSONObject();
//            object.put("textField_l88jamy9", "65102008");
//            dingUtil.UpdateYiDa("cca2bc82-c512-473f-8565-10911d7cdfe4", object);
//            JSONArray sj = new JSONArray();
//            sj.put("1683302400000");
//            sj.put("1683388800000");
            //dateField_l6u55vd0
            //发票信息不一致
            //返回失败
            //超过该张票当天查验次数
            //全电普票
            object.put("textField_l6u55vdt", dat);
            String s = dingUtil.yiDaSearch("FORM-4J7669A1Z1X22RIL61LB7AOXGRX82OHP45U6L51", object, 1);
            JSONArray jsonArray = new JSONArray(s);
            for (int i = 0; i < jsonArray.length(); i++) {
                try {
                    JSONObject jobject = jsonArray.getJSONObject(i);
                    yz(jobject.getString("formInstanceId"));

                } catch (Exception e) {

                }
            }

//            //付款结果更新
//            JSONObject update = new JSONObject();
//            update.put("dateField_l7oiflf1", "");
//            update.put("textField_l7oiflf0", "");
//

//            JSONObject obj = new JSONObject();
////            obj.put("textField_l7a7bf8d", seq);
//            JSONArray data = new JSONArray(dingUtil.yiDaSearch("FORM-UX866Q61LRK2LACIB8A6M6T1ZOLM2VY5NYB6LZ", obj));
//            if (data.length() > 0 ) {
////                if(seq.equals(data.getJSONObject(0).getJSONObject("formData").getString("textField_l7a7bf8d"))) {
//                for (int i = 0; i < data.length(); i++) {
//                    dingUtil.UpdateYiDa(data.getJSONObject(i).getString("formInstanceId"), update);
//                }
//            }
            return dingUtil.getAccessToken();
        } catch (Exception exception) {
            return exception.getMessage();
        }
    }

    @RequestMapping("fkjylistfor")
    public void fkjylistfor() {
        JSONObject object = new JSONObject();

        object.put("textField_libbv5oq", "否");
        String s = null;
        try {
            s = dingUtil.yiDaSearch("FORM-EX866CB1AQ53B88TFDV6GCDOHV4M3LHGUNY6LF", object, 1);
            logger.info("YiDaController (fkjylistfor): YiDaSearchParams => " + object.toString());
            logger.info("YiDaController (fkjylistfor): YiDaSearchResult => " + s);
        } catch (Exception e) {
            logger.error("YiDaController (fkjylistfor): YiDaSearchError => " + e.getMessage());
            e.printStackTrace();
        }
        JSONArray jsonArray = new JSONArray(s);
        System.out.println(jsonArray.length());

        for (int i = 0; i < jsonArray.length(); i++) {
            try {
                JSONObject jobject = jsonArray.getJSONObject(i);
                if (!jobject.getJSONObject("formData").has("dateField_l6yss6g6") || jobject.getJSONObject("formData").get("dateField_l6yss6g6").toString().equals("")) {
                    fkjy(jobject.getString("formInstanceId"), "Y");
                }
            } catch (Exception ex) {
                logger.error("YiDaController (fkjylistfor): YiDaSearchError => " + ex.getMessage());
                ex.printStackTrace();
            }
        }
    }

    //附件批量更新
    @GetMapping("FJUPDATES")
    public String FJUPDATES() {
        try {
            int index = 0;
            for (int y = 0; y < 7; y++) {
                String s = dingUtil.yiDaSearch("FORM-4J7669A1Z1X22RIL61LB7AOXGRX82OHP45U6L51", new JSONObject(), y);
                logger.info("YiDaController (FJUPDATES): YiDaSearchParams => " + String.valueOf(y));
                logger.info("YiDaController (FJUPDATES): YiDaSearchResult => " + s);
                JSONArray jsonArray = new JSONArray(s);
                for (int i = 0; i < jsonArray.length(); i++) {
                    try {
                        JSONObject object = jsonArray.getJSONObject(i);

                        JSONObject objectup = new JSONObject();
                        JSONArray attachmentField_l6u55vct = new JSONArray(object.getJSONObject("formData").get("attachmentField_l6u55vct").toString());
                        JSONArray attachmentField_l6u55vct_up = new JSONArray();
                        for (int j = 0; j < attachmentField_l6u55vct.length(); j++) {
                            JSONObject object1 = attachmentField_l6u55vct.getJSONObject(j);
                            String previewUrl = object1.getString("previewUrl");
                            String downloadUrl = object1.getString("downloadUrl");
                            String url = object1.getString("url");

                            object1.remove("previewUrl");
                            object1.remove("downloadUrl");
                            object1.remove("url");
                            previewUrl = previewUrl.replaceAll("https://www.senhouse.cn/api/download", "https://www.senhouse.cn/api/preview");


                            object1.put("url", url);
                            object1.put("downloadUrl", downloadUrl);
                            object1.put("previewUrl", previewUrl);
                            attachmentField_l6u55vct_up.put(object1);

                        }

                        objectup.put("attachmentField_l6u55vct", attachmentField_l6u55vct_up);
                        logger.info("YiDa Update : " + object.getString("formInstanceId") + " => " + objectup.toString());
                        String res = dingUtil.UpdateYiDa(object.getString("formInstanceId"), objectup);
                        logger.info("YiDaController (FJUPDATES): YiDaSearchParams => " + objectup.toString());
                        logger.info("YiDaController (FJUPDATES): YiDaSearchResult => " + res);
                        System.out.println(index++);
                    } catch (Exception e) {
                        logger.error("YiDaController (FJUPDATES): YiDaSearchError => " + e.getMessage());
                    }
                }

            }
        } catch (Exception e) {
            e.printStackTrace();
        }

        return "";

    }

    @GetMapping("FJtest")
    public String FJtest(String id) {
        try {
            JSONObject object = new JSONObject(dingUtil.getYidaById(id));
            System.out.println(object);

            if (true) {
                return "";
            }
            JSONArray attachmentField_l6envgqp = new JSONArray(object.get("attachmentField_l6envgqp").toString());
            JSONArray imageField_l6envgqq = new JSONArray(object.get("imageField_l6envgqq").toString());

            try {
                JSONArray jsonArray = dingUtil.downloadFjs(attachmentField_l6envgqp, "/usr/_HIH3WEB_IMG_CACHE/");
//                JSONArray jsonArray = dingUtil.downloadFjs(attachmentField_l6envgqp, "/Users/malk/Desktop/_HIH3WEB_IMG_CACHE/");
                System.out.println(jsonArray);
                jsonArray = dingUtil.downloadFjs(imageField_l6envgqq, "/usr/_HIH3WEB_IMG_CACHE/");
//                jsonArray = dingUtil.downloadFjs(imageField_l6envgqq, "/Users/malk/Desktop/_HIH3WEB_IMG_CACHE/");
                System.out.println(jsonArray);

                return "200";
            } catch (IOException e) {

                e.printStackTrace();
                return "";
            }

        } catch (Exception exception) {
            return exception.getMessage();
        }
    }

    @GetMapping("Posttest")
    public String Posttest(String url) {
        String post = "abcd";
//        System.out.println(post);
        logger.info(post);
        logger.warn(post);
        return post;
    }

    @GetMapping("uploadTest")
    public String uploadTest() {
        try {
            JSONObject object = new JSONObject();

            JSONArray attachmentField_l6envgqp = new JSONArray();
            JSONArray imageField_l6envgqq = new JSONArray();

            JSONObject object1 = new JSONObject();
            JSONObject object2 = new JSONObject();

            object1.put("previewUrl", "https://www.senhouse.cn/api/preview?filePathName=/usr/_HIH3WEB_IMG_CACHE/1660198390743_OA_API_Details.xlsx");
            object1.put("downloadUrl", "https://www.senhouse.cn/api/download?filePathName=/usr/_HIH3WEB_IMG_CACHE/1660198390743_OA_API_Details.xlsx");
            object1.put("url", "https://www.senhouse.cn/api/download?filePathName=/usr/_HIH3WEB_IMG_CACHE/1660198390743_OA_API_Details.xlsx");
            object1.put("size", "35694");
            object1.put("name", "1660198390743_OA_API_Details.xlsx");

            attachmentField_l6envgqp.put(object1);
            object2.put("previewUrl", "https://www.senhouse.cn/api/preview?filePathName=/usr/_HIH3WEB_IMG_CACHE/1660198391360_favicon.png");
            object2.put("downloadUrl", "https://www.senhouse.cn/api/download?filePathName=/usr/_HIH3WEB_IMG_CACHE/1660198391360_favicon.png");
            object2.put("url", "https://www.senhouse.cn/api/download?filePathName=/usr/_HIH3WEB_IMG_CACHE/1660198391360_favicon.png");
            object2.put("size", "2610734");
            object2.put("name", "1660198391360_favicon.png");
            imageField_l6envgqq.put(object2);
            object.put("attachmentField_l6envgqp", attachmentField_l6envgqp);
            object.put("imageField_l6envgqq", imageField_l6envgqq);
            System.out.println(object);
            String res = dingUtil.saveYiDa("FORM-XHA668810RP21VPW77B6K8RD6DB73TN9VNE6LJ", object, dingConst.getUserId());
            logger.info("YiDa Return Data :" + res);
            return res;
        } catch (Exception exception) {
            return exception.getMessage();
        }
    }

    //    String sapUrl = "https://etl-nonprod-tasks.cloud.tyson.com:443/api/1/rest/feed/run/task/TysonNonProd/Ultra_PoC/10-QA-team-fssc/tk_oa_to_sap_p2p?bearer_token=bBiGTA7PS0JJ6wKhQU8Vm0vLsIDNjLaN&interface_id=";
    // String sapUrl = "https://etl-nonprod-tasks.cloud.tyson.com:443/api/1/rest/feed/run/task/TysonNonProd/Ultra_PoC/00-STG-team-fssc/tk_oa_to_sap_p2p?bearer_token=bBiGTA7PS0JJ6wKhQU8Vm0vLsIDNjLaN&interface_id=";
    //正式0403
    String sapUrl = "https://etl-prod-tasks.tysondt.com:443/api/1/rest/feed/run/task/TysonProd/Ultraprojects/team-fssc/tk_oa_to_sap_p2p?bearer_token=bBiGTA7PS0JJ6wKhQU8Vm0vLsIDNjLaN&interface_id=";
    //测试
    //String sapUrl = "https://etl-nonprod-tasks.tysondt.com:443/api/1/rest/feed/run/task/TysonNonProd/Ultra_PoC/10-QA-team-fssc/tk_oa_to_sap_p2p?bearer_token=bBiGTA7PS0JJ6wKhQU8Vm0vLsIDNjLaN&interface_id=";
    @Autowired
    private AsyncController asyncController;


    /***
     * 抵扣预付
     */
    @RequestMapping("DKYF")
    public String dkyf(String id) {

        System.out.println(id);
        asyncController.DKYF(id);

        return CusutUtil.SuccessReturnJsonString(200, "抵扣完成", "str");
    }

    /***
     * 成本中心校验
     */
    @RequestMapping("cbzxjy")
    public String cbzxjy(String cbzx, String gsdm) {

        JSONObject jsonObject = new JSONObject();
        try {
            System.out.println(cbzx);
            System.out.println(gsdm);
            if (cbzx != null && gsdm != null) {
                JSONArray cbzxs = new JSONArray(cbzx);

                for (int i = 0; i < cbzxs.length(); i++) {
                    if (cbzxs.getString(i).length() < 5) {
                        return CusutUtil.ErrorReturnJsonString(500, "成本中心错误", "str");
                    }
                    jsonObject.put("textField_l6lta36h", cbzxs.getString(i));
                    jsonObject.put("textField_l6lta36g", gsdm);
                    String s = dingUtil.yiDaSearch("FORM-0A966I8103W2GHC9BMMVK5YSTGYL2P0F9TL6L6", jsonObject);
                    logger.info("YiDaController (cbzxjy): YiDaSearchParams => " + jsonObject.toString());
                    logger.info("YiDaController (cbzxjy): YiDaSearchResult => " + s);
                    System.out.println(s);
                    JSONArray jsonArray = new JSONArray(s);
                    if (jsonArray.length() == 0) {
                        return CusutUtil.ErrorReturnJsonString(500, "成本中心错误", "str");
                    }
                }
            }
        } catch (Exception exception) {
            exception.printStackTrace();
            logger.error("YiDaController (cbzxjy): YiDaSearchResult => " + exception.getMessage());
        }
        return CusutUtil.SuccessReturnJsonString(200, "成功", "str");
    }

    /***
     * 生成凭证 -通用
     */
    @GetMapping("CreatePz")
    @ApiOperation("生成凭证 -通用")
    public String createPz(String id, String name, String type) {
        System.out.println(id);
        if (type.equals("PO")) {
            try {
                Thread.sleep(1000);
                asyncController.POCreatePZ(id, name);
            } catch (Exception ex) {

            }
        } else if (type.equals("NP")) {
            try {
                Thread.sleep(1000);
                asyncController.NPCreatePZ(id, name);
            } catch (Exception ex) {
                log.error("error,{}", ex);
            }
        } else if (type.equals("TE")) {
            try {
                Thread.sleep(1000);
                asyncController.TECreatePZ(id, name);
            } catch (Exception ex) {

            }

        } else if (type.equals("SAXY")) {
            try {
                Thread.sleep(1000);
                asyncController.SAXY(id);
            } catch (Exception ex) {

            }
        } else if (type.contains("TECreateSeqNo")) {
            try {
                Thread.sleep(1000);
                asyncController.TECreateSeqNo(id);
            } catch (Exception ex) {

            }
        } else if (type.contains("SA")) {
            try {
                Thread.sleep(1000);
                asyncController.SACreatePZ(id, name);
            } catch (Exception ex) {

            }
        } else if (type.contains("SD")) {
            try {
                Thread.sleep(1000);
                asyncController.SDCreatePz(id, name);
            } catch (Exception ex) {

            }
        } else if (type.contains("S_ARemove")) {
            try {
                Thread.sleep(1000);
                asyncController.SARemove(id, name);
            } catch (Exception ex) {

            }
        } else if (type.contains("Xsdd")) {
            try {
                Thread.sleep(1000);
                asyncController.XSddCreatePz(id);
            } catch (Exception ex) {

            }

        }
        return CusutUtil.SuccessReturnJsonString(200, "配置生成中", "str");
    }

    /***
     * 冲销凭证 -通用
     */
    @GetMapping("CreatePzBack")
    public String CreatePzBack(String id) {
        try {
            JSONObject jsonObject = new JSONObject(dingUtil.getYidaById(id));
            String selectField_l7irsycs = jsonObject.getString("selectField_l7irsycs");
            String textField_l7jvjyog = jsonObject.getString("textField_l7jvjyog");
            long dateField_l7irsyd9 = jsonObject.getLong("dateField_l7irsyd9");
            String name = jsonObject.get("employeeField_l7irsyda_id").toString();

            if (selectField_l7irsycs.equals("PO")) {
                String substring = jsonObject.getString("associationFormField_l7irsyct_id").replaceAll("\\\\", "").substring(1);
                JSONArray jsonArray = new JSONArray(substring.substring(0, substring.length() - 1));
                for (int i = 0; i < jsonArray.length(); i++) {
                    String instanceId = jsonArray.getJSONObject(i).getString("instanceId");
                    // instanceId = "efd9ab0b-6543-49d0-bda4-47ecaa484470";
                    PORemove(instanceId, name, textField_l7jvjyog, dateField_l7irsyd9);
                }

            } else if (selectField_l7irsycs.equals("NP")) {

                String substring = jsonObject.getString("associationFormField_l7irsycu_id").replaceAll("\\\\", "").substring(1);
                JSONArray jsonArray = new JSONArray(substring.substring(0, substring.length() - 1));
                for (int i = 0; i < jsonArray.length(); i++) {
                    String instanceId = jsonArray.getJSONObject(i).getString("instanceId");
                    NPRemove(instanceId, name, textField_l7jvjyog, dateField_l7irsyd9);
                }
            } else if (selectField_l7irsycs.equals("TE")) {

                String substring = jsonObject.getString("associationFormField_l7irsycv_id").replaceAll("\\\\", "").substring(1);
                JSONArray jsonArray = new JSONArray(substring.substring(0, substring.length() - 1));
                for (int i = 0; i < jsonArray.length(); i++) {
                    String instanceId = jsonArray.getJSONObject(i).getString("instanceId");
                    TERemove(instanceId, name, textField_l7jvjyog, dateField_l7irsyd9);
                }
            }
            return CusutUtil.SuccessReturnJsonString(200, "成功", "str");

        } catch (Exception exception) {
            exception.printStackTrace();
        }


        return CusutUtil.ErrorReturnJsonString(500, "类型错误", "str");
    }

    @RequestMapping("poPost")
    public String etst1(String id) {
        JSONObject jsonObject = new JSONObject();
        jsonObject.put("textField_l701pr3d", "");
        try {
            logger.info("YiDa Update : " + id + " => " + jsonObject.toString());
            String s = dingUtil.UpdateYiDa(id, jsonObject);
            logger.info("YiDaController (etst1): YiDaSearchParams => " + jsonObject.toString());
            logger.info("YiDaController (etst1): YiDaSearchResult => " + s);

        } catch (Exception exception) {
            logger.error("YiDaController (etst1): YiDaSearchResult => " + exception.getMessage());
            exception.printStackTrace();

        }
        return "";
    }

    /***
     * 付款结果通知
     *
     */
    @RequestMapping("FKJG")
    public String FKJG(HttpServletRequest request) {
        try {
            String postString = CusutUtil.getPostString(request);
            logger.info("FKJG Get Post : " + postString);
            JSONObject object = new JSONObject(postString);
            String seq = object.getString("textField_l6ypfj93");
            JSONObject update = new JSONObject();

            update.put("dateField_l7o5kchc", object.get("dateField_l6ypfj9d"));
            update.put("textField_l7o5kch6", object.get("textField_l6ypfj99"));
            if (!seq.equals("")) {
                JSONObject obj = new JSONObject();
                obj.put("textField_l7a342k7", seq);
                JSONArray data = new JSONArray(dingUtil.yiDaSearch("FORM-GC9664C1ALL2G3G5D6ZGNCYLX1FF2DG29TB6LQ", obj));
                logger.info("YiDaController (FKJG)821: YiDaSearchParams => " + obj.toString());

                if (data.length() > 0 && data.length() == 1) {

                    logger.info("YiDa Update : " + data.getJSONObject(0).getString("formInstanceId") + " => " + update.toString());
                    String res = dingUtil.UpdateYiDa(data.getJSONObject(0).getString("formInstanceId"), update);
                    logger.info("YiDaController (FKJG)826: YiDaUpdateParams => " + update.toString());
                    logger.info("YiDaController (FKJG)826: YiDaUpdateResult => " + res);
                }

                update = new JSONObject();
                update.put("dateField_l7oiem6x", object.get("dateField_l6ypfj9d"));
                update.put("textField_l7oiem6s", object.get("textField_l6ypfj99"));

                obj = new JSONObject();
                obj.put("textField_l7a6bzps", seq);
                data = new JSONArray(dingUtil.yiDaSearch("FORM-YU966T913NK2V4E4BUVZY5X8UWYR3842GVB6LA1", obj));
                logger.info("YiDaController (FKJG)837: YiDaSearchParams => " + obj.toString());
//                logger.info("YiDaController (FKJG)837: YiDaSearchResult => "+data.getJSONObject(0).toString());
                if (data.length() > 0 && data.length() == 1) {
                    logger.info("YiDa Update : " + data.getJSONObject(0).getString("formInstanceId") + " => " + update.toString());
                    String res = dingUtil.UpdateYiDa(data.getJSONObject(0).getString("formInstanceId"), update);
                    logger.info("YiDaController (FKJG)842: YiDaUpdateParams => " + update.toString());
                    logger.info("YiDaController (FKJG)842: YiDaUpdateResult => " + res);
                }

                update = new JSONObject();
                update.put("dateField_l7oiflf1", object.get("dateField_l6ypfj9d"));
                update.put("textField_l7oiflf0", object.get("textField_l6ypfj99"));

                obj = new JSONObject();
                obj.put("textField_l7a7bf8d", seq);
                data = new JSONArray(dingUtil.yiDaSearch("FORM-UX866Q61LRK2LACIB8A6M6T1ZOLM2VY5NYB6LZ", obj));
                logger.info("YiDaController (FKJG)853: YiDaSearchParams => " + obj.toString());
//                logger.info("YiDaController (FKJG)853: YiDaSearchResult => "+data.getJSONObject(0).toString());
                if (data.length() > 0 && data.length() == 1) {
                    if (seq.equals(data.getJSONObject(0).getJSONObject("formData").getString("textField_l7a7bf8d"))) {
                        logger.info("YiDa Update : " + data.getJSONObject(0).getString("formInstanceId") + " => " + update.toString());
                        String res = dingUtil.UpdateYiDa(data.getJSONObject(0).getString("formInstanceId"), update);
                        logger.info("YiDaController (FKJG)859: YiDaUpdateParams => " + update.toString());
                        logger.info("YiDaController (FKJG)859: YiDaUpdateResult => " + res);
                    }
                }
            }
            JSONObject qobject = object;
            qobject.remove("dateField_l6ypfj9d");

            JSONArray objectsa = new JSONArray(dingUtil.yiDaSearch("FORM-IS866QA1NX53H7P07JCJAAE0OX232UQFFPY6L0", qobject));

            for (int i = 0; i < objectsa.length(); i++) {

                logger.info("YiDa Delete : " + objectsa.getJSONObject(i).getString("formInstanceId"));
                String s = dingUtil.delete(objectsa.getJSONObject(i).getString("formInstanceId"));
                logger.info("YiDaController (FKJG)873: YiDaDeleteParams" + String.valueOf(i) + " => " + objectsa.getJSONObject(i).toString());
                logger.info("YiDaController (FKJG)873: YiDaDeleteResult" + String.valueOf(i) + " => " + s);
            }

            String res = dingUtil.saveYiDa("FORM-IS866QA1NX53H7P07JCJAAE0OX232UQFFPY6L0", object, dingConst.getUserId());
            logger.info("YiDaController (FKJG)878: YiDaSaveParams => " + object.toString());
            logger.info("YiDaController (FKJG)878: YiDaSaveResult => " + res);
            return res;
        } catch (Exception ex) {
            logger.error("FKJG : " + ex.getMessage());
            ex.printStackTrace();
            return "";
        }
    }

    /***
     * 付款建议通知
     *
     */
    @RequestMapping("FKJY")
    public String FKJY(HttpServletRequest request) {
        try {
            JSONObject object = new JSONObject(CusutUtil.getPostString(request));
            System.out.println(object);
            logger.info("SAP Request:" + object.toString());
//            Logger.getGlobal().info("SAP Request: "+object.toString());
            String name = object.get("name").toString();
            JSONObject obj = new JSONObject();
            obj.put("textField_l6djch1m", name);
            JSONArray data = new JSONArray(dingUtil.yiDaSearch("FORM-4J7669A10FO250UJ9C6Q7CM00PC62YPW8DD6LT", obj));

            if (data.length() == 0) {
                System.out.println("工号不存在");
                logger.error("工号不存在");
                return CusutUtil.ErrorReturnJsonString(500, "工号不存在");
            }
            logger.info("YiDaController (FKJY)903: YiDaSearchParams => " + obj.toString());
            logger.info("YiDaController (FKJY)903: YiDaSearchResult => " + data.getJSONObject(0).toString());
            JSONObject formData = data.getJSONObject(0).getJSONObject("formData");
            String uid = formData.get("textField_l6dddg5k").toString();
            if (object.has("textField_l6ynwh4k")) {
                if (object.getString("textField_l6ynwh4k").contains("U")) {
                    object.put("textField_l7u77g5m", "紧急");
                } else {
                    object.put("textField_l7u77g5m", "普通");
                }
            }
            double je = 0;
            if (object.has("tableField_l6ynwh4n")) {
                JSONArray jsonArray = new JSONArray();
                JSONArray tableField_l6ynwh4n = object.getJSONArray("tableField_l6ynwh4n");
                for (int i = 0; i < tableField_l6ynwh4n.length(); i++) {
                    JSONObject jsonObject = tableField_l6ynwh4n.getJSONObject(i);
                    jsonObject.put("selectField_l7iumq5s", "Y");
                    double numberField_l6ynwh4y = jsonObject.getDouble("numberField_l6ynwh4y");
                    je += numberField_l6ynwh4y;
                    jsonArray.put(jsonObject);
                }

                object.remove("tableField_l6ynwh4n");
                object.put("tableField_l6ynwh4n", jsonArray);
            }

            object.put("numberField_l7u77g5h", je);
//            System.out.println(object);
            logger.info("YiDaController (FKJY)941: " + object.toString());
            String res = dingUtil.startInstance(object, uid, "FORM-EX866CB1AQ53B88TFDV6GCDOHV4M3LHGUNY6LF");
            logger.info("YiDaController (FKJY)941:  " + res);
            return res;
        } catch (Exception ex) {
            ex.printStackTrace();
            logger.error("Exception: " + ex.getMessage());
            return CusutUtil.ErrorReturnJsonString(500, "接口异常", "str");
        }
    }

    /***
     * 发票凭证生成 - sap013
     */
    @RequestMapping("POsap013")
    public String POsap013(String id) {
        try {
            JSONObject object = new JSONObject(dingUtil.getYidaById(id));
            logger.info("YiDaController (POsap013)956:  " + object.toString());
            JSONObject upJson = new JSONObject();
            String startTime = CusutUtil.getNowDate("yyyyMMdd");
            if ("".equals(object.getString("textField_l7a342k7"))) {
                JSONObject obj = new JSONObject();
                obj.put("textField_l7a7xqg2", object.get("textField_l7a7xqg2"));
                String res = dingUtil.yiDaSearch("FORM-GC9664C1ALL2G3G5D6ZGNCYLX1FF2DG29TB6LQ", obj);
                logger.info("YiDaController (POsap013)963:  " + res);
                JSONArray data = new JSONArray(res);

                String str = (100000 + data.length() + 1) + "";
                object.remove("textField_l7a342k7");
                object.put("textField_l7a342k7", object.getString("textField_l7a7xqg2") + str.substring(1, str.length()));
                upJson.put("textField_l7a342k7", object.get("textField_l7a342k7"));
            }
            JSONObject sapJson = new JSONObject();
            sapJson.put("ZOA_NUMBER", object.get("textField_l7a342k7"));    //OA单据号
            sapJson.put("ZOA_TYPE", "PO");    //OA单据类型
            sapJson.put("BUKRS", object.get("textField_l6c19doa"));    //公司代码
            sapJson.put("BELNR", object.get("textField_l6czvx07"));    //发票凭证编号
            sapJson.put("GJAHR", object.get("textField_l6x1rkjh"));    //会计年度
            System.out.println(sapJson);
            System.out.println(sapUrl + "SAP013");
            String post = HttpUtil.post(sapUrl + "SAP013", null, sapJson.toString(), null);
            if (!post.equals("")) {
                //状态改为已终止
                logger.info("YiDaController (POsap013)980:  " + post);
                String r = dingUtil.UpdateYiDa(id, upJson);
                logger.info("YiDaController (POsap013)985:  " + upJson);
                logger.info("YiDaController (POsap013)985:  " + r);

            }
            return CusutUtil.SuccessReturnJsonString(200, "成功", "str");
        } catch (Exception ex) {
            ex.printStackTrace();
            logger.error("YiDaController (POsap013)990: " + ex.getMessage());
            return CusutUtil.SuccessReturnJsonString(500, "接口异常500,请联系管理员或开发者处理", "str");
        }
    }


    /***
     * 付款建议流程
     * @return
     */
    @RequestMapping("fkjy")
    @ApiOperation("付款建议流程")
    public String fkjy(String id, String type) {
        try {
            JSONObject object = new JSONObject(dingUtil.getYidaById(id));
            logger.info("YiDaController (fkjy)1005: Result => " + object.toString());
            logger.info("YiDaController (fkjy)1005: Param => " + id);
            String startTime = CusutUtil.getNowDate("yyyyMMdd");
            JSONObject sapJson = new JSONObject();
            sapJson.put("BUKRS", object.get("textField_l6ynwh49"));    //公司代码
            sapJson.put("LAUFI", object.get("textField_l6ynwh4k"));    //付款建议ID
            sapJson.put("LAUFD", CusutUtil.getFormatDate(object.getLong("dateField_l6ynwh4m")));    //建议运行日期

            JSONArray item = new JSONArray();

            if (object.has("tableField_l6ynwh4n") && object.getJSONArray("tableField_l6ynwh4n").length() > 0) {
                for (int i = 0; i < object.getJSONArray("tableField_l6ynwh4n").length(); i++) {
                    JSONObject item_ZB = object.getJSONArray("tableField_l6ynwh4n").getJSONObject(i);
                    JSONObject fyjyzb = new JSONObject();
                    fyjyzb.put("ZITEM_NO", (i + 1) + "");
                    fyjyzb.put("GUID", item_ZB.get("textField_l6ynwh4o"));   //UUID
                    fyjyzb.put("ZAPPROVE", type);
                    fyjyzb.put("ZAPPROVE_DATE", startTime);//审批日期

                    item.put(fyjyzb);
                }
            }

            sapJson.put("ITEM", item);

            System.out.println(sapJson);
            logger.info("MEMO发起POST请求：URL={},参数={}", sapUrl, sapJson);
            String post = HttpUtil.post(sapUrl + "SAP014", null, sapJson.toString(), null);
            logger.info("MEMOPOST请求完成：响应={}", post);
            if (!post.equals("")) {
                System.out.println("SAP014");
                System.out.println(post);
                System.out.println("post:" + post);

                JSONObject jsonObject = new JSONObject();
                jsonObject.put("dateField_l6yss6g6", CusutUtil.dateTOtimeshapYYMMDD(startTime));
                jsonObject.put("textField_libbv5oq", "是");
                logger.info("YiDa Update : " + id + " => " + jsonObject.toString());
                dingUtil.UpdateYiDa(id, jsonObject);
            }
            return CusutUtil.SuccessReturnJsonString(200, "成功", "str");
        } catch (Exception ex) {
            ex.printStackTrace();
            return CusutUtil.SuccessReturnJsonString(500, "接口异常500,请联系管理员或开发者处理", "str");
        }
    }

    /***
     * 付款建议流程
     * @return
     */
    @RequestMapping("TEXF")
    public String TEXF(String id) {
        try {
            JSONObject object = new JSONObject(dingUtil.getYidaById(id));
            logger.info("YiDaController (TEXF)1058: Result => " + object.toString());
            logger.info("YiDaController (TEXF)1058: Param => " + id);
            JSONObject jsonObject = new JSONObject();

            JSONArray item = new JSONArray();

            if (object.has("tableField_l6lmxo5r") && object.getJSONArray("tableField_l6lmxo5r").length() > 0) {
                for (int i = 0; i < object.getJSONArray("tableField_l6lmxo5r").length(); i++) {
                    JSONObject item_ZB = object.getJSONArray("tableField_l6lmxo5r").getJSONObject(i);

                    if (!item_ZB.has("numberField_l6lmxo61")) {
                        item_ZB.put("numberField_l6lmxo61", 0);
                    }
                    if (item_ZB.get("numberField_l6lmxo61").toString().equals("")) {
                        item_ZB.remove("numberField_l6lmxo61");
                        item_ZB.put("numberField_l6lmxo61", 0);
                    }
                    item.put(item_ZB);
                }
            }

            jsonObject.put("tableField_l6lmxo5r", item);

            logger.info("YiDa Update : " + id + " => " + jsonObject.toString());
            dingUtil.UpdateYiDa(id, jsonObject);

            return CusutUtil.SuccessReturnJsonString(200, "成功", "str");
        } catch (Exception ex) {
            ex.printStackTrace();
            return CusutUtil.SuccessReturnJsonString(500, "接口异常500,请联系管理员或开发者处理", "str");
        }
    }


    @RequestMapping("NPXF")
    public String NPXF(String id) {
        try {
            JSONObject object = new JSONObject(dingUtil.getYidaById(id));

            JSONObject jsonObject = new JSONObject();

            JSONArray item = new JSONArray();

            if (object.has("tableField_l6bwb4hj") && object.getJSONArray("tableField_l6bwb4hj").length() > 0) {
                for (int i = 0; i < object.getJSONArray("tableField_l6bwb4hj").length(); i++) {
                    JSONObject item_ZB = object.getJSONArray("tableField_l6bwb4hj").getJSONObject(i);

                    if (!item_ZB.has("numberField_l6bx7hqh")) {
                        item_ZB.put("numberField_l6bx7hqh", 0);
                    }
                    if (item_ZB.get("numberField_l6bx7hqh").toString().equals("")) {
                        item_ZB.remove("numberField_l6bx7hqh");
                        item_ZB.put("numberField_l6bx7hqh", 0);
                    }
                    item.put(item_ZB);
                }
            }

            jsonObject.put("tableField_l6bwb4hj", item);

            logger.info("YiDa Update : " + id + " => " + jsonObject.toString());
            dingUtil.UpdateYiDa(id, jsonObject);

            return CusutUtil.SuccessReturnJsonString(200, "成功", "str");
        } catch (Exception ex) {
            ex.printStackTrace();
            return CusutUtil.SuccessReturnJsonString(500, "接口异常500,请联系管理员或开发者处理", "str");
        }
    }

    public String PORemove(String id, String name, String remake, long time) {
        try {
            JSONObject upJson = new JSONObject();
            String start_time = CusutUtil.getFormatDate(time);
            logger.info("name" + name);
            System.out.println(name);
            JSONObject object = new JSONObject(dingUtil.getYidaById(id));

            JSONObject sapJson = new JSONObject();
            sapJson.put("ZOA_NUMBER", object.get("textField_l7a342k7"));  //OA单据号
            sapJson.put("ZFUND", object.get("selectField_l6btftfn"));//付款类型
            sapJson.put("ZPAY_AMT", object.get("numberField_l6czvx0w"));       //支付金额
            sapJson.put("ZINVOICE_AMT", object.get("numberField_l6czvx0g"));      //发票总额
            sapJson.put("BUKRS", object.get("textField_l6c19doa"));       //公司代码
            if (object.get("selectField_l6btftfn").toString().contains("预付")) {
                sapJson.put("ZOA_TYPE", "AD");  //OA单据类型
                sapJson.put("BELNR_FI", object.get("textField_l7imtdo3"));      //财务凭证编号
            } else {
                sapJson.put("ZOA_TYPE", "PO");  //OA单据类型
                sapJson.put("BELNR_MM", object.get("textField_l6czvx07"));      //发票凭证编号
            }

            if (object.get("selectField_l6btftfn").toString().contains("进度")) {
                sapJson.put("ZOA_TYPE", "AD");  //OA单据类型
                sapJson.put("BELNR_FI", object.get("textField_l7imtdo3"));      //财务凭证编号
                sapJson.put("BELNR_MM", object.get("textField_l6czvx07"));      //发票凭证编号
            }

            sapJson.put("GJAHR", object.get("textField_l6x1rkjh"));       //会计年度
            sapJson.put("STGRD", remake);       //冲销原因
            sapJson.put("BUDAT", start_time);       //过账日期
            sapJson.put("USNAM", "TEST-CN001");       //过账人
            logger.info("sapJson:" + sapJson);
            System.out.println(sapJson);
            String post = HttpUtil.post(sapUrl + "SAP008", null, sapJson.toString(), null);
            if (!post.equals("")) {
                JSONObject postJsonObject = new JSONArray(post).getJSONObject(0);
                logger.info("post:" + post);
                System.out.println(post);
                if (!postJsonObject.getString("E_BELNR").equals("")) {
                    upJson.put("textField_l6yt596a", postJsonObject.getString("E_BELNR"));
                    upJson.put("dateField_l7a77uhz", CusutUtil.dateTOtimeshapYYMMDD(start_time));
                    upJson.put("textField_l7frpr3s", remake);
                }
            }
            logger.info("YiDa Update : " + id + " => " + upJson.toString());
            dingUtil.UpdateYiDa(id, upJson);
            return CusutUtil.SuccessReturnJsonString(200, "成功", "str");
        } catch (Exception ex) {
            ex.printStackTrace();
            return CusutUtil.SuccessReturnJsonString(500, "接口异常500,请联系管理员或开发者处理", "str");
        }
    }

    /***
     * 查询票夹数据 -byId -通用//
     * @param id
     * @return
     */
    public String PjgetByid(String id, String oper) {
        try {
            JSONObject object = new JSONObject(dingUtil.getYidaById(id));
            if (!object.has("textField_l6u55vd8")) {
                return "";
            }
            if (!object.getString("textField_l6u55vd8").contains("发票")) {
                return "";
            }
            if (object.getString("textField_l6u55vd3").equals("") && object.getString("textField_l6u55vd9").equals("")) {
                return "";
            }


            JSONObject jsonObject = new JSONObject();
            if (object.getString("textField_l6u55vd8").contains("全电")) {
                jsonObject.put("invoicecode", "全电发票");
            } else {
                jsonObject.put("invoicecode", object.getString("textField_l6u55vd9"));
            }
            jsonObject.put("taxno", object.getString("textField_l6u55vdn"));

            jsonObject.put("invoicenumber", object.getString("textField_l6u55vd3"));
            jsonObject.put("usetax", object.get("textField_l6vu65fs").toString());
            try {
                if (!object.has("textField_l6vvuq3f") || object.getString("textField_l6vvuq3f").equals("")) {
                    object.remove("textField_l6vvuq3f");
                    object.put("textField_l6vvuq3f", "0");
                }
                jsonObject.put("taxrate", Double.parseDouble(object.getString("textField_l6vvuq3f").substring(0, object.getString("textField_l6vvuq3f").lastIndexOf("%"))) / 100);
            } catch (Exception ex) {
                try {
                    jsonObject.put("taxrate", Double.parseDouble(object.getString("textField_l6vvuq3f")) / 100);
                } catch (Exception ex2) {
                    jsonObject.put("taxrate", 0);
                }
            }
            jsonObject.put("autodeduct", "1");
            jsonObject.put("oper", oper);

            return jsonObject.toString();
        } catch (Exception exception) {
            exception.printStackTrace();
        }
        return "";
    }


    /***
     * PO金额归集
     */
    @RequestMapping("POGj")
    public String POgj(String id) {
        try {
            JSONObject jsonObject = new JSONObject(dingUtil.getYidaById(id));
            if (jsonObject.has("tableField_l6btfti5")) {

                for (int i = 0; i < jsonObject.getJSONArray("tableField_l6btfti5").length(); i++) {
                    JSONObject itemJson = jsonObject.getJSONArray("tableField_l6btfti5").getJSONObject(i);
                    JSONObject upjson = new JSONObject();
                    upjson.put("textField_l7smls2z", itemJson.getString("textField_l6x1rkjk"));
                    upjson.put("textField_l7smls30", itemJson.getString("textField_l6czvx0h"));
                    JSONObject obj = new JSONObject();
                    obj.put("textField_l7smls2z", upjson.get("textField_l7smls2z"));
                    obj.put("textField_l7smls30", upjson.get("textField_l7smls30"));
                    JSONArray data = new JSONArray(dingUtil.yiDaSearch("FORM-Z2666J81L1Q3B6MUE5B5VCFYM11S3OXALMS7LR", obj));
                    if (!itemJson.has("numberField_l7sowiqy")) {
                        return CusutUtil.SuccessReturnJsonString(200, "成功", "str");
                    }
                    double sum = itemJson.getDouble("numberField_l7sowiqy");
                    if (data.length() > 0) {
                        sum += data.getJSONObject(0).getJSONObject("formData").getDouble("numberField_l7smls31");
                        upjson.put("numberField_l7smls31", sum);
                        logger.info("金额归集 YiDa Update : " + data.getJSONObject(0).getString("formInstanceId") + " => " + upjson.toString());
                        dingUtil.UpdateYiDa(data.getJSONObject(0).getString("formInstanceId"), upjson);

                    } else {
                        upjson.put("numberField_l7smls31", sum);

                        String return_id = dingUtil.saveYiDa("FORM-Z2666J81L1Q3B6MUE5B5VCFYM11S3OXALMS7LR", upjson, dingConst.getUserId());
                        logger.info("YiDa Return Data :" + return_id);

                    }
                }
            }
            return CusutUtil.SuccessReturnJsonString(200, "成功", "str");
        } catch (Exception ex) {
            ex.printStackTrace();
            return CusutUtil.SuccessReturnJsonString(500, "接口异常500,请联系管理员或开发者处理", "str");
        }
    }


    /***
     * 发票勾选返回
     */
    @PostMapping("bookkeepingBack")
    public String bookkeepingBack(HttpServletRequest request) {
        JSONArray jsonArray = new JSONArray(CusutUtil.getPostString(request));
        try {
            for (int i = 0; i < jsonArray.length(); i++) {
                JSONObject jsonObject = jsonArray.getJSONObject(i);
                try {
                    JSONObject queryJson = new JSONObject();
                    //PO
                    queryJson = new JSONObject();

                    queryJson.put("textField_l6yt5969", jsonObject.get("vouchernumber"));
                    JSONArray objects = new JSONArray(dingUtil.yiDaSearch("FORM-GC9664C1ALL2G3G5D6ZGNCYLX1FF2DG29TB6LQ", queryJson));

                    if (objects.length() > 0) {
                        String formInstanceId = objects.getJSONObject(0).getString("formInstanceId");
                        JSONObject UpJson = new JSONObject();
                        JSONArray uparray = new JSONArray();

                        JSONArray tableField_l6otidfq = objects.getJSONObject(0).getJSONObject("formData").getJSONArray("tableField_l6otidfq");
                        JSONArray invoices = jsonObject.getJSONArray("invoices");
                        for (int j = 0; j < invoices.length(); j++) {
                            JSONObject invoicesJSONObject = invoices.getJSONObject(j);


                            String operstatus = invoicesJSONObject.get("operstatus").toString();

                            if (operstatus.contains("1")) {
                                operstatus = "抵扣勾选完成";
                            } else if (operstatus.contains("0")) {
                                operstatus = "撤销抵扣勾选完成";
                            }
                            queryJson = new JSONObject();
                            queryJson.put("textField_l6u55vd9", invoicesJSONObject.get("invoicecode"));
                            queryJson.put("textField_l6u55vd3", invoicesJSONObject.get("invoicenumber"));
                            JSONArray objects_fp = new JSONArray(dingUtil.yiDaSearch("FORM-4J7669A1Z1X22RIL61LB7AOXGRX82OHP45U6L51", queryJson));

                            if (objects_fp.length() > 0) {
                                String formInstanceId_fp = objects_fp.getJSONObject(0).getString("formInstanceId");
                                JSONObject UpJson_fp = new JSONObject();

                                UpJson_fp.put("textField_l7efm5az", operstatus);
                                for (int l = 0; l < tableField_l6otidfq.length(); l++) {
                                    JSONObject itemJson = tableField_l6otidfq.getJSONObject(l);
                                    if (itemJson.getString("associationFormField_l6ygli4c_id").contains(formInstanceId_fp)) {
                                        itemJson.put("textField_l6q3aelu", operstatus);
                                        uparray.put(itemJson);
                                        break;
                                    }
                                }
                                logger.info("发票勾选返回po YiDa Update : " + formInstanceId_fp + " => " + UpJson_fp.toString());
                                dingUtil.UpdateYiDa(formInstanceId_fp, UpJson_fp);
                            }
                        }
                        UpJson.put("tableField_l6otidfq", uparray);
                        logger.info("发票勾选返回po YiDa Update : " + formInstanceId + " => " + UpJson.toString());
                        dingUtil.UpdateYiDa(formInstanceId, UpJson);
                    }

                    //NP
                    queryJson = new JSONObject();

                    queryJson.put("textField_l701yhu3", jsonObject.get("vouchernumber"));
                    objects = new JSONArray(dingUtil.yiDaSearch("FORM-YU966T913NK2V4E4BUVZY5X8UWYR3842GVB6LA1", queryJson));

                    if (objects.length() > 0) {
                        String formInstanceId = objects.getJSONObject(0).getString("formInstanceId");
                        JSONObject UpJson = new JSONObject();
                        JSONArray uparray = new JSONArray();

                        JSONArray tableField_l6bwb4hj = objects.getJSONObject(0).getJSONObject("formData").getJSONArray("tableField_l6bwb4hj");
                        JSONArray invoices = jsonObject.getJSONArray("invoices");
                        for (int j = 0; j < invoices.length(); j++) {
                            JSONObject invoicesJSONObject = invoices.getJSONObject(j);


                            String operstatus = invoicesJSONObject.get("operstatus").toString();

                            if (operstatus.contains("1")) {
                                operstatus = "抵扣勾选完成";
                            } else if (operstatus.contains("0")) {
                                operstatus = "撤销抵扣勾选完成";
                            }
                            queryJson = new JSONObject();
                            queryJson.put("textField_l6u55vd9", invoicesJSONObject.get("invoicecode"));
                            queryJson.put("textField_l6u55vd3", invoicesJSONObject.get("invoicenumber"));
                            JSONArray objects_fp = new JSONArray(dingUtil.yiDaSearch("FORM-4J7669A1Z1X22RIL61LB7AOXGRX82OHP45U6L51", queryJson));

                            if (objects_fp.length() > 0) {
                                String formInstanceId_fp = objects_fp.getJSONObject(0).getString("formInstanceId");
                                JSONObject UpJson_fp = new JSONObject();

                                UpJson_fp.put("textField_l7efm5az", operstatus);
                                for (int l = 0; l < tableField_l6bwb4hj.length(); l++) {
                                    JSONObject itemJson = tableField_l6bwb4hj.getJSONObject(l);
                                    if (itemJson.getString("associationFormField_l6yglav7_id").contains(formInstanceId_fp)) {
                                        itemJson.put("textField_l6q3cn36", operstatus);
                                        uparray.put(itemJson);
                                        break;
                                    }
                                }
                                logger.info("发票勾选返回np YiDa Update : " + formInstanceId_fp + " => " + UpJson_fp.toString());
                                dingUtil.UpdateYiDa(formInstanceId_fp, UpJson_fp);
                            }
                        }
                        UpJson.put("tableField_l6bwb4hj", uparray);
                        logger.info("发票勾选返回np YiDa Update : " + formInstanceId + " => " + UpJson.toString());
                        dingUtil.UpdateYiDa(formInstanceId, UpJson);
                    }

                    //TE
                    queryJson = new JSONObject();

                    queryJson.put("textField_l7a7bf81", jsonObject.get("vouchernumber"));
                    objects = new JSONArray(dingUtil.yiDaSearch("FORM-UX866Q61LRK2LACIB8A6M6T1ZOLM2VY5NYB6LZ", queryJson));

                    if (objects.length() > 0) {
                        String formInstanceId = objects.getJSONObject(0).getString("formInstanceId");
                        JSONObject UpJson = new JSONObject();
                        JSONArray uparray = new JSONArray();

                        JSONArray tableField_l6lmxo5r = objects.getJSONObject(0).getJSONObject("formData").getJSONArray("tableField_l6lmxo5r");
                        JSONArray invoices = jsonObject.getJSONArray("invoices");
                        for (int j = 0; j < invoices.length(); j++) {
                            JSONObject invoicesJSONObject = invoices.getJSONObject(j);


                            String operstatus = invoicesJSONObject.get("operstatus").toString();

                            if (operstatus.contains("1")) {
                                operstatus = "抵扣勾选完成";
                            } else if (operstatus.contains("0")) {
                                operstatus = "撤销抵扣勾选完成";
                            }
                            queryJson = new JSONObject();
                            queryJson.put("textField_l6u55vd9", jsonObject.get("invoicecode"));
                            queryJson.put("textField_l6u55vd3", jsonObject.get("invoicenumber"));
                            JSONArray objects_fp = new JSONArray(dingUtil.yiDaSearch("FORM-4J7669A1Z1X22RIL61LB7AOXGRX82OHP45U6L51", queryJson));

                            if (objects_fp.length() > 0) {
                                String formInstanceId_fp = objects_fp.getJSONObject(0).getString("formInstanceId");
                                JSONObject UpJson_fp = new JSONObject();

                                UpJson_fp.put("textField_l7efm5az", operstatus);
                                for (int l = 0; l < tableField_l6lmxo5r.length(); l++) {
                                    JSONObject itemJson = tableField_l6lmxo5r.getJSONObject(l);
                                    if (itemJson.getString("associationFormField_l6vk2yxg_id").contains(formInstanceId_fp)) {
                                        itemJson.put("textField_l6q8uw0g", operstatus);
                                        uparray.put(itemJson);
                                        break;
                                    }
                                }
                                logger.info("发票勾选返回te YiDa Update : " + formInstanceId_fp + " => " + UpJson_fp.toString());
                                dingUtil.UpdateYiDa(formInstanceId_fp, UpJson_fp);
                            }
                        }
                        UpJson.put("tableField_l6lmxo5r", uparray);
                        logger.info("发票勾选返回te YiDa Update : " + formInstanceId + " => " + UpJson.toString());
                        dingUtil.UpdateYiDa(formInstanceId, UpJson);
                    }

                } catch (Exception exception) {
//                    exception.printStackTrace();
                    continue;
                }
            }
            JSONObject returnJson = new JSONObject();
            returnJson.put("returncode", 1);
            returnJson.put("returnmsg", "成功");
            return returnJson.toString();
        } catch (Exception ex) {
            JSONObject returnJson = new JSONObject();
            returnJson.put("returncode", 1);
            returnJson.put("returnmsg", ex.getMessage());
            return returnJson.toString();
        }
    }

    /***
     * 发票勾选实现
     */
    @Async
    public String bookkeeping(String id, String type) {
        try {
            JSONObject object = new JSONObject(dingUtil.getYidaById(id));

            String nowDate = CusutUtil.getNowDate();
            JSONArray bookkeepingJArray = new JSONArray();
            JSONObject bookkeepingJObj = new JSONObject();
            bookkeepingJObj.put("voucherstatus", "0");
            bookkeepingJObj.put("voucherdate", nowDate);
            bookkeepingJObj.put("applytime", nowDate);
            bookkeepingJObj.put("syssource", "第三方系统规定");
            bookkeepingJObj.put("bookeepflag", "1");
            JSONArray invoices = new JSONArray();
            JSONObject upJson = new JSONObject();
            ArrayList<String> ids = new ArrayList<>();
            if ("PO".equals(type)) {
                bookkeepingJObj.put("vouchernumber", object.getString("textField_l6yt5969"));

                if (object.has("tableField_l6otidfq") && object.getJSONArray("tableField_l6otidfq").length() > 0) {
                    JSONArray tableField_l6otidfq = object.getJSONArray("tableField_l6otidfq");
                    for (int i = 0; i < tableField_l6otidfq.length(); i++) {
                        JSONObject jsonObject = tableField_l6otidfq.getJSONObject(i);
                        String substring = jsonObject.getString("associationFormField_l6ygli4c_id").replaceAll("\\\\", "").substring(1);
                        String instanceId = new JSONArray(substring.substring(0, substring.length() - 1)).getJSONObject(0).getString("instanceId");
                        String s = PjgetByid(instanceId, "1");
                        if (!"".equals(s)) {
                            invoices.put(new JSONObject(s));
                            ids.add(instanceId);
                        }

                    }
                    upJson.put("tableField_l6otidfq", tableField_l6otidfq);
                }
            } else if ("NP".equals(type)) {
                bookkeepingJObj.put("vouchernumber", object.getString("textField_l78k02x3"));
                if (object.has("tableField_l6bwb4hj") && object.getJSONArray("tableField_l6bwb4hj").length() > 0) {
                    JSONArray tableField_l6bwb4hj = object.getJSONArray("tableField_l6bwb4hj");
                    for (int i = 0; i < tableField_l6bwb4hj.length(); i++) {
                        JSONObject jsonObject = tableField_l6bwb4hj.getJSONObject(i);
                        String substring = jsonObject.getString("associationFormField_l6yglav7_id").replaceAll("\\\\", "").substring(1);
                        String instanceId = new JSONArray(substring.substring(0, substring.length() - 1)).getJSONObject(0).getString("instanceId");
                        String s = PjgetByid(instanceId, "1");
                        if (!"".equals(s)) {
                            invoices.put(new JSONObject(s));
                            ids.add(instanceId);
                        }
                    }
                    upJson.put("tableField_l6bwb4hj", tableField_l6bwb4hj);
                }
            } else if ("TE".equals(type)) {
                bookkeepingJObj.put("vouchernumber", object.getString("textField_l7a7bf81"));
                if (object.has("tableField_l6lmxo5r") && object.getJSONArray("tableField_l6lmxo5r").length() > 0) {
                    JSONArray tableField_l6lmxo5r = object.getJSONArray("tableField_l6lmxo5r");
                    for (int i = 0; i < tableField_l6lmxo5r.length(); i++) {
                        JSONObject jsonObject = tableField_l6lmxo5r.getJSONObject(i);
                        String substring = jsonObject.getString("associationFormField_l6vk2yxg_id").replaceAll("\\\\", "").substring(1);
                        String instanceId = new JSONArray(substring.substring(0, substring.length() - 1)).getJSONObject(0).getString("instanceId");
                        String s = PjgetByid(instanceId, "1");
                        if (!"".equals(s)) {
                            invoices.put(new JSONObject(s));
                            ids.add(instanceId);
                        }
                    }
                    upJson.put("tableField_l6lmxo5r", tableField_l6lmxo5r);
                }
            }
            bookkeepingJObj.put("invoices", invoices);
            bookkeepingJArray.put(bookkeepingJObj);

            System.out.println(bookkeepingJArray);
            logger.info("{}", bookkeepingJArray);

            String post = HttpUtil.post("http://106.15.251.153:8091/stms/openapi/income/bookkeeping", null, bookkeepingJArray.toString(), null);
            if (!"".equals(post)) {
                System.out.println(CusutUtil.unicodeDecode(post));
                logger.info("发票勾选实现 post：" + CusutUtil.unicodeDecode(post));
                JSONObject jsonObject = new JSONObject(CusutUtil.unicodeDecode(post));
                if (jsonObject.getString("code").equals("0000")) {
                    JSONArray data = jsonObject.getJSONArray("data");
                    Iterator<String> keys = upJson.keys();
                    JSONArray jsonArray = new JSONArray();
                    String key = "";
                    while (keys.hasNext()) {
                        key = keys.next();
                        jsonArray = upJson.getJSONArray(key);
                    }
                    JSONArray upjsonarray = new JSONArray();
                    for (int i = 0; i < data.length(); i++) {
                        JSONObject dataJSONObject = data.getJSONObject(i);
                        JSONObject jsonArrayJSONObject = jsonArray.getJSONObject(i);
                        String returnmsg = dataJSONObject.getString("returnmsg");
                        if (type.equals("PO")) {
                            jsonArrayJSONObject.remove("textField_l6q3aelu");
                            jsonArrayJSONObject.put("textField_l6q3aelu", returnmsg);
                            upjsonarray.put(jsonArrayJSONObject);
                        } else if (type.equals("NP")) {
                            jsonArrayJSONObject.remove("textField_l6q3cn36");
                            jsonArrayJSONObject.put("textField_l6q3cn36", returnmsg);
                            upjsonarray.put(jsonArrayJSONObject);
                        } else if (type.equals("TE")) {
                            jsonArrayJSONObject.remove("textField_l6q8uw0g");
                            jsonArrayJSONObject.put("textField_l6q8uw0g", returnmsg);
                            upjsonarray.put(jsonArrayJSONObject);
                        }
                        logger.info("发票勾选实现 YiDa Update : " + ids.get(i) + " => " + new JSONObject().put("textField_l7efm5az", returnmsg));
                        dingUtil.UpdateYiDa(ids.get(i), new JSONObject().put("textField_l7efm5az", returnmsg));
                    }
                    upJson.remove(key);
                    upJson.put(key, upjsonarray);
                    logger.info("发票勾选实现 YiDa Update : " + id + " => " + upJson);
                    dingUtil.UpdateYiDa(id, upJson);
                } else {
                    logger.info("接口返回值异常");
                    return CusutUtil.SuccessReturnJsonString(500, "接口返回值异常" + jsonObject, "str");
                }
            }
            return CusutUtil.SuccessReturnJsonString(200, "成功", "str");
        } catch (Exception ex) {
            ex.printStackTrace();
            logger.info("exception:" + ex.getMessage());
            return CusutUtil.SuccessReturnJsonString(500, "接口异常500,请联系管理员或开发者处理", "str");
        }
    }


    /***
     * 发票反勾选实现
     */
    @GetMapping("bookkeepingBack")
    public String bookkeepingBack(String id, String type) {
        try {
            JSONObject object = new JSONObject(dingUtil.getYidaById(id));

            String nowDate = CusutUtil.getNowDate();
            JSONArray bookkeepingJArray = new JSONArray();
            JSONObject bookkeepingJObj = new JSONObject();
            bookkeepingJObj.put("voucherstatus", "1");
            bookkeepingJObj.put("voucherdate", nowDate);
            bookkeepingJObj.put("applytime", nowDate);
            bookkeepingJObj.put("syssource", "第三方系统规定");
            bookkeepingJObj.put("bookeepflag", "0");
            JSONArray invoices = new JSONArray();
            JSONObject upJson = new JSONObject();
            ArrayList<String> ids = new ArrayList<>();
            if ("PO".equals(type)) {
                bookkeepingJObj.put("vouchernumber", object.getString("textField_l7imtdo3"));

                if (object.has("tableField_l6otidfq") && object.getJSONArray("tableField_l6otidfq").length() > 0) {
                    JSONArray tableField_l6otidfq = object.getJSONArray("tableField_l6otidfq");
                    for (int i = 0; i < tableField_l6otidfq.length(); i++) {
                        JSONObject jsonObject = tableField_l6otidfq.getJSONObject(i);
                        String substring = jsonObject.getString("associationFormField_ky9jivit_id").replaceAll("\\\\", "").substring(1);
                        String instanceId = new JSONArray(substring.substring(0, substring.length() - 1)).getJSONObject(0).getString("instanceId");
                        String s = PjgetByid(instanceId, "0");
                        if (!"".equals(s)) {
                            invoices.put(new JSONObject(s));
                            ids.add(instanceId);
                        }

                    }
                    upJson.put("tableField_l6otidfq", tableField_l6otidfq);
                }
            } else if ("NP".equals(type)) {
                bookkeepingJObj.put("vouchernumber", object.getString("textField_l78k02x3"));
                if (object.has("tableField_l6bwb4hj") && object.getJSONArray("tableField_l6bwb4hj").length() > 0) {
                    JSONArray tableField_l6bwb4hj = object.getJSONArray("tableField_l6bwb4hj");
                    for (int i = 0; i < tableField_l6bwb4hj.length(); i++) {
                        JSONObject jsonObject = tableField_l6bwb4hj.getJSONObject(i);
                        String substring = jsonObject.getString("associationFormField_l6yglav7_id").replaceAll("\\\\", "").substring(1);
                        String instanceId = new JSONArray(substring.substring(0, substring.length() - 1)).getJSONObject(0).getString("instanceId");
                        String s = PjgetByid(instanceId, "0");
                        if (!"".equals(s)) {
                            invoices.put(new JSONObject(s));
                            ids.add(instanceId);
                        }
                    }
                    upJson.put("tableField_l6bwb4hj", tableField_l6bwb4hj);
                }
            } else if ("TE".equals(type)) {
                bookkeepingJObj.put("vouchernumber", object.getString("textField_l7a7bf81"));


                if (object.has("tableField_l6lmxo5r") && object.getJSONArray("tableField_l6lmxo5r").length() > 0) {
                    String substring = object.getString("associationFormField_l83trmls_id").replaceAll("\\\\", "").substring(1);
                    JSONArray tableField_l6lmxo5r = new JSONArray(substring.substring(0, substring.length() - 1));

                    for (int i = 0; i < tableField_l6lmxo5r.length(); i++) {
                        bookkeepingJObj.put("voucherdate", CusutUtil.getFormatDate(object.getLong("dateField_l7a7bf88")));
                        bookkeepingJObj.put("applytime", CusutUtil.getFormatDate(object.getLong("dateField_l7a7bf88")));

//                        JSONObject jsonObject = tableField_l6lmxo5r.getJSONObject(i);
                        try {
//                            String substring = jsonObject.getString("associationFormField_l6vk2yxg_id").replaceAll("\\\\", "").substring(1);
//                            String instanceId = new JSONArray(substring.substring(0, substring.length() - 1)).getJSONObject(0).getString("instanceId");
                            String instanceId = tableField_l6lmxo5r.getJSONObject(i).getString("instanceId");
                            String s = PjgetByid(instanceId, "0");
                            if (!"".equals(s)) {
                                invoices.put(new JSONObject(s));
                                ids.add(instanceId);
                            }
                        } catch (Exception ex) {

                        }
                    }
                    upJson.put("tableField_l6lmxo5r", tableField_l6lmxo5r);
                }
            }
            bookkeepingJObj.put("invoices", invoices);
            bookkeepingJArray.put(bookkeepingJObj);

            System.out.println(bookkeepingJArray);

            String post = HttpUtil.post("http://106.15.251.153:8091/stms/openapi/income/bookkeeping", null, bookkeepingJArray.toString(), null);
            if (!"".equals(post)) {
                System.out.println(CusutUtil.unicodeDecode(post));
                logger.info("post:" + CusutUtil.unicodeDecode(post));

                JSONObject jsonObject = new JSONObject(CusutUtil.unicodeDecode(post));
                if (jsonObject.getString("code").equals("0000")) {
                    JSONArray data = jsonObject.getJSONArray("data");
                    Iterator<String> keys = upJson.keys();
                    JSONArray jsonArray = new JSONArray();
                    String key = "";
                    while (keys.hasNext()) {
                        key = keys.next();
                        jsonArray = upJson.getJSONArray(key);
                    }
                    JSONArray upjsonarray = new JSONArray();
                    for (int i = 0; i < data.length(); i++) {
                        JSONObject dataJSONObject = data.getJSONObject(i);
                        JSONObject jsonArrayJSONObject = jsonArray.getJSONObject(i);
                        String returnmsg = dataJSONObject.getString("returnmsg");
                        if (type.equals("PO")) {
                            jsonArrayJSONObject.remove("textField_l6q3aelu");
                            jsonArrayJSONObject.put("textField_l6q3aelu", returnmsg);
                            upjsonarray.put(jsonArrayJSONObject);
                        } else if (type.equals("NP")) {
                            jsonArrayJSONObject.remove("textField_l6q3cn36");
                            jsonArrayJSONObject.put("textField_l6q3cn36", returnmsg);
                            upjsonarray.put(jsonArrayJSONObject);
                        } else if (type.equals("TE")) {
                            jsonArrayJSONObject.remove("textField_l6q8uw0g");
                            jsonArrayJSONObject.put("textField_l6q8uw0g", returnmsg);
                            upjsonarray.put(jsonArrayJSONObject);
                        }
                        logger.info("发票反勾选实现 YiDa Update : " + ids.get(i) + " => " + new JSONObject().put("textField_l7efm5az", returnmsg));
                        dingUtil.UpdateYiDa(ids.get(i), new JSONObject().put("textField_l7efm5az", returnmsg));
                    }
                    upJson.remove(key);
                    upJson.put(key, upjsonarray);
                    // dingUtil.UpdateYiDa(id, upJson);
                } else {
                    logger.info("发票反勾选实现  --接口返回值异常");
                    return CusutUtil.SuccessReturnJsonString(500, "接口返回值异常" + jsonObject, "str");
                }
            }
            return CusutUtil.SuccessReturnJsonString(200, "成功", "str");
        } catch (Exception ex) {
            ex.printStackTrace();
            logger.info("发票反勾选实现 --exception:" + ex.getMessage());
            return CusutUtil.SuccessReturnJsonString(500, "接口异常500,请联系管理员或开发者处理", "str");
        }
    }


    /***
     * NP冲销
     * @return
     */
    @GetMapping("NPRemove")
    public String NPRemove(String id, String name, String remake, long time) {
        try {
            JSONObject upJson = new JSONObject();
            String start_time = CusutUtil.getFormatDate(time);
            System.out.println(name);
            JSONObject object = new JSONObject(dingUtil.getYidaById(id));
            JSONObject sapJson = new JSONObject();
            sapJson.put("ZOA_NUMBER", object.get("textField_l7a6bzps"));  //OA单据号
            sapJson.put("ZOA_TYPE", "NP");  //OA单据类型
            sapJson.put("BUKRS", object.get("textField_l7a6bzps"));       //公司代码
            sapJson.put("BELNR", object.get("textField_l701yhu3"));      //凭证编号
            sapJson.put("GJAHR", object.get("textField_l701yhtw"));       //会计年度
            sapJson.put("STGRD", remake);       //冲销原因
            sapJson.put("BUDAT", start_time);       //过账日期
            sapJson.put("USNAM", "TEST-CN001");       //过账人

            String post = HttpUtil.post(sapUrl + "SAP006", null, sapJson.toString(), null);
            if (!post.equals("")) {
                JSONObject postJsonObject = new JSONArray(post).getJSONObject(0);
                System.out.println(postJsonObject.get("E_MESSAGE"));
                if (!postJsonObject.getString("E_BELNR").equals("")) {
                    upJson.put("textField_l78k02x3", postJsonObject.getString("E_BELNR"));
                    upJson.put("dateField_l7a6wpir", CusutUtil.dateTOtimeshapYYMMDD(start_time));
                    upJson.put("textField_l701yhu4", remake);
                }
            }
            logger.info("NP冲销 YiDa Update : " + id + " => " + upJson);
            dingUtil.UpdateYiDa(id, upJson);
            return CusutUtil.SuccessReturnJsonString(200, "成功", "str");
        } catch (Exception ex) {
            logger.info("NP冲销 --exception" + ex.getMessage());
            ex.printStackTrace();
            return CusutUtil.SuccessReturnJsonString(500, "接口异常500,请联系管理员或开发者处理", "str");
        }
    }


    /***
     * TE冲销
     * @return
     */
    @GetMapping("TERemove")
    public String TERemove(String id, String name, String remake, long time) {
        try {
            JSONObject upJson = new JSONObject();
            String start_time = CusutUtil.getFormatDate(time);
            System.out.println(name);
            JSONObject object = new JSONObject(dingUtil.getYidaById(id));
            JSONObject sapJson = new JSONObject();
            sapJson.put("ZOA_NUMBER", object.get("textField_l7a7bf8d"));  //OA单据号
            sapJson.put("ZOA_TYPE", "TE");  //OA单据类型
            sapJson.put("BUKRS", object.get("textField_l7a7bf8a"));       //公司代码
            sapJson.put("BELNR", object.get("textField_l7a7bf81"));      //凭证编号
            sapJson.put("GJAHR", object.get("textField_l7a7bf8f"));       //会计年度
            sapJson.put("STGRD", remake);       //冲销原因
            sapJson.put("BUDAT", start_time);       //过账日期
            sapJson.put("USNAM", "TEST-CN001");       //过账人

            String post = HttpUtil.post(sapUrl + "SAP006", null, sapJson.toString(), null);
            if (!post.equals("")) {
                JSONObject postJsonObject = new JSONArray(post).getJSONObject(0);
                System.out.println(postJsonObject.get("E_MESSAGE"));
                if (!postJsonObject.getString("E_BELNR").equals("")) {
                    upJson.put("textField_l7a7bf87", postJsonObject.getString("E_BELNR"));
                    upJson.put("textField_l7a7bf8c", start_time);
                    upJson.put("textField_l7a7bf8b", remake);
                }
            }
            logger.info("TE冲销 YiDa Update : " + id + " => " + upJson);
            dingUtil.UpdateYiDa(id, upJson);
            return CusutUtil.SuccessReturnJsonString(200, "成功", "str");
        } catch (Exception ex) {
            ex.printStackTrace();
            return CusutUtil.SuccessReturnJsonString(500, "接口异常500,请联系管理员或开发者处理", "str");
        }
    }


    /***
     * ocr识别接口,提交发票上传触发ocr识别
     * @param id
     * @return
     */
    @GetMapping("ocr")
    public String ocr(String id) {
        logger.info("接收票据上传：" + id);
        try {
            JSONObject upJson = new JSONObject();
            String start_time = CusutUtil.getNowDate();
            JSONObject object = new JSONObject(dingUtil.getYidaById(id));
            JSONArray attachmentField_l6u528kj = new JSONArray(object.get("attachmentField_l6u528kj").toString());
            JSONArray jsonArray = dingUtil.downloadFjs(attachmentField_l6u528kj, "/usr/_HIH3WEB_IMG_CACHE/");
//            JSONArray jsonArray = dingUtil.downloadFjs(attachmentField_l6u528kj, "/Users/malk/Desktop/_HIH3WEB_IMG_CACHE/");
//                     JSONArray jsonArray = dingUtil.downloadFjs(attachmentField_l6u528kj, "E://usr//_HIH3WEB_IMG_CACHE//");
            String textareaField_l6uh2vlo = "";
            int sc_file = 0;
            int err_file = 0;
            int all_file = 0;
            for (int i = 0; i < jsonArray.length(); i++) {
                all_file++;
                File file = null;
                try {
                    String filePath = jsonArray.getString(i);
                    file = new File(filePath);
                } catch (Exception exception) {
                    err_file++;
                    textareaField_l6uh2vlo += "发票" + (i + 1) + "下载失败,请检查发票或联系管理员处理。\n";
                    continue;
                }
                String value = "";
                try {
                    MultiValueMap<String, Object> param = new LinkedMultiValueMap<>();
                    param.add("account", "admin");
                    value = HttpUtil.doPostFile2(dingConst.getHanxingUrl() + "imgocr", param, file);

                } catch (Exception ex) {
                    err_file++;
                    textareaField_l6uh2vlo += "发票" + (i + 1) + "识别错误,请检查发票或联系管理员处理。\n";
                    continue;
                }
                try {
                    JSONObject jsonObject = new JSONObject(value);
                    String code = jsonObject.getString("code");
                    String message = jsonObject.getString("message");

                    if (code.equals("200") && message.contains("成功")) {
                        try {
                            JSONArray invoices = jsonObject.getJSONArray("invoices");
                            log.info("invoices识别结果：" + invoices);
                            for (int j = 0; j < invoices.length(); j++) {
                                JSONObject invoicesJSONObject = invoices.getJSONObject(j);
                                log.info("invoicesJSONObject识别结果：" + invoicesJSONObject);
                                JSONObject createJson = new JSONObject();
                                //ocr解析
                                createJson.put("employeeField_l6u55vcz", object.get("employeeField_l6u528kp_id"));//提交人
                                createJson.put("dateField_l6u55vd0", object.get("dateField_l6u528kk"));//发票上传日期

                                //通用参数
                                createJson.put("textField_l6u55vd8", ocrType(has(invoicesJSONObject, "type").toString()));//发票种类
                                log.info("ocr:" + ocrType(has(invoicesJSONObject, "type").toString()));
                                createJson.put("textField_l6u55vda", has(invoicesJSONObject, "bx_state").toString());//报销状态
                                createJson.put("textField_l6ukuz14", has(invoicesJSONObject, "saveState").toString());//保存状态
                                createJson.put("textareaField_l6ukuz15", has(invoicesJSONObject, "saveMsg").toString());//保存结果

                                //附件-发票
                                JSONArray region = new JSONArray(has(invoicesJSONObject, "region").toString());
                                JSONArray attachmentField_l6u55vct = new JSONArray();
                                JSONObject object1 = new JSONObject();
                                String filepath = jsonArray.getString(i);
                                if (region.length() > 0 && (filepath.toLowerCase().contains("jpg") || filepath.toLowerCase().contains("jpeg") || filepath.toLowerCase().contains("png") || filepath.toLowerCase().contains("bmp"))) {
                                    String fileTyle = filepath.substring(filepath.lastIndexOf(".") + 1, filepath.length());
                                    /// prd: 25.04.20 发票存储本地化文件, 公网端口已关闭, 通过nginx/内网地址请求
//                                    String s = HttpUtil.get("http://139.224.19.43:8888/Tyson/cutImg?filepath=" + filepath + "&array=" + region + "&gs=" + fileTyle);
                                    String s = HttpUtil.get("https://www.senhouse.cn/Tyson/cutImg?filepath=" + filepath + "&array=" + region + "&gs=" + fileTyle);
                                    File cut_file = new File(s);
                                    filepath = s;
                                    object1.put("size", cut_file.length());
                                    object1.put("name", cut_file.getName());
                                } else {
                                    object1.put("size", file.length());
                                    object1.put("name", file.getName());
                                }
                                object1.put("previewUrl", "https://www.senhouse.cn/api/preview?filePathName=" + filepath);
                                object1.put("downloadUrl", "https://www.senhouse.cn/api/download?filePathName=" + filepath);
                                object1.put("url", "https://www.senhouse.cn/api/download?filePathName=" + filepath);

                                attachmentField_l6u55vct.put(object1);
                                createJson.put("attachmentField_l6u55vct", attachmentField_l6u55vct);

                                //识别参数
                                createJson.put("textField_l6u55vd3", (has(invoicesJSONObject, "number").toString()));//发票号码
                                createJson.put("textField_l6u55vd9", (has(invoicesJSONObject, "code").toString()));//发票代码


                                JSONObject queryJson = new JSONObject();
                                queryJson.put("textField_l6u55vd3", (has(invoicesJSONObject, "number").toString()));//发票号码
                                queryJson.put("textField_l6u55vd9", (has(invoicesJSONObject, "code").toString()));//发票代码
                                if (createJson.getString("textField_l6u55vd8").contains("全电") || createJson.getString("textField_l6u55vd8").contains("火车") || createJson.getString("textField_l6u55vd8").contains("航空")) {


                                } else {
                                    if (queryJson.getString("textField_l6u55vd3").equals("") || queryJson.getString("textField_l6u55vd9").equals("")) {
                                        err_file++;
                                        textareaField_l6uh2vlo += "发票" + (i + 1) + "号码/代码有空值,请检查。\n";
                                        continue;
                                    }
                                }

                                if (true) {
                                    if (new JSONArray(dingUtil.yiDaSearch("FORM-4J7669A1Z1X22RIL61LB7AOXGRX82OHP45U6L51", queryJson)).length() > 0) {
                                        err_file++;
                                        textareaField_l6uh2vlo += "发票" + (i + 1) + "重复上传,请检查。\n";
                                        continue;
                                    }
                                }
                                String type = has(invoicesJSONObject, "type").toString();

                                if (type.contains("10900") || type.contains("10902")) {
                                    err_file++;
                                    textareaField_l6uh2vlo += "发票" + (i + 1) + "属于非发票,请检查。\n";
                                    continue;
                                }

                                createJson.put("dateField_l6u55vdg", CusutUtil.dateTOtimeshap(has(invoicesJSONObject, "date").toString()));//开票日期

                                if (type.equals("01") || type.equals("04") || type.equals("14") || type.equals("10") || type.equals("10500") ||
                                        type.equals("11") || type.equals("10503") || type.equals("03") || type.equals("08") || type.equals(
                                        "10505") || type.equals("20105") || type.equals("15") || type.equals("10506") ||
                                        type.equals("16") || type.equals("21") || type.equals("22") || type.equals("08xdp") || type.equals("08xdpp")) {
                                    createJson.put("textField_l6vvuq3f", has(invoicesJSONObject, "tax_rate").toString());//税率
                                } else {
                                    createJson.put("textField_l6vvuq3f", "0%");
                                }

                                createJson.put("numberField_l6u55vdi", has(invoicesJSONObject, "tax").toString());//发票税额
                                createJson.put("textField_l6u55vdb", has(invoicesJSONObject, "seller_tax_id").toString());//销方税号
                                createJson.put("textField_l6ukuz13", has(invoicesJSONObject, "seller").toString());//销方名称
                                createJson.put("textField_l6u55vdd", has(invoicesJSONObject, "seller_bank_account").toString());//销方开户行及账好
                                createJson.put("textField_l6u55vdc", has(invoicesJSONObject, "seller_addr_tel").toString());//销方地址、电话
                                createJson.put("textField_l6u55vdk", has(invoicesJSONObject, "remark").toString());//备注
                                createJson.put("textField_l6u55vdl", has(invoicesJSONObject, "check_code").toString());//校验码
                                createJson.put("textField_l6u55vdn", has(invoicesJSONObject, "buyer_tax_id").toString());//购方身份证号/组织机构代码
                                createJson.put("textField_l6u55vdq", has(invoicesJSONObject, "kind").toString());//消费类型
                                createJson.put("textField_l6u55vdr", has(invoicesJSONObject, "title").toString());//标题
                                createJson.put("textField_l6vk7131", has(invoicesJSONObject, "buyer").toString());//购方名称
                                createJson.put("textField_l6vk7132", has(invoicesJSONObject, "buyer_addr_tel").toString());//购方地址、电话
                                createJson.put("numberField_l6vu65fq", has(invoicesJSONObject, "quantity").toString());//数量
                                createJson.put("numberField_l6vu65fr", has(invoicesJSONObject, "price").toString());//单价
                                createJson.put("textField_l6vu65fs", has(invoicesJSONObject, "in_tax").toString());//进项税
                                createJson.put("textField_l6ympla5", has(invoicesJSONObject, "time_geton").toString());//上车时间
                                createJson.put("textField_l6ympla6", has(invoicesJSONObject, "time_getoff").toString());//下车时间
                                createJson.put("textField_l6ymplab", has(invoicesJSONObject, "place").toString());//发票所在地
                                createJson.put("textField_l6ymplag", has(invoicesJSONObject, "mileage").toString());//里程
                                createJson.put("textField_l6ymplac", has(invoicesJSONObject, "province").toString());//省
                                createJson.put("textField_l6ymplad", has(invoicesJSONObject, "city").toString());//市
                                createJson.put("textField_l6ymplae", has(invoicesJSONObject, "name").toString());//姓名
                                createJson.put("textField_l6ymplaj", has(invoicesJSONObject, "user_id").toString());//身份证号码
                                createJson.put("textField_l6ymplaf", has(invoicesJSONObject, "station_geton").toString());//上车
                                createJson.put("textField_l6ymplah", has(invoicesJSONObject, "station_getoff").toString());//下车
                                createJson.put("textField_l6ymplai", has(invoicesJSONObject, "train_number").toString());//车次
                                createJson.put("textField_l6ymplak", has(invoicesJSONObject, "seat").toString());//坐席
                                createJson.put("textField_l6u55vdr", has(invoicesJSONObject, "highway_flag").toString());//是否高速费用
                                createJson.put("textField_l6ymplam", has(invoicesJSONObject, "exit").toString());//出口
                                createJson.put("textField_l6ymplal", has(invoicesJSONObject, "entrance").toString());//入口
                                createJson.put("textField_l6ymplao", has(invoicesJSONObject, "insurance").toString());//保险费


                                createJson.put("textField_l6ymplat", has(invoicesJSONObject, "international_flag").toString());//是否国际
                                createJson.put("textField_l6ymplau", has(invoicesJSONObject, "user_name").toString());//乘机人姓名


                                if (invoicesJSONObject.has("flights")) {
                                    JSONObject flights = invoicesJSONObject.getJSONArray("flights").getJSONObject(0);
                                    createJson.put("textField_l6ymplap", has(flights, "from").toString());//起飞
                                    createJson.put("textField_l6ymplaq", has(flights, "to").toString());//到达
                                    createJson.put("textField_l6ymplar", has(flights, "flight_number").toString());//航班号
                                    createJson.put("textField_l6ymplas", has(flights, "seat").toString());//座位等级
                                    createJson.put("textField_l6ymplav", has(flights, "class_name").toString());//舱
                                    createJson.put("textField_l6ymplaw", has(flights, "time").toString());//行程时间
                                    createJson.put("textField_l6ymplax", has(flights, "carrier").toString());//舱班
                                    createJson.put("textField_l6ymplaz", has(invoicesJSONObject, "city").toString());//城市
                                    createJson.put("textField_l7ivanhu", has(flights, "date"));//航班日期

                                    if ("".equals(createJson.getString("textField_l6ukuz13"))) {
                                        createJson.remove("textField_l6ukuz13");
                                        createJson.put("textField_l6ukuz13", has(flights, "issue_by").toString());
                                    }
                                }
                                createJson.put("textField_l6ymplay", has(invoicesJSONObject, "time_geton").toString());//上车时间
                                createJson.put("textField_l6ymplaz", has(invoicesJSONObject, "city").toString());//城市
                                createJson.put("textField_l6ymplb0", has(invoicesJSONObject, "mileage").toString());//里程（公里）
                                createJson.put("textField_l6ymplb3", has(invoicesJSONObject, "tax_authorities").toString());//税务总局


                                JSONArray tableField_l6ujr47b = new JSONArray();


                                //验真参数
                                try {
                                    JSONObject yanzObj = new JSONObject();
                                    yanzObj.put("fpdm", (has(invoicesJSONObject, "code").toString()));
                                    yanzObj.put("fphm", (has(invoicesJSONObject, "number").toString()));
                                    yanzObj.put("kprq", CusutUtil.dateTOxieg(has(invoicesJSONObject, "date").toString()));
                                    double je = 0;
                                    double pretax_amount = 0;
                                    double total = 0;


                                    if (invoicesJSONObject.has("pretax_amount")) {
                                        try {
                                            pretax_amount = invoicesJSONObject.getDouble("pretax_amount");
                                        } catch (Exception ex) {
                                            System.out.println(invoicesJSONObject.get("pretax_amount"));
                                        }
                                    }
                                    if (invoicesJSONObject.has("total")) {
                                        try {
                                            total = invoicesJSONObject.getDouble("total");
                                        } catch (Exception ex) {
                                            System.out.println(invoicesJSONObject.get("tokal"));
                                        }
                                    }

                                    if (total < pretax_amount) {
                                        je = total;
                                        createJson.put("numberField_l6u55vdh", has(invoicesJSONObject, "total").toString());//发票金额
                                        createJson.put("numberField_l6u55vdj", has(invoicesJSONObject, "pretax_amount").toString());//价税合计
                                    } else {
                                        je = pretax_amount;
                                        if (pretax_amount == 0) {
                                            je = total;
                                        } else {
                                            je = pretax_amount;
                                        }
                                        createJson.put("numberField_l6u55vdj", has(invoicesJSONObject, "total").toString());//发票金额
                                        createJson.put("numberField_l6u55vdh", has(invoicesJSONObject, "pretax_amount").toString());//价税合计
                                    }
                                    yanzObj.put("je", je);

                                    yanzObj.put("jym", (has(invoicesJSONObject, "check_code").toString()));
                                    yanzObj.put("account", "admin");

                                    if (createJson.getString("textField_l6u55vd8").contains("全电")) {
                                        yanzObj.remove("fpdm");
                                        yanzObj.remove("jym");
                                        yanzObj.put("fpdm", "");
                                        yanzObj.remove("je");
                                        yanzObj.put("je", Double.parseDouble(createJson.getString("numberField_l6u55vdj")));
                                        yanzObj.put("jym", "");
                                    }
                                    if (type.equals("01") || type.equals("02") || type.equals("03") || type.equals("04")
                                            || type.equals("15") || type.equals("14") || type.equals("11") || type.equals("10")
                                            || type.equals("08") || type.equals("16") || type.equals("21") || type.equals("22") || type.equals("08xdp") || type.equals("08xdpp")) {
                                        String post = HttpUtil.post("http://106.15.251.153:8095/stms_xocr/pxocr/commoncheckinvoice", null, yanzObj.toString(), null);
                                        if (!post.equals("")) {
//                                            System.out.println(post);
                                            JSONObject yanz = new JSONObject(post);
                                            if (yanz.getString("message").contains("成功") || createJson.getString("textField_l6u55vd8").contains("全电") && yanz.has("invoiceInfo")) {
                                                yanz = yanz.getJSONObject("invoiceInfo");
                                                createJson.put("textField_l6u55vds", has(yanz, "resultCode").toString());//验真结果
                                                createJson.put("textField_l6u55vdt", has(yanz, "resultTip").toString());//验真详情
                                                createJson.put("numberField_l6u55vdu", has(yanz, "checkCount").toString());//查验次数
                                                createJson.put("textField_l6u55vdm", has(yanz, "cancellationMark").toString());//作废标志
                                                createJson.put("textField_l6u55vdp", has(yanz, "zeroTaxRateFlag").toString());//零税率标注

                                                //明细参数
                                                if (yanz.has("detailList")) {
                                                    JSONArray items = yanz.getJSONArray("detailList");
                                                    for (int k = 0; k < items.length(); k++) {
                                                        JSONObject itemObject = new JSONObject();
                                                        JSONObject item = items.getJSONObject(k);
                                                        itemObject.put("textField_l6ujr47c", has(item, "goodsName").toString());//名称
                                                        itemObject.put("numberField_l6ujr47e", has(item, "num").toString());//数量
                                                        itemObject.put("textField_lam8efux", has(item, "unit").toString());//单位
                                                        itemObject.put("numberField_l6ujr47g", has(item, "taxUnitPrice").toString());//单价
                                                        itemObject.put("textField_l6vvuq3e", has(item, "taxRate").toString());//税率
                                                        itemObject.put("numberField_l6vu65fp", has(item, "taxAmount").toString());//税额
                                                        itemObject.put("numberField_l6ujr47f", has(item, "detailAmount").toString());//金额
                                                        tableField_l6ujr47b.put(itemObject);
                                                        if (k == 0) {
                                                            if ("".equals(createJson.getString("textField_l6vvuq3f"))) {
                                                                createJson.remove("textField_l6vvuq3f");
                                                                createJson.put("textField_l6vvuq3f", has(item, "taxRate").toString());
                                                                createJson.remove("numberField_l6u55vdi");
                                                                createJson.put("numberField_l6u55vdi", has(item, "taxAmount").toString());
                                                                createJson.remove("numberField_l6vu65fq");
                                                                createJson.put("numberField_l6vu65fq", has(item, "num").toString());
                                                                createJson.remove("numberField_l6vu65fr");
                                                                createJson.put("numberField_l6vu65fr", has(item, "taxUnitPrice").toString());
                                                            }
                                                        }
                                                    }
                                                    createJson.put("tableField_l6ujr47b", tableField_l6ujr47b);//明细实例
                                                }
                                            } else {
                                                createJson.put("textField_l6u55vdt", yanz.getString("message"));
                                            }
                                        }
                                    }
                                } catch (Exception ex) {
                                    ex.printStackTrace();
                                }
                                //开发参数
                                createJson.put("textField_l7efm5ay", "否");
                                //过路费发票 ？？
                                if (type.equals("10505") || type.equals("10203") || type.equals("10506") || type.equals("10507") || type.equals("10503") || type.equals("10500") || type.equals("10200") || type.equals("10400") || has(invoicesJSONObject, "block_chain").equals("1")) {
//                                    if (!createJson.has("textField_l6u55vdt")) {
                                    createJson.put("textField_l6u55vdt", "查验成功发票一致");
                                    createJson.put("textField_l6u55vds", "0001");
//                                    }
                                }


                                //明细参数
                                if (!createJson.has("tableField_l6ujr47b")) {
                                    if (invoicesJSONObject.has("items")) {
                                        JSONArray items = invoicesJSONObject.getJSONArray("items");
                                        for (int k = 0; k < items.length(); k++) {
                                            JSONObject itemObject = new JSONObject();
                                            JSONObject item = items.getJSONObject(k);
                                            itemObject.put("textField_lam8efux", has(item, "unit").toString());//单位
                                            itemObject.put("textField_l6ujr47c", has(item, "name").toString());//名称
                                            itemObject.put("numberField_l6ujr47e", has(item, "quantity").toString());//数量
                                            itemObject.put("numberField_l6ujr47g", has(item, "price").toString());//单价
                                            itemObject.put("textField_l6vvuq3e", has(item, "tax_rate").toString());//税率
                                            itemObject.put("numberField_l6vu65fp", has(item, "tax").toString());//税额
                                            itemObject.put("numberField_l6ujr47f", has(item, "total").toString());//金额
                                            tableField_l6ujr47b.put(itemObject);

                                            if ("".equals(createJson.getString("textField_l6vvuq3f"))) {
                                                createJson.remove("textField_l6vvuq3f");
                                                createJson.put("textField_l6vvuq3f", has(item, "tax_rate").toString());
                                                createJson.remove("numberField_l6u55vdi");
                                                createJson.put("numberField_l6u55vdi", has(item, "tax").toString());
                                                createJson.remove("numberField_l6vu65fq");
                                                createJson.put("numberField_l6vu65fq", has(item, "quantity").toString());
                                                createJson.remove("numberField_l6vu65fr");
                                                createJson.put("numberField_l6vu65fr", has(item, "price").toString());
                                            }
                                        }
                                    }
                                    createJson.put("tableField_l6ujr47b", tableField_l6ujr47b);//明细实例
                                }

                                String return_id = dingUtil.saveYiDa("FORM-4J7669A1Z1X22RIL61LB7AOXGRX82OHP45U6L51", createJson, object.getString("userId"));
                                logger.info("YiDa Return Data :" + return_id);

                                sc_file++;
                            }
                        } catch (Exception ex) {
                            ex.printStackTrace();
                            err_file++;
                            textareaField_l6uh2vlo += "发票" + (i + 1) + "识别结果解析错误,请联系管理员处理。\n";
                            continue;
                        }
                    } else {
                        err_file++;
                        textareaField_l6uh2vlo += "发票" + (i + 1) + "识别异常," + jsonObject + "。\n";
                        continue;
                    }
                } catch (Exception ex) {
                    err_file++;
                    textareaField_l6uh2vlo += "发票" + (i + 1) + "识别结果解析错误,请检查发票或联系识别供应商处理。\n";
                    continue;
                }


            }
            String end_time = CusutUtil.getNowDate();

            upJson.put("textField_l6u54xlg", "识别完成");
            upJson.put("textareaField_l6uh2vlo", textareaField_l6uh2vlo);
            upJson.put("textField_lk0k5ryb", all_file);
            upJson.put("textField_lk0k5ryc", sc_file);
            upJson.put("textField_l6u54xlh", err_file);
            upJson.put("textField_l6u54xli", CusutUtil.getTime(start_time, end_time));

            logger.info("ocr识别 YiDa Update : " + id + " => " + upJson);
            dingUtil.UpdateYiDa(id, upJson);
            return CusutUtil.SuccessReturnJsonString(200, "识别成功", "str");
        } catch (Exception ex) {
            logger.info("orc识别 --exception" + ex.getMessage());
            ex.printStackTrace();
            return CusutUtil.SuccessReturnJsonString(500, "识别异常,请联系管理员或开发方处理", "str");
        }

    }

    @GetMapping("bookkeeping")
    public String bookkeepingC(String id, String type) {
        return asyncController.bookkeeping(id, type);
    }


    /***
     * yz验真接口,重新触发验真操作
     * @param id
     * @return
     */
    @GetMapping("yz")
    public String yz(String id) {

        JSONObject upJson = new JSONObject();
        JSONObject object = null;
        try {
            object = new JSONObject(dingUtil.getYidaById(id));
//            System.out.println(object);

        } catch (Exception e) {
            e.printStackTrace();
        }

        if (object.getString("textField_l6u55vdt").contains("查验成功")) {
            return CusutUtil.SuccessReturnJsonString(200, "验真成功", "str");
        }
        //验真参数
        try {
            JSONObject yanzObj = new JSONObject();
            yanzObj.put("fpdm", (has(object, "textField_l6u55vd9").toString()));
            yanzObj.put("fphm", (has(object, "textField_l6u55vd3").toString()));
            yanzObj.put("kprq", CusutUtil.getFormatDate(object.getLong("dateField_l6u55vdg")));
            if (object.has("numberField_l6u55vdh")) {
                yanzObj.put("je", object.getDouble("numberField_l6u55vdh"));
            } else {
                yanzObj.put("je", object.getDouble("numberField_l6u55vdj"));
            }
            //
            yanzObj.put("jym", (has(object, "textField_l6u55vdl").toString()));
            yanzObj.put("account", "admin");
            if (object.getString("textField_l6u55vd8").contains("全电")) {
                yanzObj.remove("fpdm");
                yanzObj.remove("jym");
                yanzObj.put("fpdm", "");
                yanzObj.remove("je");
                yanzObj.put("je", object.getDouble("numberField_l6u55vdj"));
                yanzObj.put("jym", "");
            }

//            System.out.println(yanzObj);
//            String post = "";
            String post = HttpUtil.post("http://106.15.251.153:8095/stms_xocr/pxocr/commoncheckinvoice", null, yanzObj.toString(), null);
            if (!post.equals("")) {
//                System.out.println(post);
                JSONObject yanz = new JSONObject(post);
                if (yanz.getString("message").contains("成功") || object.getString("textField_l6u55vd8").contains("全电") && yanz.has("invoiceInfo")) {
                    yanz = yanz.getJSONObject("invoiceInfo");
                    upJson.put("textField_l6u55vds", has(yanz, "resultCode").toString());//验真结果
                    upJson.put("textField_l6u55vdt", has(yanz, "resultTip").toString());//验真详情
                    upJson.put("numberField_l6u55vdu", has(yanz, "checkCount").toString());//查验次数
                    upJson.put("textField_l6u55vdm", has(yanz, "cancellationMark").toString());//作废标志
                    upJson.put("textField_l6u55vdp", has(yanz, "zeroTaxRateFlag").toString());//零税率标注
                    JSONArray tableField_l6ujr47b = new JSONArray();
                    //明细参数
                    if (yanz.has("detailList")) {
                        JSONArray items = yanz.getJSONArray("detailList");
                        for (int k = 0; k < items.length(); k++) {
                            JSONObject itemObject = new JSONObject();
                            JSONObject item = items.getJSONObject(k);
                            upJson.put("textField_l6ujr47c", has(item, "goodsName").toString());//名称
                            upJson.put("numberField_l6ujr47e", has(item, "num").toString());//数量
                            upJson.put("textField_lam8efux", has(item, "unit").toString());//单位
                            upJson.put("numberField_l6ujr47g", has(item, "taxUnitPrice").toString());//单价
                            upJson.put("textField_l6vvuq3e", has(item, "taxRate").toString());//税率
                            upJson.put("numberField_l6vu65fp", has(item, "taxAmount").toString());//税额
                            upJson.put("numberField_l6ujr47f", has(item, "detailAmount").toString());//金额
                            tableField_l6ujr47b.put(itemObject);
                            if (k == 0) {
                                if ("".equals(object.getString("textField_l6vvuq3f"))) {
                                    upJson.remove("textField_l6vvuq3f");
                                    upJson.put("textField_l6vvuq3f", has(item, "taxRate").toString());
                                    upJson.remove("numberField_l6u55vdi");
                                    upJson.put("numberField_l6u55vdi", has(item, "taxAmount").toString());
                                    upJson.remove("numberField_l6vu65fq");
                                    upJson.put("numberField_l6vu65fq", has(item, "num").toString());
                                    upJson.remove("numberField_l6vu65fr");
                                    upJson.put("numberField_l6vu65fr", has(item, "taxUnitPrice").toString());
                                }
                            }
                        }
                        upJson.put("tableField_l6ujr47b", tableField_l6ujr47b);//明细实例

                    } else {
                        upJson.put("textField_l6u55vdt", yanz.getString("message"));
                    }
                }
            }
        } catch (Exception ex) {
            ex.printStackTrace();
        }
        //开发参数
        upJson.put("textField_l7efm5ay", "否");


        try {
            logger.info("yz验真接口 YiDa Update : " + id + " => " + upJson);
            dingUtil.UpdateYiDa(id, upJson);
        } catch (Exception e) {
            e.printStackTrace();
        }

        return CusutUtil.SuccessReturnJsonString(200, "验真成功", "str");
    }

    @GetMapping("POXY")
    public String poxy(String id, String user, String dept) {
        try {
            Thread.sleep(1000);
            asyncController.POXY(id, user, dept);
        } catch (Exception ex) {
            ex.printStackTrace();
        }
        return CusutUtil.SuccessReturnJsonString(200, "成功", "str");
    }

    Object has(JSONObject jo, String key) {
        if (jo.has(key) && !jo.get(key).toString().toLowerCase().equals("null")) {
            return jo.get(key);
        }
        return "";
    }

    String ocrType(String type) {
        log.info("type:"+type);
        switch (type) {
            case "01":
                return "增值税专用发票";
            case "04":
                return "增值税普通发票";
            case "14":
                return "通行费电子普通发票";
            case "10400":
                return "机打发票";
            case "10900":
                return "可报销其他发票";
            case "10":
                return "增值税电子普通发票";
            case "10500":
                return "出租车发票";
            case "11":
                return "增值税普通发票(卷票)";
            case "10503":
                return "火车票";
            case "20100":
                return "国际小票";
            case "03":
                return "机动车销售统一发票";
            case "08":
                return "增值税电子专用发票";
            case "10505":
                return "客运汽车";
            case "20105":
                return "滴滴出行行程单";
            case "15":
                return "二手车销售统一发票";
            case "10506":
                return "航空运输电子客票行程单";
            case "10902":
                return "完税证明";
            case "10505a":
                return "船票";
            case "10200":
                return "定额发票";
            case "10203":
                return "火车票退票";
            case "10507":
                return "过路费发票";
            case "02":
                return "货运运输业增值税专用发票";
            case "16":
                return "区块链电子发票";
            case "21":
                return "全电发票(专票)";
            case "22":
                return "全电发票(普票)";
            case "08xdp":
                return "全电专票";
            case "08xdpp":
                return "全电普票";
            case "51":
                return "电子火车票";
            default:
                return "联系管理员增加类型," + type;
        }
    }


    /**
     * 修改OA付款单_付款状态
     */
    @PostMapping("paymentResult")
    public String paymentResult(HttpServletRequest request) {
        JSONObject object = new JSONObject(CusutUtil.getPostString(request));
        try {

            String seq = object.getString("textField_l6ypfj93");
            if (seq.equals("")) {
                return "";
            }
            JSONObject update = new JSONObject();

            update.put("dateField_l7o5kchc", object.get("dateField_l6ypfj9d"));
            update.put("textField_l7o5kch6", object.get("textField_l6ypfj99"));

            JSONObject obj = new JSONObject();
            obj.put("textField_l7a342k7", seq);
            JSONArray data = new JSONArray(dingUtil.yiDaSearch("FORM-GC9664C1ALL2G3G5D6ZGNCYLX1FF2DG29TB6LQ", obj));
            if (data.length() > 0 && data.length() == 1) {
                logger.info("修改OA付款单 YiDa Update : " + data.getJSONObject(0).getString("formInstanceId") + " => " + update);
                dingUtil.UpdateYiDa(data.getJSONObject(0).getString("formInstanceId"), update);
            }

            update = new JSONObject();
            update.put("dateField_l7oiem6x", object.get("dateField_l6ypfj9d"));
            update.put("textField_l7oiem6s", object.get("textField_l6ypfj99"));

            obj = new JSONObject();
            obj.put("textField_l7a6bzps", seq);
            data = new JSONArray(dingUtil.yiDaSearch("FORM-YU966T913NK2V4E4BUVZY5X8UWYR3842GVB6LA1", obj));
            if (data.length() > 0 && data.length() == 1) {
                logger.info("修改OA付款单 YiDa Update : " + data.getJSONObject(0).getString("formInstanceId") + " => " + update);
                dingUtil.UpdateYiDa(data.getJSONObject(0).getString("formInstanceId"), update);
            }

            update = new JSONObject();
            update.put("dateField_l7oiflf1", object.get("dateField_l6ypfj9d"));
            update.put("textField_l7oiflf0", object.get("textField_l6ypfj99"));

            obj = new JSONObject();
            obj.put("textField_l7a7bf8d", seq);
            data = new JSONArray(dingUtil.yiDaSearch("FORM-UX866Q61LRK2LACIB8A6M6T1ZOLM2VY5NYB6LZ", obj));
            if (data.length() > 0 && data.length() == 1) {
                if (seq.equals(data.getJSONObject(0).getJSONObject("formData").getString("textField_l7a7bf8d"))) {
                    logger.info("修改OA付款单 YiDa Update : " + data.getJSONObject(0).getString("formInstanceId") + " => " + update);
                    dingUtil.UpdateYiDa(data.getJSONObject(0).getString("formInstanceId"), update);
                }
            }

            JSONObject qobject = object;
            qobject.remove("dateField_l6ypfj9d");
            JSONArray objectsa = new JSONArray(dingUtil.yiDaSearch("FORM-IS866QA1NX53H7P07JCJAAE0OX232UQFFPY6L0", qobject));

            for (int i = 0; i < objectsa.length(); i++) {
                String return_id = dingUtil.delete(objectsa.getJSONObject(i).getString("formInstanceId"));
                logger.info("YiDa Return Data :" + return_id);
            }
            String res = dingUtil.saveYiDa("FORM-IS866QA1NX53H7P07JCJAAE0OX232UQFFPY6L0", object, dingConst.getUserId());
            logger.info("YiDa Return Data :" + res);
            return res;
        } catch (Exception exception) {
            exception.printStackTrace();
            return CusutUtil.ErrorReturnJsonString(500, exception.getMessage());
        }
    }

    @RequestMapping("fkjgup")
    public void fkjgUp() {
        try {
            for (int iq = 0; iq < 21; iq++) {

                String s = dingUtil.yiDaSearch("FORM-IS866QA1NX53H7P07JCJAAE0OX232UQFFPY6L0", new JSONObject(), iq);
                JSONArray jsonArray = new JSONArray(s);
                for (int i = 0; i < jsonArray.length(); i++) {
                    JSONObject object = jsonArray.getJSONObject(i).getJSONObject("formData");
//                    System.out.println(object);
                    if (object.has("textField_l6ypfj93")) {
                        String seq = object.getString("textField_l6ypfj93");
                        if (seq.equals("")) {
                            continue;
                        }
                        if (!object.has("dateField_l6ypfj9d")) {
                            continue;
                        }
                        JSONObject update = new JSONObject();
                        update.put("dateField_l7o5kchc", object.get("dateField_l6ypfj9d"));
                        update.put("textField_l7o5kch6", object.get("textField_l6ypfj99"));

                        JSONObject obj = new JSONObject();
                        obj.put("textField_l7a342k7", seq);
                        JSONArray data = new JSONArray(dingUtil.yiDaSearch("FORM-GC9664C1ALL2G3G5D6ZGNCYLX1FF2DG29TB6LQ", obj));
                        if (data.length() > 0) {
                            logger.info("fkjgup YiDa Update : " + data.getJSONObject(0).getString("formInstanceId") + " => " + update);
                            dingUtil.UpdateYiDa(data.getJSONObject(0).getString("formInstanceId"), update);
                        }

                        update = new JSONObject();
                        update.put("dateField_l7oiem6x", object.get("dateField_l6ypfj9d"));
                        update.put("textField_l7oiem6s", object.get("textField_l6ypfj99"));

                        obj = new JSONObject();
                        obj.put("textField_l7a6bzps", seq);
                        data = new JSONArray(dingUtil.yiDaSearch("FORM-YU966T913NK2V4E4BUVZY5X8UWYR3842GVB6LA1", obj));
                        if (data.length() > 0 && data.length() == 1) {
                            logger.info("fkjgup  YiDa Update : " + data.getJSONObject(0).getString("formInstanceId") + " => " + update);
                            dingUtil.UpdateYiDa(data.getJSONObject(0).getString("formInstanceId"), update);
                        }

                        update = new JSONObject();
                        update.put("dateField_l7oiflf1", object.get("dateField_l6ypfj9d"));
                        update.put("textField_l7oiflf0", object.get("textField_l6ypfj99"));

                        obj = new JSONObject();
                        obj.put("textField_l7a7bf8d", seq);
                        data = new JSONArray(dingUtil.yiDaSearch("FORM-UX866Q61LRK2LACIB8A6M6T1ZOLM2VY5NYB6LZ", obj));
                        if (data.length() > 0 && data.length() == 1) {
                            if (seq.equals(data.getJSONObject(0).getJSONObject("formData").getString("textField_l7a7bf8d"))) {
                                logger.info("fkjgup YiDa Update : " + data.getJSONObject(0).getString("formInstanceId") + " => " + update);
                                dingUtil.UpdateYiDa(data.getJSONObject(0).getString("formInstanceId"), update);
                            }
                        }
                    }
                }
            }

        } catch (Exception ex) {
            ex.printStackTrace();
        }

    }


    /**
     * 获取文件夹下所有文件的名称 + 模糊查询（当不需要模糊查询时，queryStr传空或null即可）
     * <p>
     * 1.当路径不存在时，map返回retType值为1
     * <p>
     * 2.当路径为文件路径时，map返回retType值为2，文件名fileName值为文件名
     * <p>
     * 3.当路径下有文件夹时，map返回retType值为3，文件名列表fileNameList，文件夹名列表folderNameList
     *
     * @param folderPath 路径
     * @param queryStr   模糊查询字符串
     * @return
     */
    @RequestMapping("getFilesName")
    public static HashMap<String, Object> getFilesName(String folderPath, String queryStr) {

        HashMap<String, Object> map = new HashMap<>();

        List<String> fileNameList = new ArrayList<>();//文件名列表

        List<String> folderNameList = new ArrayList<>();//文件夹名列表

        File f = new File(folderPath);

        if (!f.exists()) { //路径不存在

            map.put("retType", "1");

        } else {

            boolean flag = f.isDirectory();

            if (flag == false) { //路径为文件

                map.put("retType", "2");

                map.put("fileName", f.getName());

            } else { //路径为文件夹

                map.put("retType", "3");

                File fa[] = f.listFiles();

                queryStr = queryStr == null ? "" : queryStr;//若queryStr传入为null,则替换为空（indexOf匹配值不能为null）

                for (int i = 0; i < fa.length; i++) {

                    File fs = fa[i];

                    if (fs.getName().indexOf(queryStr) != -1) {

                        if (fs.isDirectory()) {

                            folderNameList.add(fs.getName());

                        } else {

                            fileNameList.add(fs.getName());

                        }

                    }

                }

                map.put("fileNameList", fileNameList);

                map.put("folderNameList", folderNameList);

            }

        }

        return map;

    }

    /***
     * 调用预览请求
     * @param filePathName
     * @param response
     */
    @GetMapping("preview")
    public void preview(String filePathName, HttpServletResponse response, HttpServletRequest request) {
        String queryString = request.getQueryString();
        String[] params = queryString.split("filePathName=");

        try {
            filePathName = URLDecoder.decode(params[1], "UTF-8");
        } catch (UnsupportedEncodingException e) {
            e.printStackTrace();
        }


        filePathName = filePathName.replace('\\', File.separator.toCharArray()[0]);
//        System.out.println(filePathName);
        File file = new File(filePathName);
//        System.out.println(file.exists());
        if (file.exists()) {
            byte[] data = null;
            try {
                FileInputStream input = new FileInputStream(file);
                data = new byte[input.available()];
                input.read(data);
                response.getOutputStream().write(data);
                input.close();
            } catch (Exception e) {
                System.out.println(e);
            }
        } else {
            return;
        }
    }

    /**
     * 通用下载请求
     *
     * @param filePathName 文件路径
     */
    @GetMapping("download")
    public void fileDownload(String filePathName, HttpServletResponse response) {
        try {
            String fileName = filePathName.substring(filePathName.lastIndexOf("/") + 1);
            response.setContentType(MediaType.APPLICATION_OCTET_STREAM_VALUE);
            FileUtil.setAttachmentResponseHeader(response, fileName);
            FileUtil.writeBytes(filePathName, response.getOutputStream());
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    @Autowired
    private ReadExcel readExcel;

    @GetMapping("TestReadExecl")
    public void execl() {
        readExcel.readExcel("/usr/Demo/银行_数据模板.xlsx");
    }


    @PostMapping("SaveSupplier")
    public String saveSupplier(HttpServletRequest request) {
        logger.info("接收供应商数据:" + request.getParameter("param"));
        JSONObject object = new JSONObject(CusutUtil.getPostString(request));

        try {
            System.out.println(object);
            logger.info("post:" + object.toString());

            if (!"".equals(has(object, "textField_l6dhvu1t"))) {
                JSONObject Query_json = new JSONObject();
                Query_json.put("textField_l80ydpfm", has(object, "textField_l6dhvu1t"));
                JSONArray yhjsarray = new JSONArray(dingUtil.yiDaSearch("FORM-FV966U91GDR3XRDMA6AO26UXKDEL3FC2DY08LF", Query_json));
                if (yhjsarray.length() > 0) {
                    String lxh = yhjsarray.getJSONObject(0).getJSONObject("formData").getString("textField_l80ydpfn");
                    object.put("textField_l8e4ryjf", lxh);
                }
            }

            JSONObject jsonObject = new JSONObject();
            if (!"".equals(has(object, "textField_l6dhvu1p"))) {
                jsonObject.put("textField_l75terja", has(object, "textField_l6dhvu1p"));
                JSONArray yhjsarray = new JSONArray(dingUtil.yiDaSearch("FORM-EX866CB143A3WF6PAR7O94M7SE7I2FMKET57L5", jsonObject));
                if (yhjsarray.length() == 1) {
                    String lxh = yhjsarray.getJSONObject(0).getJSONObject("formData").getString("textField_l75terjb");
                    object.put("textField_l8e4ryja", lxh);
                }
            }

            if (object.has("textField_l6bwnaf8") && object.has("textField_l6dhvu1r")) {
                JSONObject queryJon = new JSONObject();
                if (object.has("textField_l6bwnafd") && object.has("textField_l6d2ia49")) {
                    queryJon = new JSONObject();
                    queryJon.put("textField_l82e28fm", object.get("textField_l6bwnaf8"));
                    queryJon.put("textField_l82e28g6", object.get("textField_l6dhvu1r"));
                    queryJon.put("textField_l82e28fr", object.get("textField_l6bwnafd"));
                    queryJon.put("textField_l82e28fx", object.get("textField_l6d2ia49"));
                    JSONArray jsonArray = new JSONArray(dingUtil.yiDaSearch("FORM-IQ8666B11JP3KW8NDK9BG5UTNC4Y2RZX1E28LW", queryJon));
                    try {
                        queryJon.put("textField_l82e28fh", has(object, "textField_l6dhvu1p"));
                        queryJon.put("textField_l82e28fz", has(object, "textField_l6dhvu1o"));
                        queryJon.put("textField_l82e28g4", has(object, "textField_l6dhvu1q"));
                        queryJon.put("textField_l82e28fy", "供应商");


                        if (jsonArray.length() > 0) {
                            String formInstanceId = jsonArray.getJSONObject(0).getString("formInstanceId");
                            logger.info(" YiDa Update : " + formInstanceId + " => " + queryJon);
                            dingUtil.UpdateYiDa(formInstanceId, queryJon);
                        } else {
                            String return_id = dingUtil.saveYiDa("FORM-IQ8666B11JP3KW8NDK9BG5UTNC4Y2RZX1E28LW", queryJon, dingConst.getUserId());
                            logger.info("YiDa Return Data :" + return_id);

                        }
                    } catch (Exception ex) {
                        ex.printStackTrace();
                    }
                }

                queryJon = new JSONObject();
                queryJon.put("textField_l6bwnaf8", object.get("textField_l6bwnaf8"));
                queryJon.put("textField_l6dhvu1r", object.get("textField_l6dhvu1r"));
                JSONArray jsonArray = new JSONArray(dingUtil.yiDaSearch("FORM-FV966U91BPP2KC648VLLT5J26WOO2DX2NWB6L0", queryJon));
                try {
                    if (jsonArray.length() > 0) {
                        String formInstanceId = jsonArray.getJSONObject(0).getString("formInstanceId");
                        jsonObject = new JSONObject();
                        jsonObject.put("result", formInstanceId);

                        logger.info(" YiDa Update : " + formInstanceId + " => " + object);
                        dingUtil.UpdateYiDa(formInstanceId, object);
                        return jsonObject.toString();
                    }
                } catch (Exception ex) {

                }
            }
            String res = dingUtil.saveYiDa("FORM-FV966U91BPP2KC648VLLT5J26WOO2DX2NWB6L0", object, dingConst.getUserId());
            logger.info("YiDa Return Data :" + res);
            return res;

        } catch (Exception exception) {
            exception.printStackTrace();
            return CusutUtil.ErrorReturnJsonString(500, exception.getMessage());
        }
    }

    @PostMapping("SaveCostCenter")
    public String saveCostCenter(HttpServletRequest request) {
        JSONObject object = new JSONObject(CusutUtil.getPostString(request));
        System.out.println(object);
        try {
            if (object.has("textField_l6lta36u")) {
                if (object.getString("textField_l6lta36u").equals("E")) {
                    object.put("textField_l7zn4eyt", object.get("textField_l6lta36v"));
                    object.remove("textField_l6lta36v");
                }
            }

            if (object.has("textField_l6lta36g") && object.has("textField_l6lta36h")) {

                JSONObject queryJon = new JSONObject();
                queryJon.put("textField_l6lta36g", object.get("textField_l6lta36g"));
                queryJon.put("textField_l6lta36h", object.get("textField_l6lta36h"));
                JSONArray jsonArray = new JSONArray(dingUtil.yiDaSearch("FORM-0A966I8103W2GHC9BMMVK5YSTGYL2P0F9TL6L6", queryJon));
                try {
                    if (jsonArray.length() > 0) {
                        String formInstanceId = jsonArray.getJSONObject(0).getString("formInstanceId");
                        JSONObject jsonObject = new JSONObject();
                        jsonObject.put("result", formInstanceId);

                        logger.info(" YiDa Update : " + formInstanceId + " => " + object);
                        dingUtil.UpdateYiDa(formInstanceId, object);
                        return jsonObject.toString();
                    }
                } catch (Exception ex) {

                }
            }
            String res = dingUtil.saveYiDa("FORM-0A966I8103W2GHC9BMMVK5YSTGYL2P0F9TL6L6", object, dingConst.getUserId());
            logger.info("YiDa Return Data :" + res);
            return res;
        } catch (Exception exception) {
            exception.printStackTrace();
            return CusutUtil.ErrorReturnJsonString(500, exception.getMessage());
        }
    }

    @PostMapping("savevoucher")
    public String savevoucher(HttpServletRequest request) {
        JSONObject object = new JSONObject(CusutUtil.getPostString(request));
        try {
            String res = dingUtil.saveYiDa("FORM-0X8660B176337EFHBF6H7AMX6VTT2OUUD8X6LM", object, dingConst.getUserId());
            logger.info("YiDa Return Data :" + res);
            return res;
        } catch (Exception exception) {
            exception.printStackTrace();
            return CusutUtil.ErrorReturnJsonString(500, exception.getMessage());
        }
    }

    @PostMapping("saveNonPOPaymentRequest")
    public String saveNonPOPaymentRequest(HttpServletRequest request) {
        JSONObject object = new JSONObject(CusutUtil.getPostString(request));
        try {
            return dingUtil.saveYiDa("FORM-YU966T913NK2V4E4BUVZY5X8UWYR3842GVB6LA1", object, dingConst.getUserId());
        } catch (Exception exception) {
            exception.printStackTrace();
            return CusutUtil.ErrorReturnJsonString(500, exception.getMessage());
        }
    }

    @PostMapping("SaveCustomer")
    public String SaveCustomer(HttpServletRequest request) {
        JSONObject object = new JSONObject(CusutUtil.getPostString(request));
        try {
            System.out.println(object);
            if (object.has("textField_l6em70k2")) {
                JSONObject queryJon = new JSONObject();
                if (object.has("textField_l6em70kl") && object.has("textField_l6em70kh")) {
                    queryJon = new JSONObject();
                    queryJon.put("textField_l82e28fm", object.get("textField_l6em70k2"));
                    queryJon.put("textField_l82e28g6", object.get("textField_l6em70kn"));
                    queryJon.put("textField_l82e28fr", object.get("textField_l6em70kl"));
                    queryJon.put("textField_l82e28fx", object.get("textField_l6em70kh"));
                    JSONArray jsonArray = new JSONArray(dingUtil.yiDaSearch("FORM-IQ8666B11JP3KW8NDK9BG5UTNC4Y2RZX1E28LW", queryJon));
                    try {
                        queryJon.put("textField_l82e28fh", has(object, "textField_l6em70km"));
                        queryJon.put("textField_l82e28fz", has(object, "textField_l6em70kg"));
                        queryJon.put("textField_l82e28g4", has(object, "textField_l6em70kj"));
                        queryJon.put("textField_l82e28fy", "客户");
                        if (jsonArray.length() > 0) {
                            String formInstanceId = jsonArray.getJSONObject(0).getString("formInstanceId");
                            logger.info(" YiDa Update : " + formInstanceId + " => " + queryJon);
                            dingUtil.UpdateYiDa(formInstanceId, queryJon);
                        } else {

                            dingUtil.saveYiDa("FORM-IQ8666B11JP3KW8NDK9BG5UTNC4Y2RZX1E28LW", queryJon, dingConst.getUserId());
                        }
                    } catch (Exception ex) {
                        ex.printStackTrace();
                    }
                }

                queryJon = new JSONObject();
                queryJon.put("textField_l6em70k2", object.get("textField_l6em70k2"));
                queryJon.put("textField_l6em70kn", object.get("textField_l6em70kn"));
                JSONArray jsonArray = new JSONArray(dingUtil.yiDaSearch("FORM-NO966791YOK2XKW9DMSEGD5L1IN73UHW3ME6LR1", queryJon));
                try {
                    if (jsonArray.length() > 0) {
                        String formInstanceId = jsonArray.getJSONObject(0).getString("formInstanceId");
                        JSONObject jsonObject = new JSONObject();
                        jsonObject.put("result", formInstanceId);

                        logger.info(" YiDa Update : " + formInstanceId + " => " + object);
                        dingUtil.UpdateYiDa(formInstanceId, object);
                        return jsonObject.toString();
                    }
                } catch (Exception ex) {

                }
            }

            String res = dingUtil.saveYiDa("FORM-NO966791YOK2XKW9DMSEGD5L1IN73UHW3ME6LR1", object, dingConst.getUserId());
            logger.info("YiDa Return Data :" + res);
            return res;

        } catch (Exception exception) {
            exception.printStackTrace();
            return CusutUtil.ErrorReturnJsonString(500, exception.getMessage());
        }
    }

    @PostMapping("SaveAccountTitle")
    public String SaveAccountTitle(HttpServletRequest request) {
        JSONObject object = new JSONObject(CusutUtil.getPostString(request));
        try {
            System.out.println(object);
            if (object.has("textField_l701lsek")) {
                if (object.getString("textField_l701lsek").equals("E")) {
                    object.put("textField_l7zncue0", object.get("textField_l6emcrsk"));
                    object.remove("textField_l6emcrsk");
                }
            }

            if (object.has("textField_l6emcrsc") && object.has("textField_l6emcrsj")) {

                JSONObject queryJon = new JSONObject();
                queryJon.put("textField_l6emcrsc", object.get("textField_l6emcrsc"));
                queryJon.put("textField_l6emcrsj", object.get("textField_l6emcrsj"));
                JSONArray jsonArray = new JSONArray(dingUtil.yiDaSearch("FORM-NC966W818OP2542CC0GIP9G2WT4C2UZOCME6LK", queryJon));
                try {
                    if (jsonArray.length() > 0) {
                        String formInstanceId = jsonArray.getJSONObject(0).getString("formInstanceId");
                        JSONObject jsonObject = new JSONObject();
                        jsonObject.put("result", formInstanceId);

                        logger.info(" YiDa Update : " + formInstanceId + " => " + object);
                        dingUtil.UpdateYiDa(formInstanceId, object);
                        return jsonObject.toString();
                    }
                } catch (Exception ex) {

                }
            }
            String res = dingUtil.saveYiDa("FORM-NC966W818OP2542CC0GIP9G2WT4C2UZOCME6LK", object, dingConst.getUserId());
            logger.info("YiDa Return Data :" + res);
            return res;
        } catch (Exception exception) {
            exception.printStackTrace();
            return CusutUtil.ErrorReturnJsonString(500, exception.getMessage());
        }
    }

    @PostMapping("base")
    public String base(String formUUid, HttpServletRequest request) {
        JSONObject object = new JSONObject(CusutUtil.getPostString(request));
        try {
            String res = dingUtil.saveYiDa(formUUid, object, dingConst.getUserId());
            logger.info("YiDa Return Data :" + res);
            return res;
        } catch (Exception exception) {
            exception.printStackTrace();
            return CusutUtil.ErrorReturnJsonString(500, exception.getMessage());
        }
    }


}
